/* File: _test_fortranmodule.c
 * This file is auto-generated with f2py (version:1.24.3).
 * f2py is a Fortran to Python Interface Generator (FPIG), Second Edition,
 * written by Pearu Peterson <pearu@cens.ioc.ee>.
 * Generation date: Wed Jul 12 00:00:00 2023
 * Do not edit this file directly unless you know what you are doing!!!
 */

#ifdef __cplusplus
extern "C" {
#endif

#ifndef PY_SSIZE_T_CLEAN
#define PY_SSIZE_T_CLEAN
#endif /* PY_SSIZE_T_CLEAN */

/* Unconditionally included */
#include <Python.h>
#include <numpy/npy_os.h>

/*********************** See f2py2e/cfuncs.py: includes ***********************/
#include "fortranobject.h"
#include <string.h>

/**************** See f2py2e/rules.py: mod_rules['modulebody'] ****************/
static PyObject *_test_fortran_error;
static PyObject *_test_fortran_module;

/*********************** See f2py2e/cfuncs.py: typedefs ***********************/
typedef char * string;

/****************** See f2py2e/cfuncs.py: typedefs_generated ******************/
/*need_typedefs_generated*/

/********************** See f2py2e/cfuncs.py: cppmacros **********************/
\
#define FAILNULL(p) do {                                            \
    if ((p) == NULL) {                                              \
        PyErr_SetString(PyExc_MemoryError, "NULL pointer found");   \
        goto capi_fail;                                             \
    }                                                               \
} while (0)

#define STRINGMALLOC(str,len)\
    if ((str = (string)malloc(len+1)) == NULL) {\
        PyErr_SetString(PyExc_MemoryError, "out of memory");\
        goto capi_fail;\
    } else {\
        (str)[len] = '\0';\
    }

#if defined(PREPEND_FORTRAN)
#if defined(NO_APPEND_FORTRAN)
#if defined(UPPERCASE_FORTRAN)
#define F_FUNC(f,F) _##F
#else
#define F_FUNC(f,F) _##f
#endif
#else
#if defined(UPPERCASE_FORTRAN)
#define F_FUNC(f,F) _##F##_
#else
#define F_FUNC(f,F) _##f##_
#endif
#endif
#else
#if defined(NO_APPEND_FORTRAN)
#if defined(UPPERCASE_FORTRAN)
#define F_FUNC(f,F) F
#else
#define F_FUNC(f,F) f
#endif
#else
#if defined(UPPERCASE_FORTRAN)
#define F_FUNC(f,F) F##_
#else
#define F_FUNC(f,F) f##_
#endif
#endif
#endif
#if defined(UNDERSCORE_G77)
#define F_FUNC_US(f,F) F_FUNC(f##_,F##_)
#else
#define F_FUNC_US(f,F) F_FUNC(f,F)
#endif

/* See fortranobject.h for definitions. The macros here are provided for BC. */
#define rank f2py_rank
#define shape f2py_shape
#define fshape f2py_shape
#define len f2py_len
#define flen f2py_flen
#define slen f2py_slen
#define size f2py_size

#define STRINGFREE(str) do {if (!(str == NULL)) free(str);} while (0)

/*
STRINGPADN replaces null values with padding values from the right.

`to` must have size of at least N bytes.

If the `to[N-1]` has null value, then replace it and all the
preceding, nulls with the given padding.

STRINGPADN(to, N, PADDING, NULLVALUE) is an inverse operation.
*/
#define STRINGPADN(to, N, NULLVALUE, PADDING)                   \
    do {                                                        \
        int _m = (N);                                           \
        char *_to = (to);                                       \
        for (_m -= 1; _m >= 0 && _to[_m] == NULLVALUE; _m--) {  \
             _to[_m] = PADDING;                                 \
        }                                                       \
    } while (0)

#ifdef DEBUGCFUNCS
#define CFUNCSMESS(mess) fprintf(stderr,"debug-capi:"mess);
#define CFUNCSMESSPY(mess,obj) CFUNCSMESS(mess) \
    PyObject_Print((PyObject *)obj,stderr,Py_PRINT_RAW);\
    fprintf(stderr,"\n");
#else
#define CFUNCSMESS(mess)
#define CFUNCSMESSPY(mess,obj)
#endif

#ifndef max
#define max(a,b) ((a > b) ? (a) : (b))
#endif
#ifndef min
#define min(a,b) ((a < b) ? (a) : (b))
#endif
#ifndef MAX
#define MAX(a,b) ((a > b) ? (a) : (b))
#endif
#ifndef MIN
#define MIN(a,b) ((a < b) ? (a) : (b))
#endif

/*
STRINGCOPYN copies N bytes.

`to` and `from` buffers must have sizes of at least N bytes.
*/
#define STRINGCOPYN(to,from,N)                                  \
    do {                                                        \
        int _m = (N);                                           \
        char *_to = (to);                                       \
        char *_from = (from);                                   \
        FAILNULL(_to); FAILNULL(_from);                         \
        (void)strncpy(_to, _from, _m);             \
    } while (0)


/************************ See f2py2e/cfuncs.py: cfuncs ************************/
static int
int_from_pyobj(int* v, PyObject *obj, const char *errmess)
{
    PyObject* tmp = NULL;

    if (PyLong_Check(obj)) {
        *v = Npy__PyLong_AsInt(obj);
        return !(*v == -1 && PyErr_Occurred());
    }

    tmp = PyNumber_Long(obj);
    if (tmp) {
        *v = Npy__PyLong_AsInt(tmp);
        Py_DECREF(tmp);
        return !(*v == -1 && PyErr_Occurred());
    }

    if (PyComplex_Check(obj)) {
        PyErr_Clear();
        tmp = PyObject_GetAttrString(obj,"real");
    }
    else if (PyBytes_Check(obj) || PyUnicode_Check(obj)) {
        /*pass*/;
    }
    else if (PySequence_Check(obj)) {
        PyErr_Clear();
        tmp = PySequence_GetItem(obj, 0);
    }

    if (tmp) {
        if (int_from_pyobj(v, tmp, errmess)) {
            Py_DECREF(tmp);
            return 1;
        }
        Py_DECREF(tmp);
    }

    {
        PyObject* err = PyErr_Occurred();
        if (err == NULL) {
            err = _test_fortran_error;
        }
        PyErr_SetString(err, errmess);
    }
    return 0;
}

/*
  Create a new string buffer `str` of at most length `len` from a
  Python string-like object `obj`.

  The string buffer has given size (len) or the size of inistr when len==-1.

  The string buffer is padded with blanks: in Fortran, trailing blanks
  are insignificant contrary to C nulls.
 */
static int
string_from_pyobj(string *str, int *len, const string inistr, PyObject *obj,
                  const char *errmess)
{
    PyObject *tmp = NULL;
    string buf = NULL;
    npy_intp n = -1;
#ifdef DEBUGCFUNCS
fprintf(stderr,"string_from_pyobj(str='%s',len=%d,inistr='%s',obj=%p)\n",
               (char*)str, *len, (char *)inistr, obj);
#endif
    if (obj == Py_None) {
        n = strlen(inistr);
        buf = inistr;
    }
    else if (PyArray_Check(obj)) {
        PyArrayObject *arr = (PyArrayObject *)obj;
        if (!ISCONTIGUOUS(arr)) {
            PyErr_SetString(PyExc_ValueError,
                            "array object is non-contiguous.");
            goto capi_fail;
        }
        n = PyArray_NBYTES(arr);
        buf = PyArray_DATA(arr);
        n = strnlen(buf, n);
    }
    else {
        if (PyBytes_Check(obj)) {
            tmp = obj;
            Py_INCREF(tmp);
        }
        else if (PyUnicode_Check(obj)) {
            tmp = PyUnicode_AsASCIIString(obj);
        }
        else {
            PyObject *tmp2;
            tmp2 = PyObject_Str(obj);
            if (tmp2) {
                tmp = PyUnicode_AsASCIIString(tmp2);
                Py_DECREF(tmp2);
            }
            else {
                tmp = NULL;
            }
        }
        if (tmp == NULL) goto capi_fail;
        n = PyBytes_GET_SIZE(tmp);
        buf = PyBytes_AS_STRING(tmp);
    }
    if (*len == -1) {
        /* TODO: change the type of `len` so that we can remove this */
        if (n > NPY_MAX_INT) {
            PyErr_SetString(PyExc_OverflowError,
                            "object too large for a 32-bit int");
            goto capi_fail;
        }
        *len = n;
    }
    else if (*len < n) {
        /* discard the last (len-n) bytes of input buf */
        n = *len;
    }
    if (n < 0 || *len < 0 || buf == NULL) {
        goto capi_fail;
    }
    STRINGMALLOC(*str, *len);  // *str is allocated with size (*len + 1)
    if (n < *len) {
        /*
          Pad fixed-width string with nulls. The caller will replace
          nulls with blanks when the corresponding argument is not
          intent(c).
        */
        memset(*str + n, '\0', *len - n);
    }
    STRINGCOPYN(*str, buf, n);
    Py_XDECREF(tmp);
    return 1;
capi_fail:
    Py_XDECREF(tmp);
    {
        PyObject* err = PyErr_Occurred();
        if (err == NULL) {
            err = _test_fortran_error;
        }
        PyErr_SetString(err, errmess);
    }
    return 0;
}


/********************* See f2py2e/cfuncs.py: userincludes *********************/
/*need_userincludes*/

/********************* See f2py2e/capi_rules.py: usercode *********************/


/* See f2py2e/rules.py */
extern void F_FUNC_US(read_unformatted_double,READ_UNFORMATTED_DOUBLE)(int*,int*,int*,double*,string,size_t);
extern void F_FUNC_US(read_unformatted_int,READ_UNFORMATTED_INT)(int*,int*,int*,int*,string,size_t);
extern void F_FUNC_US(read_unformatted_mixed,READ_UNFORMATTED_MIXED)(int*,int*,int*,double*,int*,string,size_t);
/*eof externroutines*/

/******************** See f2py2e/capi_rules.py: usercode1 ********************/


/******************* See f2py2e/cb_rules.py: buildcallback *******************/
/*need_callbacks*/

/*********************** See f2py2e/rules.py: buildapi ***********************/

/************************** read_unformatted_double **************************/
static char doc_f2py_rout__test_fortran_read_unformatted_double[] = "\
a = read_unformatted_double(m,n,k,filename)\n\nWrapper for ``read_unformatted_double``.\
\n\nParameters\n----------\n"
"m : input int\n"
"n : input int\n"
"k : input int\n"
"filename : input string(len=4096)\n"
"\nReturns\n-------\n"
"a : rank-3 array('d') with bounds (m,n,k)";
/* extern void F_FUNC_US(read_unformatted_double,READ_UNFORMATTED_DOUBLE)(int*,int*,int*,double*,string,size_t); */
static PyObject *f2py_rout__test_fortran_read_unformatted_double(const PyObject *capi_self,
                           PyObject *capi_args,
                           PyObject *capi_keywds,
                           void (*f2py_func)(int*,int*,int*,double*,string,size_t)) {
    PyObject * volatile capi_buildvalue = NULL;
    volatile int f2py_success = 1;
/*decl*/

    int m = 0;
    PyObject *m_capi = Py_None;
    int n = 0;
    PyObject *n_capi = Py_None;
    int k = 0;
    PyObject *k_capi = Py_None;
    double *a = NULL;
    npy_intp a_Dims[3] = {-1, -1, -1};
    const int a_Rank = 3;
    PyArrayObject *capi_a_as_array = NULL;
    int capi_a_intent = 0;
    string filename = NULL;
    int slen(filename);
    PyObject *filename_capi = Py_None;
    static char *capi_kwlist[] = {"m","n","k","filename",NULL};

/*routdebugenter*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_clock();
#endif
    if (!PyArg_ParseTupleAndKeywords(capi_args,capi_keywds,\
        "OOOO|:_test_fortran.read_unformatted_double",\
        capi_kwlist,&m_capi,&n_capi,&k_capi,&filename_capi))
        return NULL;
/*frompyobj*/
    /* Processing variable m */
        f2py_success = int_from_pyobj(&m,m_capi,"_test_fortran.read_unformatted_double() 1st argument (m) can't be converted to int");
    if (f2py_success) {
    /* Processing variable n */
        f2py_success = int_from_pyobj(&n,n_capi,"_test_fortran.read_unformatted_double() 2nd argument (n) can't be converted to int");
    if (f2py_success) {
    /* Processing variable k */
        f2py_success = int_from_pyobj(&k,k_capi,"_test_fortran.read_unformatted_double() 3rd argument (k) can't be converted to int");
    if (f2py_success) {
    /* Processing variable filename */
    slen(filename) = 4096;
    f2py_success = string_from_pyobj(&filename,&slen(filename),"",filename_capi,"string_from_pyobj failed in converting 4th argument`filename' of _test_fortran.read_unformatted_double to C string");
    if (f2py_success) {
        STRINGPADN(filename, slen(filename), '\0', ' ');
    /* Processing variable a */
    a_Dims[0]=m,a_Dims[1]=n,a_Dims[2]=k;
    capi_a_intent |= F2PY_INTENT_OUT|F2PY_INTENT_HIDE;
    const char * capi_errmess = "_test_fortran._test_fortran.read_unformatted_double: failed to create array from the hidden `a`";
    capi_a_as_array = ndarray_from_pyobj(  NPY_DOUBLE,1,a_Dims,a_Rank,  capi_a_intent,Py_None,capi_errmess);
    if (capi_a_as_array == NULL) {
        PyObject* capi_err = PyErr_Occurred();
        if (capi_err == NULL) {
            capi_err = _test_fortran_error;
            PyErr_SetString(capi_err, capi_errmess);
        }
    } else {
        a = (double *)(PyArray_DATA(capi_a_as_array));

/*end of frompyobj*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_call_clock();
#endif
/*callfortranroutine*/
                (*f2py_func)(&m,&n,&k,a,filename,slen(filename));
if (PyErr_Occurred())
  f2py_success = 0;
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_call_clock();
#endif
/*end of callfortranroutine*/
        if (f2py_success) {
/*pyobjfrom*/
/*end of pyobjfrom*/
        CFUNCSMESS("Building return value.\n");
        capi_buildvalue = Py_BuildValue("N",capi_a_as_array);
/*closepyobjfrom*/
/*end of closepyobjfrom*/
        } /*if (f2py_success) after callfortranroutine*/
/*cleanupfrompyobj*/
    }  /* if (capi_a_as_array == NULL) ... else of a */
    /* End of cleaning variable a */
        STRINGFREE(filename);
    }  /*if (f2py_success) of filename*/
    /* End of cleaning variable filename */
    } /*if (f2py_success) of k*/
    /* End of cleaning variable k */
    } /*if (f2py_success) of n*/
    /* End of cleaning variable n */
    } /*if (f2py_success) of m*/
    /* End of cleaning variable m */
/*end of cleanupfrompyobj*/
    if (capi_buildvalue == NULL) {
/*routdebugfailure*/
    } else {
/*routdebugleave*/
    }
    CFUNCSMESS("Freeing memory.\n");
/*freemem*/
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_clock();
#endif
    return capi_buildvalue;
}
/*********************** end of read_unformatted_double ***********************/

/**************************** read_unformatted_int ****************************/
static char doc_f2py_rout__test_fortran_read_unformatted_int[] = "\
a = read_unformatted_int(m,n,k,filename)\n\nWrapper for ``read_unformatted_int``.\
\n\nParameters\n----------\n"
"m : input int\n"
"n : input int\n"
"k : input int\n"
"filename : input string(len=4096)\n"
"\nReturns\n-------\n"
"a : rank-3 array('i') with bounds (m,n,k)";
/* extern void F_FUNC_US(read_unformatted_int,READ_UNFORMATTED_INT)(int*,int*,int*,int*,string,size_t); */
static PyObject *f2py_rout__test_fortran_read_unformatted_int(const PyObject *capi_self,
                           PyObject *capi_args,
                           PyObject *capi_keywds,
                           void (*f2py_func)(int*,int*,int*,int*,string,size_t)) {
    PyObject * volatile capi_buildvalue = NULL;
    volatile int f2py_success = 1;
/*decl*/

    int m = 0;
    PyObject *m_capi = Py_None;
    int n = 0;
    PyObject *n_capi = Py_None;
    int k = 0;
    PyObject *k_capi = Py_None;
    int *a = NULL;
    npy_intp a_Dims[3] = {-1, -1, -1};
    const int a_Rank = 3;
    PyArrayObject *capi_a_as_array = NULL;
    int capi_a_intent = 0;
    string filename = NULL;
    int slen(filename);
    PyObject *filename_capi = Py_None;
    static char *capi_kwlist[] = {"m","n","k","filename",NULL};

/*routdebugenter*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_clock();
#endif
    if (!PyArg_ParseTupleAndKeywords(capi_args,capi_keywds,\
        "OOOO|:_test_fortran.read_unformatted_int",\
        capi_kwlist,&m_capi,&n_capi,&k_capi,&filename_capi))
        return NULL;
/*frompyobj*/
    /* Processing variable m */
        f2py_success = int_from_pyobj(&m,m_capi,"_test_fortran.read_unformatted_int() 1st argument (m) can't be converted to int");
    if (f2py_success) {
    /* Processing variable n */
        f2py_success = int_from_pyobj(&n,n_capi,"_test_fortran.read_unformatted_int() 2nd argument (n) can't be converted to int");
    if (f2py_success) {
    /* Processing variable k */
        f2py_success = int_from_pyobj(&k,k_capi,"_test_fortran.read_unformatted_int() 3rd argument (k) can't be converted to int");
    if (f2py_success) {
    /* Processing variable filename */
    slen(filename) = 4096;
    f2py_success = string_from_pyobj(&filename,&slen(filename),"",filename_capi,"string_from_pyobj failed in converting 4th argument`filename' of _test_fortran.read_unformatted_int to C string");
    if (f2py_success) {
        STRINGPADN(filename, slen(filename), '\0', ' ');
    /* Processing variable a */
    a_Dims[0]=m,a_Dims[1]=n,a_Dims[2]=k;
    capi_a_intent |= F2PY_INTENT_OUT|F2PY_INTENT_HIDE;
    const char * capi_errmess = "_test_fortran._test_fortran.read_unformatted_int: failed to create array from the hidden `a`";
    capi_a_as_array = ndarray_from_pyobj(  NPY_INT,1,a_Dims,a_Rank,  capi_a_intent,Py_None,capi_errmess);
    if (capi_a_as_array == NULL) {
        PyObject* capi_err = PyErr_Occurred();
        if (capi_err == NULL) {
            capi_err = _test_fortran_error;
            PyErr_SetString(capi_err, capi_errmess);
        }
    } else {
        a = (int *)(PyArray_DATA(capi_a_as_array));

/*end of frompyobj*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_call_clock();
#endif
/*callfortranroutine*/
                (*f2py_func)(&m,&n,&k,a,filename,slen(filename));
if (PyErr_Occurred())
  f2py_success = 0;
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_call_clock();
#endif
/*end of callfortranroutine*/
        if (f2py_success) {
/*pyobjfrom*/
/*end of pyobjfrom*/
        CFUNCSMESS("Building return value.\n");
        capi_buildvalue = Py_BuildValue("N",capi_a_as_array);
/*closepyobjfrom*/
/*end of closepyobjfrom*/
        } /*if (f2py_success) after callfortranroutine*/
/*cleanupfrompyobj*/
    }  /* if (capi_a_as_array == NULL) ... else of a */
    /* End of cleaning variable a */
        STRINGFREE(filename);
    }  /*if (f2py_success) of filename*/
    /* End of cleaning variable filename */
    } /*if (f2py_success) of k*/
    /* End of cleaning variable k */
    } /*if (f2py_success) of n*/
    /* End of cleaning variable n */
    } /*if (f2py_success) of m*/
    /* End of cleaning variable m */
/*end of cleanupfrompyobj*/
    if (capi_buildvalue == NULL) {
/*routdebugfailure*/
    } else {
/*routdebugleave*/
    }
    CFUNCSMESS("Freeing memory.\n");
/*freemem*/
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_clock();
#endif
    return capi_buildvalue;
}
/************************ end of read_unformatted_int ************************/

/*************************** read_unformatted_mixed ***************************/
static char doc_f2py_rout__test_fortran_read_unformatted_mixed[] = "\
a,b = read_unformatted_mixed(m,n,k,filename)\n\nWrapper for ``read_unformatted_mixed``.\
\n\nParameters\n----------\n"
"m : input int\n"
"n : input int\n"
"k : input int\n"
"filename : input string(len=4096)\n"
"\nReturns\n-------\n"
"a : rank-2 array('d') with bounds (m,n)\n"
"b : rank-1 array('i') with bounds (k)";
/* extern void F_FUNC_US(read_unformatted_mixed,READ_UNFORMATTED_MIXED)(int*,int*,int*,double*,int*,string,size_t); */
static PyObject *f2py_rout__test_fortran_read_unformatted_mixed(const PyObject *capi_self,
                           PyObject *capi_args,
                           PyObject *capi_keywds,
                           void (*f2py_func)(int*,int*,int*,double*,int*,string,size_t)) {
    PyObject * volatile capi_buildvalue = NULL;
    volatile int f2py_success = 1;
/*decl*/

    int m = 0;
    PyObject *m_capi = Py_None;
    int n = 0;
    PyObject *n_capi = Py_None;
    int k = 0;
    PyObject *k_capi = Py_None;
    double *a = NULL;
    npy_intp a_Dims[2] = {-1, -1};
    const int a_Rank = 2;
    PyArrayObject *capi_a_as_array = NULL;
    int capi_a_intent = 0;
    int *b = NULL;
    npy_intp b_Dims[1] = {-1};
    const int b_Rank = 1;
    PyArrayObject *capi_b_as_array = NULL;
    int capi_b_intent = 0;
    string filename = NULL;
    int slen(filename);
    PyObject *filename_capi = Py_None;
    static char *capi_kwlist[] = {"m","n","k","filename",NULL};

/*routdebugenter*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_clock();
#endif
    if (!PyArg_ParseTupleAndKeywords(capi_args,capi_keywds,\
        "OOOO|:_test_fortran.read_unformatted_mixed",\
        capi_kwlist,&m_capi,&n_capi,&k_capi,&filename_capi))
        return NULL;
/*frompyobj*/
    /* Processing variable m */
        f2py_success = int_from_pyobj(&m,m_capi,"_test_fortran.read_unformatted_mixed() 1st argument (m) can't be converted to int");
    if (f2py_success) {
    /* Processing variable n */
        f2py_success = int_from_pyobj(&n,n_capi,"_test_fortran.read_unformatted_mixed() 2nd argument (n) can't be converted to int");
    if (f2py_success) {
    /* Processing variable k */
        f2py_success = int_from_pyobj(&k,k_capi,"_test_fortran.read_unformatted_mixed() 3rd argument (k) can't be converted to int");
    if (f2py_success) {
    /* Processing variable filename */
    slen(filename) = 4096;
    f2py_success = string_from_pyobj(&filename,&slen(filename),"",filename_capi,"string_from_pyobj failed in converting 4th argument`filename' of _test_fortran.read_unformatted_mixed to C string");
    if (f2py_success) {
        STRINGPADN(filename, slen(filename), '\0', ' ');
    /* Processing variable a */
    a_Dims[0]=m,a_Dims[1]=n;
    capi_a_intent |= F2PY_INTENT_OUT|F2PY_INTENT_HIDE;
    const char * capi_errmess = "_test_fortran._test_fortran.read_unformatted_mixed: failed to create array from the hidden `a`";
    capi_a_as_array = ndarray_from_pyobj(  NPY_DOUBLE,1,a_Dims,a_Rank,  capi_a_intent,Py_None,capi_errmess);
    if (capi_a_as_array == NULL) {
        PyObject* capi_err = PyErr_Occurred();
        if (capi_err == NULL) {
            capi_err = _test_fortran_error;
            PyErr_SetString(capi_err, capi_errmess);
        }
    } else {
        a = (double *)(PyArray_DATA(capi_a_as_array));

    /* Processing variable b */
    b_Dims[0]=k;
    capi_b_intent |= F2PY_INTENT_OUT|F2PY_INTENT_HIDE;
    const char * capi_errmess = "_test_fortran._test_fortran.read_unformatted_mixed: failed to create array from the hidden `b`";
    capi_b_as_array = ndarray_from_pyobj(  NPY_INT,1,b_Dims,b_Rank,  capi_b_intent,Py_None,capi_errmess);
    if (capi_b_as_array == NULL) {
        PyObject* capi_err = PyErr_Occurred();
        if (capi_err == NULL) {
            capi_err = _test_fortran_error;
            PyErr_SetString(capi_err, capi_errmess);
        }
    } else {
        b = (int *)(PyArray_DATA(capi_b_as_array));

/*end of frompyobj*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_call_clock();
#endif
/*callfortranroutine*/
                (*f2py_func)(&m,&n,&k,a,b,filename,slen(filename));
if (PyErr_Occurred())
  f2py_success = 0;
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_call_clock();
#endif
/*end of callfortranroutine*/
        if (f2py_success) {
/*pyobjfrom*/
/*end of pyobjfrom*/
        CFUNCSMESS("Building return value.\n");
        capi_buildvalue = Py_BuildValue("NN",capi_a_as_array,capi_b_as_array);
/*closepyobjfrom*/
/*end of closepyobjfrom*/
        } /*if (f2py_success) after callfortranroutine*/
/*cleanupfrompyobj*/
    }  /* if (capi_b_as_array == NULL) ... else of b */
    /* End of cleaning variable b */
    }  /* if (capi_a_as_array == NULL) ... else of a */
    /* End of cleaning variable a */
        STRINGFREE(filename);
    }  /*if (f2py_success) of filename*/
    /* End of cleaning variable filename */
    } /*if (f2py_success) of k*/
    /* End of cleaning variable k */
    } /*if (f2py_success) of n*/
    /* End of cleaning variable n */
    } /*if (f2py_success) of m*/
    /* End of cleaning variable m */
/*end of cleanupfrompyobj*/
    if (capi_buildvalue == NULL) {
/*routdebugfailure*/
    } else {
/*routdebugleave*/
    }
    CFUNCSMESS("Freeing memory.\n");
/*freemem*/
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_clock();
#endif
    return capi_buildvalue;
}
/*********************** end of read_unformatted_mixed ***********************/
/*eof body*/

/******************* See f2py2e/f90mod_rules.py: buildhooks *******************/
/*need_f90modhooks*/

/************** See f2py2e/rules.py: module_rules['modulebody'] **************/

/******************* See f2py2e/common_rules.py: buildhooks *******************/

/*need_commonhooks*/

/**************************** See f2py2e/rules.py ****************************/

static FortranDataDef f2py_routine_defs[] = {
    {"read_unformatted_double",-1,{{-1}},0,0,(char *)  F_FUNC_US(read_unformatted_double,READ_UNFORMATTED_DOUBLE),  (f2py_init_func)f2py_rout__test_fortran_read_unformatted_double,doc_f2py_rout__test_fortran_read_unformatted_double},
    {"read_unformatted_int",-1,{{-1}},0,0,(char *)  F_FUNC_US(read_unformatted_int,READ_UNFORMATTED_INT),  (f2py_init_func)f2py_rout__test_fortran_read_unformatted_int,doc_f2py_rout__test_fortran_read_unformatted_int},
    {"read_unformatted_mixed",-1,{{-1}},0,0,(char *)  F_FUNC_US(read_unformatted_mixed,READ_UNFORMATTED_MIXED),  (f2py_init_func)f2py_rout__test_fortran_read_unformatted_mixed,doc_f2py_rout__test_fortran_read_unformatted_mixed},

/*eof routine_defs*/
    {NULL}
};

static PyMethodDef f2py_module_methods[] = {

    {NULL,NULL}
};

static struct PyModuleDef moduledef = {
    PyModuleDef_HEAD_INIT,
    "_test_fortran",
    NULL,
    -1,
    f2py_module_methods,
    NULL,
    NULL,
    NULL,
    NULL
};

PyMODINIT_FUNC PyInit__test_fortran(void) {
    int i;
    PyObject *m,*d, *s, *tmp;
    m = _test_fortran_module = PyModule_Create(&moduledef);
    Py_SET_TYPE(&PyFortran_Type, &PyType_Type);
    import_array();
    if (PyErr_Occurred())
        {PyErr_SetString(PyExc_ImportError, "can't initialize module _test_fortran (failed to import numpy)"); return m;}
    d = PyModule_GetDict(m);
    s = PyUnicode_FromString("1.24.3");
    PyDict_SetItemString(d, "__version__", s);
    Py_DECREF(s);
    s = PyUnicode_FromString(
        "This module '_test_fortran' is auto-generated with f2py (version:1.24.3).\nFunctions:\n"
"    a = read_unformatted_double(m,n,k,filename)\n"
"    a = read_unformatted_int(m,n,k,filename)\n"
"    a,b = read_unformatted_mixed(m,n,k,filename)\n"
".");
    PyDict_SetItemString(d, "__doc__", s);
    Py_DECREF(s);
    s = PyUnicode_FromString("1.24.3");
    PyDict_SetItemString(d, "__f2py_numpy_version__", s);
    Py_DECREF(s);
    _test_fortran_error = PyErr_NewException ("_test_fortran.error", NULL, NULL);
    /*
     * Store the error object inside the dict, so that it could get deallocated.
     * (in practice, this is a module, so it likely will not and cannot.)
     */
    PyDict_SetItemString(d, "__test_fortran_error", _test_fortran_error);
    Py_DECREF(_test_fortran_error);
    for(i=0;f2py_routine_defs[i].name!=NULL;i++) {
        tmp = PyFortranObject_NewAsAttr(&f2py_routine_defs[i]);
        PyDict_SetItemString(d, f2py_routine_defs[i].name, tmp);
        Py_DECREF(tmp);
    }



/*eof initf2pywraphooks*/
/*eof initf90modhooks*/

/*eof initcommonhooks*/


#ifdef F2PY_REPORT_ATEXIT
    if (! PyErr_Occurred())
        on_exit(f2py_report_on_exit,(void*)"_test_fortran");
#endif
    return m;
}
#ifdef __cplusplus
}
#endif
