/* File: _arpackmodule.c
 * This file is auto-generated with f2py (version:1.24.3).
 * f2py is a Fortran to Python Interface Generator (FPIG), Second Edition,
 * written by Pearu Peterson <pearu@cens.ioc.ee>.
 * Generation date: Wed Jul 12 00:00:00 2023
 * Do not edit this file directly unless you know what you are doing!!!
 */

#ifdef __cplusplus
extern "C" {
#endif

#ifndef PY_SSIZE_T_CLEAN
#define PY_SSIZE_T_CLEAN
#endif /* PY_SSIZE_T_CLEAN */

/* Unconditionally included */
#include <Python.h>
#include <numpy/npy_os.h>

/*********************** See f2py2e/cfuncs.py: includes ***********************/
#include "fortranobject.h"
#include <string.h>
#include <math.h>

/**************** See f2py2e/rules.py: mod_rules['modulebody'] ****************/
static PyObject *_arpack_error;
static PyObject *_arpack_module;

/*********************** See f2py2e/cfuncs.py: typedefs ***********************/
typedef char * string;
typedef char character;
typedef struct {float r,i;} complex_float;
typedef struct {double r,i;} complex_double;

/****************** See f2py2e/cfuncs.py: typedefs_generated ******************/
/*need_typedefs_generated*/

/********************** See f2py2e/cfuncs.py: cppmacros **********************/
\
#define FAILNULL(p) do {                                            \
    if ((p) == NULL) {                                              \
        PyErr_SetString(PyExc_MemoryError, "NULL pointer found");   \
        goto capi_fail;                                             \
    }                                                               \
} while (0)

#define STRINGMALLOC(str,len)\
    if ((str = (string)malloc(len+1)) == NULL) {\
        PyErr_SetString(PyExc_MemoryError, "out of memory");\
        goto capi_fail;\
    } else {\
        (str)[len] = '\0';\
    }

#if defined(PREPEND_FORTRAN)
#if defined(NO_APPEND_FORTRAN)
#if defined(UPPERCASE_FORTRAN)
#define F_FUNC(f,F) _##F
#else
#define F_FUNC(f,F) _##f
#endif
#else
#if defined(UPPERCASE_FORTRAN)
#define F_FUNC(f,F) _##F##_
#else
#define F_FUNC(f,F) _##f##_
#endif
#endif
#else
#if defined(NO_APPEND_FORTRAN)
#if defined(UPPERCASE_FORTRAN)
#define F_FUNC(f,F) F
#else
#define F_FUNC(f,F) f
#endif
#else
#if defined(UPPERCASE_FORTRAN)
#define F_FUNC(f,F) F##_
#else
#define F_FUNC(f,F) f##_
#endif
#endif
#endif
#if defined(UNDERSCORE_G77)
#define F_FUNC_US(f,F) F_FUNC(f##_,F##_)
#else
#define F_FUNC_US(f,F) F_FUNC(f,F)
#endif

/* See fortranobject.h for definitions. The macros here are provided for BC. */
#define rank f2py_rank
#define shape f2py_shape
#define fshape f2py_shape
#define len f2py_len
#define flen f2py_flen
#define slen f2py_slen
#define size f2py_size

#define STRINGFREE(str) do {if (!(str == NULL)) free(str);} while (0)

/*
STRINGPADN replaces null values with padding values from the right.

`to` must have size of at least N bytes.

If the `to[N-1]` has null value, then replace it and all the
preceding, nulls with the given padding.

STRINGPADN(to, N, PADDING, NULLVALUE) is an inverse operation.
*/
#define STRINGPADN(to, N, NULLVALUE, PADDING)                   \
    do {                                                        \
        int _m = (N);                                           \
        char *_to = (to);                                       \
        for (_m -= 1; _m >= 0 && _to[_m] == NULLVALUE; _m--) {  \
             _to[_m] = PADDING;                                 \
        }                                                       \
    } while (0)

#define CHECKSCALAR(check,tcheck,name,show,var)\
    if (!(check)) {\
        char errstring[256];\
        sprintf(errstring, "%s: "show, "("tcheck") failed for "name, var);\
        PyErr_SetString(_arpack_error,errstring);\
        /*goto capi_fail;*/\
    } else 
#ifdef DEBUGCFUNCS
#define CFUNCSMESS(mess) fprintf(stderr,"debug-capi:"mess);
#define CFUNCSMESSPY(mess,obj) CFUNCSMESS(mess) \
    PyObject_Print((PyObject *)obj,stderr,Py_PRINT_RAW);\
    fprintf(stderr,"\n");
#else
#define CFUNCSMESS(mess)
#define CFUNCSMESSPY(mess,obj)
#endif

#ifndef max
#define max(a,b) ((a > b) ? (a) : (b))
#endif
#ifndef min
#define min(a,b) ((a < b) ? (a) : (b))
#endif
#ifndef MAX
#define MAX(a,b) ((a > b) ? (a) : (b))
#endif
#ifndef MIN
#define MIN(a,b) ((a < b) ? (a) : (b))
#endif

#define pyobj_from_complex_float1(v) (PyComplex_FromDoubles(v.r,v.i))
#define pyobj_from_complex_double1(v) (PyComplex_FromDoubles(v.r,v.i))
/*
STRINGCOPYN copies N bytes.

`to` and `from` buffers must have sizes of at least N bytes.
*/
#define STRINGCOPYN(to,from,N)                                  \
    do {                                                        \
        int _m = (N);                                           \
        char *_to = (to);                                       \
        char *_from = (from);                                   \
        FAILNULL(_to); FAILNULL(_from);                         \
        (void)strncpy(_to, _from, _m);             \
    } while (0)


/************************ See f2py2e/cfuncs.py: cfuncs ************************/
static int
complex_double_from_pyobj(complex_double* v, PyObject *obj, const char *errmess) {
    Py_complex c;
    if (PyComplex_Check(obj)) {
        c = PyComplex_AsCComplex(obj);
        (*v).r = c.real;
        (*v).i = c.imag;
        return 1;
    }
    if (PyArray_IsScalar(obj, ComplexFloating)) {
        if (PyArray_IsScalar(obj, CFloat)) {
            npy_cfloat new;
            PyArray_ScalarAsCtype(obj, &new);
            (*v).r = (double)new.real;
            (*v).i = (double)new.imag;
        }
        else if (PyArray_IsScalar(obj, CLongDouble)) {
            npy_clongdouble new;
            PyArray_ScalarAsCtype(obj, &new);
            (*v).r = (double)new.real;
            (*v).i = (double)new.imag;
        }
        else { /* if (PyArray_IsScalar(obj, CDouble)) */
            PyArray_ScalarAsCtype(obj, v);
        }
        return 1;
    }
    if (PyArray_CheckScalar(obj)) { /* 0-dim array or still array scalar */
        PyArrayObject *arr;
        if (PyArray_Check(obj)) {
            arr = (PyArrayObject *)PyArray_Cast((PyArrayObject *)obj, NPY_CDOUBLE);
        }
        else {
            arr = (PyArrayObject *)PyArray_FromScalar(obj, PyArray_DescrFromType(NPY_CDOUBLE));
        }
        if (arr == NULL) {
            return 0;
        }
        (*v).r = ((npy_cdouble *)PyArray_DATA(arr))->real;
        (*v).i = ((npy_cdouble *)PyArray_DATA(arr))->imag;
        Py_DECREF(arr);
        return 1;
    }
    /* Python does not provide PyNumber_Complex function :-( */
    (*v).i = 0.0;
    if (PyFloat_Check(obj)) {
        (*v).r = PyFloat_AsDouble(obj);
        return !((*v).r == -1.0 && PyErr_Occurred());
    }
    if (PyLong_Check(obj)) {
        (*v).r = PyLong_AsDouble(obj);
        return !((*v).r == -1.0 && PyErr_Occurred());
    }
    if (PySequence_Check(obj) && !(PyBytes_Check(obj) || PyUnicode_Check(obj))) {
        PyObject *tmp = PySequence_GetItem(obj,0);
        if (tmp) {
            if (complex_double_from_pyobj(v,tmp,errmess)) {
                Py_DECREF(tmp);
                return 1;
            }
            Py_DECREF(tmp);
        }
    }
    {
        PyObject* err = PyErr_Occurred();
        if (err==NULL)
            err = PyExc_TypeError;
        PyErr_SetString(err,errmess);
    }
    return 0;
}

static int
double_from_pyobj(double* v, PyObject *obj, const char *errmess)
{
    PyObject* tmp = NULL;
    if (PyFloat_Check(obj)) {
        *v = PyFloat_AsDouble(obj);
        return !(*v == -1.0 && PyErr_Occurred());
    }

    tmp = PyNumber_Float(obj);
    if (tmp) {
        *v = PyFloat_AsDouble(tmp);
        Py_DECREF(tmp);
        return !(*v == -1.0 && PyErr_Occurred());
    }

    if (PyComplex_Check(obj)) {
        PyErr_Clear();
        tmp = PyObject_GetAttrString(obj,"real");
    }
    else if (PyBytes_Check(obj) || PyUnicode_Check(obj)) {
        /*pass*/;
    }
    else if (PySequence_Check(obj)) {
        PyErr_Clear();
        tmp = PySequence_GetItem(obj, 0);
    }

    if (tmp) {
        if (double_from_pyobj(v,tmp,errmess)) {Py_DECREF(tmp); return 1;}
        Py_DECREF(tmp);
    }
    {
        PyObject* err = PyErr_Occurred();
        if (err==NULL) err = _arpack_error;
        PyErr_SetString(err,errmess);
    }
    return 0;
}

static int
int_from_pyobj(int* v, PyObject *obj, const char *errmess)
{
    PyObject* tmp = NULL;

    if (PyLong_Check(obj)) {
        *v = Npy__PyLong_AsInt(obj);
        return !(*v == -1 && PyErr_Occurred());
    }

    tmp = PyNumber_Long(obj);
    if (tmp) {
        *v = Npy__PyLong_AsInt(tmp);
        Py_DECREF(tmp);
        return !(*v == -1 && PyErr_Occurred());
    }

    if (PyComplex_Check(obj)) {
        PyErr_Clear();
        tmp = PyObject_GetAttrString(obj,"real");
    }
    else if (PyBytes_Check(obj) || PyUnicode_Check(obj)) {
        /*pass*/;
    }
    else if (PySequence_Check(obj)) {
        PyErr_Clear();
        tmp = PySequence_GetItem(obj, 0);
    }

    if (tmp) {
        if (int_from_pyobj(v, tmp, errmess)) {
            Py_DECREF(tmp);
            return 1;
        }
        Py_DECREF(tmp);
    }

    {
        PyObject* err = PyErr_Occurred();
        if (err == NULL) {
            err = _arpack_error;
        }
        PyErr_SetString(err, errmess);
    }
    return 0;
}

/*
  Create a new string buffer `str` of at most length `len` from a
  Python string-like object `obj`.

  The string buffer has given size (len) or the size of inistr when len==-1.

  The string buffer is padded with blanks: in Fortran, trailing blanks
  are insignificant contrary to C nulls.
 */
static int
string_from_pyobj(string *str, int *len, const string inistr, PyObject *obj,
                  const char *errmess)
{
    PyObject *tmp = NULL;
    string buf = NULL;
    npy_intp n = -1;
#ifdef DEBUGCFUNCS
fprintf(stderr,"string_from_pyobj(str='%s',len=%d,inistr='%s',obj=%p)\n",
               (char*)str, *len, (char *)inistr, obj);
#endif
    if (obj == Py_None) {
        n = strlen(inistr);
        buf = inistr;
    }
    else if (PyArray_Check(obj)) {
        PyArrayObject *arr = (PyArrayObject *)obj;
        if (!ISCONTIGUOUS(arr)) {
            PyErr_SetString(PyExc_ValueError,
                            "array object is non-contiguous.");
            goto capi_fail;
        }
        n = PyArray_NBYTES(arr);
        buf = PyArray_DATA(arr);
        n = strnlen(buf, n);
    }
    else {
        if (PyBytes_Check(obj)) {
            tmp = obj;
            Py_INCREF(tmp);
        }
        else if (PyUnicode_Check(obj)) {
            tmp = PyUnicode_AsASCIIString(obj);
        }
        else {
            PyObject *tmp2;
            tmp2 = PyObject_Str(obj);
            if (tmp2) {
                tmp = PyUnicode_AsASCIIString(tmp2);
                Py_DECREF(tmp2);
            }
            else {
                tmp = NULL;
            }
        }
        if (tmp == NULL) goto capi_fail;
        n = PyBytes_GET_SIZE(tmp);
        buf = PyBytes_AS_STRING(tmp);
    }
    if (*len == -1) {
        /* TODO: change the type of `len` so that we can remove this */
        if (n > NPY_MAX_INT) {
            PyErr_SetString(PyExc_OverflowError,
                            "object too large for a 32-bit int");
            goto capi_fail;
        }
        *len = n;
    }
    else if (*len < n) {
        /* discard the last (len-n) bytes of input buf */
        n = *len;
    }
    if (n < 0 || *len < 0 || buf == NULL) {
        goto capi_fail;
    }
    STRINGMALLOC(*str, *len);  // *str is allocated with size (*len + 1)
    if (n < *len) {
        /*
          Pad fixed-width string with nulls. The caller will replace
          nulls with blanks when the corresponding argument is not
          intent(c).
        */
        memset(*str + n, '\0', *len - n);
    }
    STRINGCOPYN(*str, buf, n);
    Py_XDECREF(tmp);
    return 1;
capi_fail:
    Py_XDECREF(tmp);
    {
        PyObject* err = PyErr_Occurred();
        if (err == NULL) {
            err = _arpack_error;
        }
        PyErr_SetString(err, errmess);
    }
    return 0;
}

static int
float_from_pyobj(float* v, PyObject *obj, const char *errmess)
{
    double d=0.0;
    if (double_from_pyobj(&d,obj,errmess)) {
        *v = (float)d;
        return 1;
    }
    return 0;
}

static int
character_from_pyobj(character* v, PyObject *obj, const char *errmess) {
    if (PyBytes_Check(obj)) {
        /* empty bytes has trailing null, so dereferencing is always safe */
        *v = PyBytes_AS_STRING(obj)[0];
        return 1;
    } else if (PyUnicode_Check(obj)) {
        PyObject* tmp = PyUnicode_AsASCIIString(obj);
        if (tmp != NULL) {
            *v = PyBytes_AS_STRING(tmp)[0];
            Py_DECREF(tmp);
            return 1;
        }
    } else if (PyArray_Check(obj)) {
        PyArrayObject* arr = (PyArrayObject*)obj;
        if (F2PY_ARRAY_IS_CHARACTER_COMPATIBLE(arr)) {
            *v = PyArray_BYTES(arr)[0];
            return 1;
        } else if (F2PY_IS_UNICODE_ARRAY(arr)) {
            // TODO: update when numpy will support 1-byte and
            // 2-byte unicode dtypes
            PyObject* tmp = PyUnicode_FromKindAndData(
                              PyUnicode_4BYTE_KIND,
                              PyArray_BYTES(arr),
                              (PyArray_NBYTES(arr)>0?1:0));
            if (tmp != NULL) {
                if (character_from_pyobj(v, tmp, errmess)) {
                    Py_DECREF(tmp);
                    return 1;
                }
                Py_DECREF(tmp);
            }
        }
    } else if (PySequence_Check(obj)) {
        PyObject* tmp = PySequence_GetItem(obj,0);
        if (tmp != NULL) {
            if (character_from_pyobj(v, tmp, errmess)) {
                Py_DECREF(tmp);
                return 1;
            }
            Py_DECREF(tmp);
        }
    }
    {
        char mess[F2PY_MESSAGE_BUFFER_SIZE];
        strcpy(mess, errmess);
        PyObject* err = PyErr_Occurred();
        if (err == NULL) {
            err = PyExc_TypeError;
        }
        sprintf(mess + strlen(mess),
                " -- expected str|bytes|sequence-of-str-or-bytes, got ");
        f2py_describe(obj, mess + strlen(mess));
        PyErr_SetString(err, mess);
    }
    return 0;
}

static int
complex_float_from_pyobj(complex_float* v,PyObject *obj,const char *errmess)
{
    complex_double cd={0.0,0.0};
    if (complex_double_from_pyobj(&cd,obj,errmess)) {
        (*v).r = (float)cd.r;
        (*v).i = (float)cd.i;
        return 1;
    }
    return 0;
}


/********************* See f2py2e/cfuncs.py: userincludes *********************/
/*need_userincludes*/

/********************* See f2py2e/capi_rules.py: usercode *********************/


/* See f2py2e/rules.py */
extern void F_FUNC(ssaupd,SSAUPD)(int*,string,int*,string,int*,float*,float*,int*,float*,int*,int*,int*,float*,float*,int*,int*,size_t,size_t);
extern void F_FUNC(dsaupd,DSAUPD)(int*,string,int*,string,int*,double*,double*,int*,double*,int*,int*,int*,double*,double*,int*,int*,size_t,size_t);
extern void F_FUNC(sseupd,SSEUPD)(int*,character*,int*,float*,float*,int*,float*,character*,int*,string,int*,float*,float*,int*,float*,int*,int*,int*,float*,float*,int*,int*,size_t);
extern void F_FUNC(dseupd,DSEUPD)(int*,character*,int*,double*,double*,int*,double*,character*,int*,string,int*,double*,double*,int*,double*,int*,int*,int*,double*,double*,int*,int*,size_t);
extern void F_FUNC(snaupd,SNAUPD)(int*,string,int*,string,int*,float*,float*,int*,float*,int*,int*,int*,float*,float*,int*,int*,size_t,size_t);
extern void F_FUNC(dnaupd,DNAUPD)(int*,string,int*,string,int*,double*,double*,int*,double*,int*,int*,int*,double*,double*,int*,int*,size_t,size_t);
extern void F_FUNC(sneupd,SNEUPD)(int*,character*,int*,float*,float*,float*,int*,float*,float*,float*,character*,int*,string,int*,float*,float*,int*,float*,int*,int*,int*,float*,float*,int*,int*,size_t);
extern void F_FUNC(dneupd,DNEUPD)(int*,character*,int*,double*,double*,double*,int*,double*,double*,double*,character*,int*,string,int*,double*,double*,int*,double*,int*,int*,int*,double*,double*,int*,int*,size_t);
extern void F_FUNC(cnaupd,CNAUPD)(int*,string,int*,string,int*,float*,complex_float*,int*,complex_float*,int*,int*,int*,complex_float*,complex_float*,int*,float*,int*,size_t,size_t);
extern void F_FUNC(znaupd,ZNAUPD)(int*,string,int*,string,int*,double*,complex_double*,int*,complex_double*,int*,int*,int*,complex_double*,complex_double*,int*,double*,int*,size_t,size_t);
extern void F_FUNC(cneupd,CNEUPD)(int*,character*,int*,complex_float*,complex_float*,int*,complex_float*,complex_float*,character*,int*,string,int*,float*,complex_float*,int*,complex_float*,int*,int*,int*,complex_float*,complex_float*,int*,float*,int*,size_t);
extern void F_FUNC(zneupd,ZNEUPD)(int*,character*,int*,complex_double*,complex_double*,int*,complex_double*,complex_double*,character*,int*,string,int*,double*,complex_double*,int*,complex_double*,int*,int*,int*,complex_double*,complex_double*,int*,double*,int*,size_t);
/*eof externroutines*/

/******************** See f2py2e/capi_rules.py: usercode1 ********************/


/******************* See f2py2e/cb_rules.py: buildcallback *******************/
/*need_callbacks*/

/*********************** See f2py2e/rules.py: buildapi ***********************/

/*********************************** ssaupd ***********************************/
static char doc_f2py_rout__arpack_ssaupd[] = "\
ido,tol,resid,v,iparam,ipntr,info = ssaupd(ido,bmat,which,nev,tol,resid,v,iparam,ipntr,workd,workl,info,[n,ncv,ldv,lworkl])\n\nWrapper for ``ssaupd``.\
\n\nParameters\n----------\n"
"ido : input int\n"
"bmat : input string(len=1)\n"
"which : input string(len=2)\n"
"nev : input int\n"
"tol : input float\n"
"resid : input rank-1 array('f') with bounds (n)\n"
"v : input rank-2 array('f') with bounds (ldv,ncv)\n"
"iparam : input rank-1 array('i') with bounds (11)\n"
"ipntr : input rank-1 array('i') with bounds (11)\n"
"workd : in/output rank-1 array('f') with bounds (3 * n)\n"
"workl : in/output rank-1 array('f') with bounds (lworkl)\n"
"info : input int\n"
"\nOther Parameters\n----------------\n"
"n : input int, optional\n    Default: len(resid)\n"
"ncv : input int, optional\n    Default: shape(v,1)\n"
"ldv : input int, optional\n    Default: shape(v,0)\n"
"lworkl : input int, optional\n    Default: len(workl)\n"
"\nReturns\n-------\n"
"ido : int\n"
"tol : float\n"
"resid : rank-1 array('f') with bounds (n)\n"
"v : rank-2 array('f') with bounds (ldv,ncv)\n"
"iparam : rank-1 array('i') with bounds (11)\n"
"ipntr : rank-1 array('i') with bounds (11)\n"
"info : int";
/* extern void F_FUNC(ssaupd,SSAUPD)(int*,string,int*,string,int*,float*,float*,int*,float*,int*,int*,int*,float*,float*,int*,int*,size_t,size_t); */
static PyObject *f2py_rout__arpack_ssaupd(const PyObject *capi_self,
                           PyObject *capi_args,
                           PyObject *capi_keywds,
                           void (*f2py_func)(int*,string,int*,string,int*,float*,float*,int*,float*,int*,int*,int*,float*,float*,int*,int*,size_t,size_t)) {
    PyObject * volatile capi_buildvalue = NULL;
    volatile int f2py_success = 1;
/*decl*/

    int ido = 0;
    PyObject *ido_capi = Py_None;
    string bmat = NULL;
    int slen(bmat);
    PyObject *bmat_capi = Py_None;
    int n = 0;
    PyObject *n_capi = Py_None;
    string which = NULL;
    int slen(which);
    PyObject *which_capi = Py_None;
    int nev = 0;
    PyObject *nev_capi = Py_None;
    float tol = 0;
    PyObject *tol_capi = Py_None;
    float *resid = NULL;
    npy_intp resid_Dims[1] = {-1};
    const int resid_Rank = 1;
    PyArrayObject *capi_resid_as_array = NULL;
    int capi_resid_intent = 0;
    PyObject *resid_capi = Py_None;
    int ncv = 0;
    PyObject *ncv_capi = Py_None;
    float *v = NULL;
    npy_intp v_Dims[2] = {-1, -1};
    const int v_Rank = 2;
    PyArrayObject *capi_v_as_array = NULL;
    int capi_v_intent = 0;
    PyObject *v_capi = Py_None;
    int ldv = 0;
    PyObject *ldv_capi = Py_None;
    int *iparam = NULL;
    npy_intp iparam_Dims[1] = {-1};
    const int iparam_Rank = 1;
    PyArrayObject *capi_iparam_as_array = NULL;
    int capi_iparam_intent = 0;
    PyObject *iparam_capi = Py_None;
    int *ipntr = NULL;
    npy_intp ipntr_Dims[1] = {-1};
    const int ipntr_Rank = 1;
    PyArrayObject *capi_ipntr_as_array = NULL;
    int capi_ipntr_intent = 0;
    PyObject *ipntr_capi = Py_None;
    float *workd = NULL;
    npy_intp workd_Dims[1] = {-1};
    const int workd_Rank = 1;
    PyArrayObject *capi_workd_as_array = NULL;
    int capi_workd_intent = 0;
    PyObject *workd_capi = Py_None;
    float *workl = NULL;
    npy_intp workl_Dims[1] = {-1};
    const int workl_Rank = 1;
    PyArrayObject *capi_workl_as_array = NULL;
    int capi_workl_intent = 0;
    PyObject *workl_capi = Py_None;
    int lworkl = 0;
    PyObject *lworkl_capi = Py_None;
    int info = 0;
    PyObject *info_capi = Py_None;
    static char *capi_kwlist[] = {"ido","bmat","which","nev","tol","resid","v","iparam","ipntr","workd","workl","info","n","ncv","ldv","lworkl",NULL};

/*routdebugenter*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_clock();
#endif
    if (!PyArg_ParseTupleAndKeywords(capi_args,capi_keywds,\
        "OOOOOOOOOOOO|OOOO:_arpack.ssaupd",\
        capi_kwlist,&ido_capi,&bmat_capi,&which_capi,&nev_capi,&tol_capi,&resid_capi,&v_capi,&iparam_capi,&ipntr_capi,&workd_capi,&workl_capi,&info_capi,&n_capi,&ncv_capi,&ldv_capi,&lworkl_capi))
        return NULL;
/*frompyobj*/
    /* Processing variable ido */
        f2py_success = int_from_pyobj(&ido,ido_capi,"_arpack.ssaupd() 1st argument (ido) can't be converted to int");
    if (f2py_success) {
    /* Processing variable bmat */
    slen(bmat) = 1;
    f2py_success = string_from_pyobj(&bmat,&slen(bmat),"",bmat_capi,"string_from_pyobj failed in converting 2nd argument`bmat' of _arpack.ssaupd to C string");
    if (f2py_success) {
        STRINGPADN(bmat, slen(bmat), '\0', ' ');
    /* Processing variable which */
    slen(which) = 2;
    f2py_success = string_from_pyobj(&which,&slen(which),"",which_capi,"string_from_pyobj failed in converting 3rd argument`which' of _arpack.ssaupd to C string");
    if (f2py_success) {
        STRINGPADN(which, slen(which), '\0', ' ');
    /* Processing variable nev */
        f2py_success = int_from_pyobj(&nev,nev_capi,"_arpack.ssaupd() 4th argument (nev) can't be converted to int");
    if (f2py_success) {
    /* Processing variable tol */
        f2py_success = float_from_pyobj(&tol,tol_capi,"_arpack.ssaupd() 5th argument (tol) can't be converted to float");
    if (f2py_success) {
    /* Processing variable resid */
    ;
    capi_resid_intent |= F2PY_INTENT_IN|F2PY_INTENT_OUT;
    const char * capi_errmess = "_arpack._arpack.ssaupd: failed to create array from the 6th argument `resid`";
    capi_resid_as_array = ndarray_from_pyobj(  NPY_FLOAT,1,resid_Dims,resid_Rank,  capi_resid_intent,resid_capi,capi_errmess);
    if (capi_resid_as_array == NULL) {
        PyObject* capi_err = PyErr_Occurred();
        if (capi_err == NULL) {
            capi_err = _arpack_error;
            PyErr_SetString(capi_err, capi_errmess);
        }
    } else {
        resid = (float *)(PyArray_DATA(capi_resid_as_array));

    /* Processing variable v */
    ;
    capi_v_intent |= F2PY_INTENT_IN|F2PY_INTENT_OUT;
    const char * capi_errmess = "_arpack._arpack.ssaupd: failed to create array from the 7th argument `v`";
    capi_v_as_array = ndarray_from_pyobj(  NPY_FLOAT,1,v_Dims,v_Rank,  capi_v_intent,v_capi,capi_errmess);
    if (capi_v_as_array == NULL) {
        PyObject* capi_err = PyErr_Occurred();
        if (capi_err == NULL) {
            capi_err = _arpack_error;
            PyErr_SetString(capi_err, capi_errmess);
        }
    } else {
        v = (float *)(PyArray_DATA(capi_v_as_array));

    /* Processing variable iparam */
    iparam_Dims[0]=11;
    capi_iparam_intent |= F2PY_INTENT_IN|F2PY_INTENT_OUT;
    const char * capi_errmess = "_arpack._arpack.ssaupd: failed to create array from the 8th argument `iparam`";
    capi_iparam_as_array = ndarray_from_pyobj(  NPY_INT,1,iparam_Dims,iparam_Rank,  capi_iparam_intent,iparam_capi,capi_errmess);
    if (capi_iparam_as_array == NULL) {
        PyObject* capi_err = PyErr_Occurred();
        if (capi_err == NULL) {
            capi_err = _arpack_error;
            PyErr_SetString(capi_err, capi_errmess);
        }
    } else {
        iparam = (int *)(PyArray_DATA(capi_iparam_as_array));

    /* Processing variable ipntr */
    ipntr_Dims[0]=11;
    capi_ipntr_intent |= F2PY_INTENT_IN|F2PY_INTENT_OUT;
    const char * capi_errmess = "_arpack._arpack.ssaupd: failed to create array from the 9th argument `ipntr`";
    capi_ipntr_as_array = ndarray_from_pyobj(  NPY_INT,1,ipntr_Dims,ipntr_Rank,  capi_ipntr_intent,ipntr_capi,capi_errmess);
    if (capi_ipntr_as_array == NULL) {
        PyObject* capi_err = PyErr_Occurred();
        if (capi_err == NULL) {
            capi_err = _arpack_error;
            PyErr_SetString(capi_err, capi_errmess);
        }
    } else {
        ipntr = (int *)(PyArray_DATA(capi_ipntr_as_array));

    /* Processing variable workl */
    ;
    capi_workl_intent |= F2PY_INTENT_INOUT;
    const char * capi_errmess = "_arpack._arpack.ssaupd: failed to create array from the 11st argument `workl`";
    capi_workl_as_array = ndarray_from_pyobj(  NPY_FLOAT,1,workl_Dims,workl_Rank,  capi_workl_intent,workl_capi,capi_errmess);
    if (capi_workl_as_array == NULL) {
        PyObject* capi_err = PyErr_Occurred();
        if (capi_err == NULL) {
            capi_err = _arpack_error;
            PyErr_SetString(capi_err, capi_errmess);
        }
    } else {
        workl = (float *)(PyArray_DATA(capi_workl_as_array));

    /* Processing variable info */
        f2py_success = int_from_pyobj(&info,info_capi,"_arpack.ssaupd() 12nd argument (info) can't be converted to int");
    if (f2py_success) {
    /* Processing variable n */
    if (n_capi == Py_None) n = len(resid); else
        f2py_success = int_from_pyobj(&n,n_capi,"_arpack.ssaupd() 1st keyword (n) can't be converted to int");
    if (f2py_success) {
    CHECKSCALAR(len(resid)>=n,"len(resid)>=n","1st keyword n","ssaupd:n=%d",n) {
    /* Processing variable ncv */
    if (ncv_capi == Py_None) ncv = shape(v,1); else
        f2py_success = int_from_pyobj(&ncv,ncv_capi,"_arpack.ssaupd() 2nd keyword (ncv) can't be converted to int");
    if (f2py_success) {
    CHECKSCALAR(shape(v,1)==ncv,"shape(v,1)==ncv","2nd keyword ncv","ssaupd:ncv=%d",ncv) {
    /* Processing variable ldv */
    if (ldv_capi == Py_None) ldv = shape(v,0); else
        f2py_success = int_from_pyobj(&ldv,ldv_capi,"_arpack.ssaupd() 3rd keyword (ldv) can't be converted to int");
    if (f2py_success) {
    CHECKSCALAR(shape(v,0)==ldv,"shape(v,0)==ldv","3rd keyword ldv","ssaupd:ldv=%d",ldv) {
    /* Processing variable workd */
    workd_Dims[0]=3 * n;
    capi_workd_intent |= F2PY_INTENT_INOUT;
    const char * capi_errmess = "_arpack._arpack.ssaupd: failed to create array from the 10th argument `workd`";
    capi_workd_as_array = ndarray_from_pyobj(  NPY_FLOAT,1,workd_Dims,workd_Rank,  capi_workd_intent,workd_capi,capi_errmess);
    if (capi_workd_as_array == NULL) {
        PyObject* capi_err = PyErr_Occurred();
        if (capi_err == NULL) {
            capi_err = _arpack_error;
            PyErr_SetString(capi_err, capi_errmess);
        }
    } else {
        workd = (float *)(PyArray_DATA(capi_workd_as_array));

    /* Processing variable lworkl */
    if (lworkl_capi == Py_None) lworkl = len(workl); else
        f2py_success = int_from_pyobj(&lworkl,lworkl_capi,"_arpack.ssaupd() 4th keyword (lworkl) can't be converted to int");
    if (f2py_success) {
    CHECKSCALAR(len(workl)>=lworkl,"len(workl)>=lworkl","4th keyword lworkl","ssaupd:lworkl=%d",lworkl) {
/*end of frompyobj*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_call_clock();
#endif
/*callfortranroutine*/
            Py_BEGIN_ALLOW_THREADS
                (*f2py_func)(&ido,bmat,&n,which,&nev,&tol,resid,&ncv,v,&ldv,iparam,ipntr,workd,workl,&lworkl,&info,slen(bmat),slen(which));
            Py_END_ALLOW_THREADS
if (PyErr_Occurred())
  f2py_success = 0;
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_call_clock();
#endif
/*end of callfortranroutine*/
        if (f2py_success) {
/*pyobjfrom*/
/*end of pyobjfrom*/
        CFUNCSMESS("Building return value.\n");
        capi_buildvalue = Py_BuildValue("ifNNNNi",ido,tol,capi_resid_as_array,capi_v_as_array,capi_iparam_as_array,capi_ipntr_as_array,info);
/*closepyobjfrom*/
/*end of closepyobjfrom*/
        } /*if (f2py_success) after callfortranroutine*/
/*cleanupfrompyobj*/
    } /*CHECKSCALAR(len(workl)>=lworkl)*/
    } /*if (f2py_success) of lworkl*/
    /* End of cleaning variable lworkl */
    if((PyObject *)capi_workd_as_array!=workd_capi) {
        Py_XDECREF(capi_workd_as_array); }
    }  /* if (capi_workd_as_array == NULL) ... else of workd */
    /* End of cleaning variable workd */
    } /*CHECKSCALAR(shape(v,0)==ldv)*/
    } /*if (f2py_success) of ldv*/
    /* End of cleaning variable ldv */
    } /*CHECKSCALAR(shape(v,1)==ncv)*/
    } /*if (f2py_success) of ncv*/
    /* End of cleaning variable ncv */
    } /*CHECKSCALAR(len(resid)>=n)*/
    } /*if (f2py_success) of n*/
    /* End of cleaning variable n */
    } /*if (f2py_success) of info*/
    /* End of cleaning variable info */
    if((PyObject *)capi_workl_as_array!=workl_capi) {
        Py_XDECREF(capi_workl_as_array); }
    }  /* if (capi_workl_as_array == NULL) ... else of workl */
    /* End of cleaning variable workl */
    }  /* if (capi_ipntr_as_array == NULL) ... else of ipntr */
    /* End of cleaning variable ipntr */
    }  /* if (capi_iparam_as_array == NULL) ... else of iparam */
    /* End of cleaning variable iparam */
    }  /* if (capi_v_as_array == NULL) ... else of v */
    /* End of cleaning variable v */
    }  /* if (capi_resid_as_array == NULL) ... else of resid */
    /* End of cleaning variable resid */
    } /*if (f2py_success) of tol*/
    /* End of cleaning variable tol */
    } /*if (f2py_success) of nev*/
    /* End of cleaning variable nev */
        STRINGFREE(which);
    }  /*if (f2py_success) of which*/
    /* End of cleaning variable which */
        STRINGFREE(bmat);
    }  /*if (f2py_success) of bmat*/
    /* End of cleaning variable bmat */
    } /*if (f2py_success) of ido*/
    /* End of cleaning variable ido */
/*end of cleanupfrompyobj*/
    if (capi_buildvalue == NULL) {
/*routdebugfailure*/
    } else {
/*routdebugleave*/
    }
    CFUNCSMESS("Freeing memory.\n");
/*freemem*/
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_clock();
#endif
    return capi_buildvalue;
}
/******************************* end of ssaupd *******************************/

/*********************************** dsaupd ***********************************/
static char doc_f2py_rout__arpack_dsaupd[] = "\
ido,tol,resid,v,iparam,ipntr,info = dsaupd(ido,bmat,which,nev,tol,resid,v,iparam,ipntr,workd,workl,info,[n,ncv,ldv,lworkl])\n\nWrapper for ``dsaupd``.\
\n\nParameters\n----------\n"
"ido : input int\n"
"bmat : input string(len=1)\n"
"which : input string(len=2)\n"
"nev : input int\n"
"tol : input float\n"
"resid : input rank-1 array('d') with bounds (n)\n"
"v : input rank-2 array('d') with bounds (ldv,ncv)\n"
"iparam : input rank-1 array('i') with bounds (11)\n"
"ipntr : input rank-1 array('i') with bounds (11)\n"
"workd : in/output rank-1 array('d') with bounds (3 * n)\n"
"workl : in/output rank-1 array('d') with bounds (lworkl)\n"
"info : input int\n"
"\nOther Parameters\n----------------\n"
"n : input int, optional\n    Default: len(resid)\n"
"ncv : input int, optional\n    Default: shape(v,1)\n"
"ldv : input int, optional\n    Default: shape(v,0)\n"
"lworkl : input int, optional\n    Default: len(workl)\n"
"\nReturns\n-------\n"
"ido : int\n"
"tol : float\n"
"resid : rank-1 array('d') with bounds (n)\n"
"v : rank-2 array('d') with bounds (ldv,ncv)\n"
"iparam : rank-1 array('i') with bounds (11)\n"
"ipntr : rank-1 array('i') with bounds (11)\n"
"info : int";
/* extern void F_FUNC(dsaupd,DSAUPD)(int*,string,int*,string,int*,double*,double*,int*,double*,int*,int*,int*,double*,double*,int*,int*,size_t,size_t); */
static PyObject *f2py_rout__arpack_dsaupd(const PyObject *capi_self,
                           PyObject *capi_args,
                           PyObject *capi_keywds,
                           void (*f2py_func)(int*,string,int*,string,int*,double*,double*,int*,double*,int*,int*,int*,double*,double*,int*,int*,size_t,size_t)) {
    PyObject * volatile capi_buildvalue = NULL;
    volatile int f2py_success = 1;
/*decl*/

    int ido = 0;
    PyObject *ido_capi = Py_None;
    string bmat = NULL;
    int slen(bmat);
    PyObject *bmat_capi = Py_None;
    int n = 0;
    PyObject *n_capi = Py_None;
    string which = NULL;
    int slen(which);
    PyObject *which_capi = Py_None;
    int nev = 0;
    PyObject *nev_capi = Py_None;
    double tol = 0;
    PyObject *tol_capi = Py_None;
    double *resid = NULL;
    npy_intp resid_Dims[1] = {-1};
    const int resid_Rank = 1;
    PyArrayObject *capi_resid_as_array = NULL;
    int capi_resid_intent = 0;
    PyObject *resid_capi = Py_None;
    int ncv = 0;
    PyObject *ncv_capi = Py_None;
    double *v = NULL;
    npy_intp v_Dims[2] = {-1, -1};
    const int v_Rank = 2;
    PyArrayObject *capi_v_as_array = NULL;
    int capi_v_intent = 0;
    PyObject *v_capi = Py_None;
    int ldv = 0;
    PyObject *ldv_capi = Py_None;
    int *iparam = NULL;
    npy_intp iparam_Dims[1] = {-1};
    const int iparam_Rank = 1;
    PyArrayObject *capi_iparam_as_array = NULL;
    int capi_iparam_intent = 0;
    PyObject *iparam_capi = Py_None;
    int *ipntr = NULL;
    npy_intp ipntr_Dims[1] = {-1};
    const int ipntr_Rank = 1;
    PyArrayObject *capi_ipntr_as_array = NULL;
    int capi_ipntr_intent = 0;
    PyObject *ipntr_capi = Py_None;
    double *workd = NULL;
    npy_intp workd_Dims[1] = {-1};
    const int workd_Rank = 1;
    PyArrayObject *capi_workd_as_array = NULL;
    int capi_workd_intent = 0;
    PyObject *workd_capi = Py_None;
    double *workl = NULL;
    npy_intp workl_Dims[1] = {-1};
    const int workl_Rank = 1;
    PyArrayObject *capi_workl_as_array = NULL;
    int capi_workl_intent = 0;
    PyObject *workl_capi = Py_None;
    int lworkl = 0;
    PyObject *lworkl_capi = Py_None;
    int info = 0;
    PyObject *info_capi = Py_None;
    static char *capi_kwlist[] = {"ido","bmat","which","nev","tol","resid","v","iparam","ipntr","workd","workl","info","n","ncv","ldv","lworkl",NULL};

/*routdebugenter*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_clock();
#endif
    if (!PyArg_ParseTupleAndKeywords(capi_args,capi_keywds,\
        "OOOOOOOOOOOO|OOOO:_arpack.dsaupd",\
        capi_kwlist,&ido_capi,&bmat_capi,&which_capi,&nev_capi,&tol_capi,&resid_capi,&v_capi,&iparam_capi,&ipntr_capi,&workd_capi,&workl_capi,&info_capi,&n_capi,&ncv_capi,&ldv_capi,&lworkl_capi))
        return NULL;
/*frompyobj*/
    /* Processing variable ido */
        f2py_success = int_from_pyobj(&ido,ido_capi,"_arpack.dsaupd() 1st argument (ido) can't be converted to int");
    if (f2py_success) {
    /* Processing variable bmat */
    slen(bmat) = 1;
    f2py_success = string_from_pyobj(&bmat,&slen(bmat),"",bmat_capi,"string_from_pyobj failed in converting 2nd argument`bmat' of _arpack.dsaupd to C string");
    if (f2py_success) {
        STRINGPADN(bmat, slen(bmat), '\0', ' ');
    /* Processing variable which */
    slen(which) = 2;
    f2py_success = string_from_pyobj(&which,&slen(which),"",which_capi,"string_from_pyobj failed in converting 3rd argument`which' of _arpack.dsaupd to C string");
    if (f2py_success) {
        STRINGPADN(which, slen(which), '\0', ' ');
    /* Processing variable nev */
        f2py_success = int_from_pyobj(&nev,nev_capi,"_arpack.dsaupd() 4th argument (nev) can't be converted to int");
    if (f2py_success) {
    /* Processing variable tol */
        f2py_success = double_from_pyobj(&tol,tol_capi,"_arpack.dsaupd() 5th argument (tol) can't be converted to double");
    if (f2py_success) {
    /* Processing variable resid */
    ;
    capi_resid_intent |= F2PY_INTENT_IN|F2PY_INTENT_OUT;
    const char * capi_errmess = "_arpack._arpack.dsaupd: failed to create array from the 6th argument `resid`";
    capi_resid_as_array = ndarray_from_pyobj(  NPY_DOUBLE,1,resid_Dims,resid_Rank,  capi_resid_intent,resid_capi,capi_errmess);
    if (capi_resid_as_array == NULL) {
        PyObject* capi_err = PyErr_Occurred();
        if (capi_err == NULL) {
            capi_err = _arpack_error;
            PyErr_SetString(capi_err, capi_errmess);
        }
    } else {
        resid = (double *)(PyArray_DATA(capi_resid_as_array));

    /* Processing variable v */
    ;
    capi_v_intent |= F2PY_INTENT_IN|F2PY_INTENT_OUT;
    const char * capi_errmess = "_arpack._arpack.dsaupd: failed to create array from the 7th argument `v`";
    capi_v_as_array = ndarray_from_pyobj(  NPY_DOUBLE,1,v_Dims,v_Rank,  capi_v_intent,v_capi,capi_errmess);
    if (capi_v_as_array == NULL) {
        PyObject* capi_err = PyErr_Occurred();
        if (capi_err == NULL) {
            capi_err = _arpack_error;
            PyErr_SetString(capi_err, capi_errmess);
        }
    } else {
        v = (double *)(PyArray_DATA(capi_v_as_array));

    /* Processing variable iparam */
    iparam_Dims[0]=11;
    capi_iparam_intent |= F2PY_INTENT_IN|F2PY_INTENT_OUT;
    const char * capi_errmess = "_arpack._arpack.dsaupd: failed to create array from the 8th argument `iparam`";
    capi_iparam_as_array = ndarray_from_pyobj(  NPY_INT,1,iparam_Dims,iparam_Rank,  capi_iparam_intent,iparam_capi,capi_errmess);
    if (capi_iparam_as_array == NULL) {
        PyObject* capi_err = PyErr_Occurred();
        if (capi_err == NULL) {
            capi_err = _arpack_error;
            PyErr_SetString(capi_err, capi_errmess);
        }
    } else {
        iparam = (int *)(PyArray_DATA(capi_iparam_as_array));

    /* Processing variable ipntr */
    ipntr_Dims[0]=11;
    capi_ipntr_intent |= F2PY_INTENT_IN|F2PY_INTENT_OUT;
    const char * capi_errmess = "_arpack._arpack.dsaupd: failed to create array from the 9th argument `ipntr`";
    capi_ipntr_as_array = ndarray_from_pyobj(  NPY_INT,1,ipntr_Dims,ipntr_Rank,  capi_ipntr_intent,ipntr_capi,capi_errmess);
    if (capi_ipntr_as_array == NULL) {
        PyObject* capi_err = PyErr_Occurred();
        if (capi_err == NULL) {
            capi_err = _arpack_error;
            PyErr_SetString(capi_err, capi_errmess);
        }
    } else {
        ipntr = (int *)(PyArray_DATA(capi_ipntr_as_array));

    /* Processing variable workl */
    ;
    capi_workl_intent |= F2PY_INTENT_INOUT;
    const char * capi_errmess = "_arpack._arpack.dsaupd: failed to create array from the 11st argument `workl`";
    capi_workl_as_array = ndarray_from_pyobj(  NPY_DOUBLE,1,workl_Dims,workl_Rank,  capi_workl_intent,workl_capi,capi_errmess);
    if (capi_workl_as_array == NULL) {
        PyObject* capi_err = PyErr_Occurred();
        if (capi_err == NULL) {
            capi_err = _arpack_error;
            PyErr_SetString(capi_err, capi_errmess);
        }
    } else {
        workl = (double *)(PyArray_DATA(capi_workl_as_array));

    /* Processing variable info */
        f2py_success = int_from_pyobj(&info,info_capi,"_arpack.dsaupd() 12nd argument (info) can't be converted to int");
    if (f2py_success) {
    /* Processing variable n */
    if (n_capi == Py_None) n = len(resid); else
        f2py_success = int_from_pyobj(&n,n_capi,"_arpack.dsaupd() 1st keyword (n) can't be converted to int");
    if (f2py_success) {
    CHECKSCALAR(len(resid)>=n,"len(resid)>=n","1st keyword n","dsaupd:n=%d",n) {
    /* Processing variable ncv */
    if (ncv_capi == Py_None) ncv = shape(v,1); else
        f2py_success = int_from_pyobj(&ncv,ncv_capi,"_arpack.dsaupd() 2nd keyword (ncv) can't be converted to int");
    if (f2py_success) {
    CHECKSCALAR(shape(v,1)==ncv,"shape(v,1)==ncv","2nd keyword ncv","dsaupd:ncv=%d",ncv) {
    /* Processing variable ldv */
    if (ldv_capi == Py_None) ldv = shape(v,0); else
        f2py_success = int_from_pyobj(&ldv,ldv_capi,"_arpack.dsaupd() 3rd keyword (ldv) can't be converted to int");
    if (f2py_success) {
    CHECKSCALAR(shape(v,0)==ldv,"shape(v,0)==ldv","3rd keyword ldv","dsaupd:ldv=%d",ldv) {
    /* Processing variable workd */
    workd_Dims[0]=3 * n;
    capi_workd_intent |= F2PY_INTENT_INOUT;
    const char * capi_errmess = "_arpack._arpack.dsaupd: failed to create array from the 10th argument `workd`";
    capi_workd_as_array = ndarray_from_pyobj(  NPY_DOUBLE,1,workd_Dims,workd_Rank,  capi_workd_intent,workd_capi,capi_errmess);
    if (capi_workd_as_array == NULL) {
        PyObject* capi_err = PyErr_Occurred();
        if (capi_err == NULL) {
            capi_err = _arpack_error;
            PyErr_SetString(capi_err, capi_errmess);
        }
    } else {
        workd = (double *)(PyArray_DATA(capi_workd_as_array));

    /* Processing variable lworkl */
    if (lworkl_capi == Py_None) lworkl = len(workl); else
        f2py_success = int_from_pyobj(&lworkl,lworkl_capi,"_arpack.dsaupd() 4th keyword (lworkl) can't be converted to int");
    if (f2py_success) {
    CHECKSCALAR(len(workl)>=lworkl,"len(workl)>=lworkl","4th keyword lworkl","dsaupd:lworkl=%d",lworkl) {
/*end of frompyobj*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_call_clock();
#endif
/*callfortranroutine*/
            Py_BEGIN_ALLOW_THREADS
                (*f2py_func)(&ido,bmat,&n,which,&nev,&tol,resid,&ncv,v,&ldv,iparam,ipntr,workd,workl,&lworkl,&info,slen(bmat),slen(which));
            Py_END_ALLOW_THREADS
if (PyErr_Occurred())
  f2py_success = 0;
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_call_clock();
#endif
/*end of callfortranroutine*/
        if (f2py_success) {
/*pyobjfrom*/
/*end of pyobjfrom*/
        CFUNCSMESS("Building return value.\n");
        capi_buildvalue = Py_BuildValue("idNNNNi",ido,tol,capi_resid_as_array,capi_v_as_array,capi_iparam_as_array,capi_ipntr_as_array,info);
/*closepyobjfrom*/
/*end of closepyobjfrom*/
        } /*if (f2py_success) after callfortranroutine*/
/*cleanupfrompyobj*/
    } /*CHECKSCALAR(len(workl)>=lworkl)*/
    } /*if (f2py_success) of lworkl*/
    /* End of cleaning variable lworkl */
    if((PyObject *)capi_workd_as_array!=workd_capi) {
        Py_XDECREF(capi_workd_as_array); }
    }  /* if (capi_workd_as_array == NULL) ... else of workd */
    /* End of cleaning variable workd */
    } /*CHECKSCALAR(shape(v,0)==ldv)*/
    } /*if (f2py_success) of ldv*/
    /* End of cleaning variable ldv */
    } /*CHECKSCALAR(shape(v,1)==ncv)*/
    } /*if (f2py_success) of ncv*/
    /* End of cleaning variable ncv */
    } /*CHECKSCALAR(len(resid)>=n)*/
    } /*if (f2py_success) of n*/
    /* End of cleaning variable n */
    } /*if (f2py_success) of info*/
    /* End of cleaning variable info */
    if((PyObject *)capi_workl_as_array!=workl_capi) {
        Py_XDECREF(capi_workl_as_array); }
    }  /* if (capi_workl_as_array == NULL) ... else of workl */
    /* End of cleaning variable workl */
    }  /* if (capi_ipntr_as_array == NULL) ... else of ipntr */
    /* End of cleaning variable ipntr */
    }  /* if (capi_iparam_as_array == NULL) ... else of iparam */
    /* End of cleaning variable iparam */
    }  /* if (capi_v_as_array == NULL) ... else of v */
    /* End of cleaning variable v */
    }  /* if (capi_resid_as_array == NULL) ... else of resid */
    /* End of cleaning variable resid */
    } /*if (f2py_success) of tol*/
    /* End of cleaning variable tol */
    } /*if (f2py_success) of nev*/
    /* End of cleaning variable nev */
        STRINGFREE(which);
    }  /*if (f2py_success) of which*/
    /* End of cleaning variable which */
        STRINGFREE(bmat);
    }  /*if (f2py_success) of bmat*/
    /* End of cleaning variable bmat */
    } /*if (f2py_success) of ido*/
    /* End of cleaning variable ido */
/*end of cleanupfrompyobj*/
    if (capi_buildvalue == NULL) {
/*routdebugfailure*/
    } else {
/*routdebugleave*/
    }
    CFUNCSMESS("Freeing memory.\n");
/*freemem*/
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_clock();
#endif
    return capi_buildvalue;
}
/******************************* end of dsaupd *******************************/

/*********************************** sseupd ***********************************/
static char doc_f2py_rout__arpack_sseupd[] = "\
d,z,info = sseupd(rvec,howmny,select,sigma,bmat,which,nev,tol,resid,v,iparam,ipntr,workd,workl,info,[ldz,n,ncv,ldv,lworkl])\n\nWrapper for ``sseupd``.\
\n\nParameters\n----------\n"
"rvec : input int\n"
"howmny : input bytes\n"
"select : input rank-1 array('i') with bounds (ncv)\n"
"sigma : input float\n"
"bmat : input bytes\n"
"which : input string(len=2)\n"
"nev : input int\n"
"tol : input float\n"
"resid : input rank-1 array('f') with bounds (n)\n"
"v : input rank-2 array('f') with bounds (ldv,ncv)\n"
"iparam : input rank-1 array('i') with bounds (7)\n"
"ipntr : input rank-1 array('i') with bounds (11)\n"
"workd : input rank-1 array('f') with bounds (2 * n)\n"
"workl : input rank-1 array('f') with bounds (lworkl)\n"
"info : input int\n"
"\nOther Parameters\n----------------\n"
"ldz : input int, optional\n    Default: shape(z,0)\n"
"n : input int, optional\n    Default: len(resid)\n"
"ncv : input int, optional\n    Default: len(select)\n"
"ldv : input int, optional\n    Default: shape(v,0)\n"
"lworkl : input int, optional\n    Default: len(workl)\n"
"\nReturns\n-------\n"
"d : rank-1 array('f') with bounds (nev)\n"
"z : rank-2 array('f') with bounds (n,nev)\n"
"info : int";
/* extern void F_FUNC(sseupd,SSEUPD)(int*,character*,int*,float*,float*,int*,float*,character*,int*,string,int*,float*,float*,int*,float*,int*,int*,int*,float*,float*,int*,int*,size_t); */
static PyObject *f2py_rout__arpack_sseupd(const PyObject *capi_self,
                           PyObject *capi_args,
                           PyObject *capi_keywds,
                           void (*f2py_func)(int*,character*,int*,float*,float*,int*,float*,character*,int*,string,int*,float*,float*,int*,float*,int*,int*,int*,float*,float*,int*,int*,size_t)) {
    PyObject * volatile capi_buildvalue = NULL;
    volatile int f2py_success = 1;
/*decl*/

    int rvec = 0;
    PyObject *rvec_capi = Py_None;
    character howmny = 0;
    PyObject *howmny_capi = Py_None;
    int *select = NULL;
    npy_intp select_Dims[1] = {-1};
    const int select_Rank = 1;
    PyArrayObject *capi_select_as_array = NULL;
    int capi_select_intent = 0;
    PyObject *select_capi = Py_None;
    float *d = NULL;
    npy_intp d_Dims[1] = {-1};
    const int d_Rank = 1;
    PyArrayObject *capi_d_as_array = NULL;
    int capi_d_intent = 0;
    float *z = NULL;
    npy_intp z_Dims[2] = {-1, -1};
    const int z_Rank = 2;
    PyArrayObject *capi_z_as_array = NULL;
    int capi_z_intent = 0;
    int ldz = 0;
    PyObject *ldz_capi = Py_None;
    float sigma = 0;
    PyObject *sigma_capi = Py_None;
    character bmat = 0;
    PyObject *bmat_capi = Py_None;
    int n = 0;
    PyObject *n_capi = Py_None;
    string which = NULL;
    int slen(which);
    PyObject *which_capi = Py_None;
    int nev = 0;
    PyObject *nev_capi = Py_None;
    float tol = 0;
    PyObject *tol_capi = Py_None;
    float *resid = NULL;
    npy_intp resid_Dims[1] = {-1};
    const int resid_Rank = 1;
    PyArrayObject *capi_resid_as_array = NULL;
    int capi_resid_intent = 0;
    PyObject *resid_capi = Py_None;
    int ncv = 0;
    PyObject *ncv_capi = Py_None;
    float *v = NULL;
    npy_intp v_Dims[2] = {-1, -1};
    const int v_Rank = 2;
    PyArrayObject *capi_v_as_array = NULL;
    int capi_v_intent = 0;
    PyObject *v_capi = Py_None;
    int ldv = 0;
    PyObject *ldv_capi = Py_None;
    int *iparam = NULL;
    npy_intp iparam_Dims[1] = {-1};
    const int iparam_Rank = 1;
    PyArrayObject *capi_iparam_as_array = NULL;
    int capi_iparam_intent = 0;
    PyObject *iparam_capi = Py_None;
    int *ipntr = NULL;
    npy_intp ipntr_Dims[1] = {-1};
    const int ipntr_Rank = 1;
    PyArrayObject *capi_ipntr_as_array = NULL;
    int capi_ipntr_intent = 0;
    PyObject *ipntr_capi = Py_None;
    float *workd = NULL;
    npy_intp workd_Dims[1] = {-1};
    const int workd_Rank = 1;
    PyArrayObject *capi_workd_as_array = NULL;
    int capi_workd_intent = 0;
    PyObject *workd_capi = Py_None;
    float *workl = NULL;
    npy_intp workl_Dims[1] = {-1};
    const int workl_Rank = 1;
    PyArrayObject *capi_workl_as_array = NULL;
    int capi_workl_intent = 0;
    PyObject *workl_capi = Py_None;
    int lworkl = 0;
    PyObject *lworkl_capi = Py_None;
    int info = 0;
    PyObject *info_capi = Py_None;
    static char *capi_kwlist[] = {"rvec","howmny","select","sigma","bmat","which","nev","tol","resid","v","iparam","ipntr","workd","workl","info","ldz","n","ncv","ldv","lworkl",NULL};

/*routdebugenter*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_clock();
#endif
    if (!PyArg_ParseTupleAndKeywords(capi_args,capi_keywds,\
        "OOOOOOOOOOOOOOO|OOOOO:_arpack.sseupd",\
        capi_kwlist,&rvec_capi,&howmny_capi,&select_capi,&sigma_capi,&bmat_capi,&which_capi,&nev_capi,&tol_capi,&resid_capi,&v_capi,&iparam_capi,&ipntr_capi,&workd_capi,&workl_capi,&info_capi,&ldz_capi,&n_capi,&ncv_capi,&ldv_capi,&lworkl_capi))
        return NULL;
/*frompyobj*/
    /* Processing variable rvec */
        rvec = (int)PyObject_IsTrue(rvec_capi);
        f2py_success = 1;
    if (f2py_success) {
    /* Processing variable howmny */
        f2py_success = character_from_pyobj(&howmny,howmny_capi,"_arpack.sseupd() 2nd argument (howmny) can't be converted to character");
    if (f2py_success) {
    /* Processing variable select */
    ;
    capi_select_intent |= F2PY_INTENT_IN;
    const char * capi_errmess = "_arpack._arpack.sseupd: failed to create array from the 3rd argument `select`";
    capi_select_as_array = ndarray_from_pyobj(  NPY_INT,1,select_Dims,select_Rank,  capi_select_intent,select_capi,capi_errmess);
    if (capi_select_as_array == NULL) {
        PyObject* capi_err = PyErr_Occurred();
        if (capi_err == NULL) {
            capi_err = _arpack_error;
            PyErr_SetString(capi_err, capi_errmess);
        }
    } else {
        select = (int *)(PyArray_DATA(capi_select_as_array));

    /* Processing variable sigma */
        f2py_success = float_from_pyobj(&sigma,sigma_capi,"_arpack.sseupd() 4th argument (sigma) can't be converted to float");
    if (f2py_success) {
    /* Processing variable bmat */
        f2py_success = character_from_pyobj(&bmat,bmat_capi,"_arpack.sseupd() 5th argument (bmat) can't be converted to character");
    if (f2py_success) {
    /* Processing variable which */
    slen(which) = 2;
    f2py_success = string_from_pyobj(&which,&slen(which),"",which_capi,"string_from_pyobj failed in converting 6th argument`which' of _arpack.sseupd to C string");
    if (f2py_success) {
        STRINGPADN(which, slen(which), '\0', ' ');
    /* Processing variable nev */
        f2py_success = int_from_pyobj(&nev,nev_capi,"_arpack.sseupd() 7th argument (nev) can't be converted to int");
    if (f2py_success) {
    /* Processing variable tol */
        f2py_success = float_from_pyobj(&tol,tol_capi,"_arpack.sseupd() 8th argument (tol) can't be converted to float");
    if (f2py_success) {
    /* Processing variable resid */
    ;
    capi_resid_intent |= F2PY_INTENT_IN;
    const char * capi_errmess = "_arpack._arpack.sseupd: failed to create array from the 9th argument `resid`";
    capi_resid_as_array = ndarray_from_pyobj(  NPY_FLOAT,1,resid_Dims,resid_Rank,  capi_resid_intent,resid_capi,capi_errmess);
    if (capi_resid_as_array == NULL) {
        PyObject* capi_err = PyErr_Occurred();
        if (capi_err == NULL) {
            capi_err = _arpack_error;
            PyErr_SetString(capi_err, capi_errmess);
        }
    } else {
        resid = (float *)(PyArray_DATA(capi_resid_as_array));

    /* Processing variable iparam */
    iparam_Dims[0]=7;
    capi_iparam_intent |= F2PY_INTENT_IN;
    const char * capi_errmess = "_arpack._arpack.sseupd: failed to create array from the 11st argument `iparam`";
    capi_iparam_as_array = ndarray_from_pyobj(  NPY_INT,1,iparam_Dims,iparam_Rank,  capi_iparam_intent,iparam_capi,capi_errmess);
    if (capi_iparam_as_array == NULL) {
        PyObject* capi_err = PyErr_Occurred();
        if (capi_err == NULL) {
            capi_err = _arpack_error;
            PyErr_SetString(capi_err, capi_errmess);
        }
    } else {
        iparam = (int *)(PyArray_DATA(capi_iparam_as_array));

    /* Processing variable ipntr */
    ipntr_Dims[0]=11;
    capi_ipntr_intent |= F2PY_INTENT_IN;
    const char * capi_errmess = "_arpack._arpack.sseupd: failed to create array from the 12nd argument `ipntr`";
    capi_ipntr_as_array = ndarray_from_pyobj(  NPY_INT,1,ipntr_Dims,ipntr_Rank,  capi_ipntr_intent,ipntr_capi,capi_errmess);
    if (capi_ipntr_as_array == NULL) {
        PyObject* capi_err = PyErr_Occurred();
        if (capi_err == NULL) {
            capi_err = _arpack_error;
            PyErr_SetString(capi_err, capi_errmess);
        }
    } else {
        ipntr = (int *)(PyArray_DATA(capi_ipntr_as_array));

    /* Processing variable workl */
    ;
    capi_workl_intent |= F2PY_INTENT_IN;
    const char * capi_errmess = "_arpack._arpack.sseupd: failed to create array from the 14th argument `workl`";
    capi_workl_as_array = ndarray_from_pyobj(  NPY_FLOAT,1,workl_Dims,workl_Rank,  capi_workl_intent,workl_capi,capi_errmess);
    if (capi_workl_as_array == NULL) {
        PyObject* capi_err = PyErr_Occurred();
        if (capi_err == NULL) {
            capi_err = _arpack_error;
            PyErr_SetString(capi_err, capi_errmess);
        }
    } else {
        workl = (float *)(PyArray_DATA(capi_workl_as_array));

    /* Processing variable info */
        f2py_success = int_from_pyobj(&info,info_capi,"_arpack.sseupd() 15th argument (info) can't be converted to int");
    if (f2py_success) {
    /* Processing variable d */
    d_Dims[0]=nev;
    capi_d_intent |= F2PY_INTENT_OUT|F2PY_INTENT_HIDE;
    const char * capi_errmess = "_arpack._arpack.sseupd: failed to create array from the hidden `d`";
    capi_d_as_array = ndarray_from_pyobj(  NPY_FLOAT,1,d_Dims,d_Rank,  capi_d_intent,Py_None,capi_errmess);
    if (capi_d_as_array == NULL) {
        PyObject* capi_err = PyErr_Occurred();
        if (capi_err == NULL) {
            capi_err = _arpack_error;
            PyErr_SetString(capi_err, capi_errmess);
        }
    } else {
        d = (float *)(PyArray_DATA(capi_d_as_array));

    /* Processing variable n */
    if (n_capi == Py_None) n = len(resid); else
        f2py_success = int_from_pyobj(&n,n_capi,"_arpack.sseupd() 2nd keyword (n) can't be converted to int");
    if (f2py_success) {
    CHECKSCALAR(len(resid)>=n,"len(resid)>=n","2nd keyword n","sseupd:n=%d",n) {
    /* Processing variable ncv */
    if (ncv_capi == Py_None) ncv = len(select); else
        f2py_success = int_from_pyobj(&ncv,ncv_capi,"_arpack.sseupd() 3rd keyword (ncv) can't be converted to int");
    if (f2py_success) {
    CHECKSCALAR(len(select)>=ncv,"len(select)>=ncv","3rd keyword ncv","sseupd:ncv=%d",ncv) {
    /* Processing variable v */
    v_Dims[1]=ncv;
    capi_v_intent |= F2PY_INTENT_IN;
    const char * capi_errmess = "_arpack._arpack.sseupd: failed to create array from the 10th argument `v`";
    capi_v_as_array = ndarray_from_pyobj(  NPY_FLOAT,1,v_Dims,v_Rank,  capi_v_intent,v_capi,capi_errmess);
    if (capi_v_as_array == NULL) {
        PyObject* capi_err = PyErr_Occurred();
        if (capi_err == NULL) {
            capi_err = _arpack_error;
            PyErr_SetString(capi_err, capi_errmess);
        }
    } else {
        v = (float *)(PyArray_DATA(capi_v_as_array));

    /* Processing variable ldv */
    if (ldv_capi == Py_None) ldv = shape(v,0); else
        f2py_success = int_from_pyobj(&ldv,ldv_capi,"_arpack.sseupd() 4th keyword (ldv) can't be converted to int");
    if (f2py_success) {
    CHECKSCALAR(shape(v,0)==ldv,"shape(v,0)==ldv","4th keyword ldv","sseupd:ldv=%d",ldv) {
    /* Processing variable workd */
    workd_Dims[0]=2 * n;
    capi_workd_intent |= F2PY_INTENT_IN;
    const char * capi_errmess = "_arpack._arpack.sseupd: failed to create array from the 13rd argument `workd`";
    capi_workd_as_array = ndarray_from_pyobj(  NPY_FLOAT,1,workd_Dims,workd_Rank,  capi_workd_intent,workd_capi,capi_errmess);
    if (capi_workd_as_array == NULL) {
        PyObject* capi_err = PyErr_Occurred();
        if (capi_err == NULL) {
            capi_err = _arpack_error;
            PyErr_SetString(capi_err, capi_errmess);
        }
    } else {
        workd = (float *)(PyArray_DATA(capi_workd_as_array));

    /* Processing variable lworkl */
    if (lworkl_capi == Py_None) lworkl = len(workl); else
        f2py_success = int_from_pyobj(&lworkl,lworkl_capi,"_arpack.sseupd() 5th keyword (lworkl) can't be converted to int");
    if (f2py_success) {
    CHECKSCALAR(len(workl)>=lworkl,"len(workl)>=lworkl","5th keyword lworkl","sseupd:lworkl=%d",lworkl) {
    /* Processing variable z */
    z_Dims[0]=n,z_Dims[1]=nev;
    capi_z_intent |= F2PY_INTENT_OUT|F2PY_INTENT_HIDE;
    const char * capi_errmess = "_arpack._arpack.sseupd: failed to create array from the hidden `z`";
    capi_z_as_array = ndarray_from_pyobj(  NPY_FLOAT,1,z_Dims,z_Rank,  capi_z_intent,Py_None,capi_errmess);
    if (capi_z_as_array == NULL) {
        PyObject* capi_err = PyErr_Occurred();
        if (capi_err == NULL) {
            capi_err = _arpack_error;
            PyErr_SetString(capi_err, capi_errmess);
        }
    } else {
        z = (float *)(PyArray_DATA(capi_z_as_array));

    /* Processing variable ldz */
    if (ldz_capi == Py_None) ldz = shape(z,0); else
        f2py_success = int_from_pyobj(&ldz,ldz_capi,"_arpack.sseupd() 1st keyword (ldz) can't be converted to int");
    if (f2py_success) {
    CHECKSCALAR(shape(z,0)==ldz,"shape(z,0)==ldz","1st keyword ldz","sseupd:ldz=%d",ldz) {
/*end of frompyobj*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_call_clock();
#endif
/*callfortranroutine*/
            Py_BEGIN_ALLOW_THREADS
                (*f2py_func)(&rvec,&howmny,select,d,z,&ldz,&sigma,&bmat,&n,which,&nev,&tol,resid,&ncv,v,&ldv,iparam,ipntr,workd,workl,&lworkl,&info,slen(which));
            Py_END_ALLOW_THREADS
if (PyErr_Occurred())
  f2py_success = 0;
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_call_clock();
#endif
/*end of callfortranroutine*/
        if (f2py_success) {
/*pyobjfrom*/
/*end of pyobjfrom*/
        CFUNCSMESS("Building return value.\n");
        capi_buildvalue = Py_BuildValue("NNi",capi_d_as_array,capi_z_as_array,info);
/*closepyobjfrom*/
/*end of closepyobjfrom*/
        } /*if (f2py_success) after callfortranroutine*/
/*cleanupfrompyobj*/
    } /*CHECKSCALAR(shape(z,0)==ldz)*/
    } /*if (f2py_success) of ldz*/
    /* End of cleaning variable ldz */
    }  /* if (capi_z_as_array == NULL) ... else of z */
    /* End of cleaning variable z */
    } /*CHECKSCALAR(len(workl)>=lworkl)*/
    } /*if (f2py_success) of lworkl*/
    /* End of cleaning variable lworkl */
    if((PyObject *)capi_workd_as_array!=workd_capi) {
        Py_XDECREF(capi_workd_as_array); }
    }  /* if (capi_workd_as_array == NULL) ... else of workd */
    /* End of cleaning variable workd */
    } /*CHECKSCALAR(shape(v,0)==ldv)*/
    } /*if (f2py_success) of ldv*/
    /* End of cleaning variable ldv */
    if((PyObject *)capi_v_as_array!=v_capi) {
        Py_XDECREF(capi_v_as_array); }
    }  /* if (capi_v_as_array == NULL) ... else of v */
    /* End of cleaning variable v */
    } /*CHECKSCALAR(len(select)>=ncv)*/
    } /*if (f2py_success) of ncv*/
    /* End of cleaning variable ncv */
    } /*CHECKSCALAR(len(resid)>=n)*/
    } /*if (f2py_success) of n*/
    /* End of cleaning variable n */
    }  /* if (capi_d_as_array == NULL) ... else of d */
    /* End of cleaning variable d */
    } /*if (f2py_success) of info*/
    /* End of cleaning variable info */
    if((PyObject *)capi_workl_as_array!=workl_capi) {
        Py_XDECREF(capi_workl_as_array); }
    }  /* if (capi_workl_as_array == NULL) ... else of workl */
    /* End of cleaning variable workl */
    if((PyObject *)capi_ipntr_as_array!=ipntr_capi) {
        Py_XDECREF(capi_ipntr_as_array); }
    }  /* if (capi_ipntr_as_array == NULL) ... else of ipntr */
    /* End of cleaning variable ipntr */
    if((PyObject *)capi_iparam_as_array!=iparam_capi) {
        Py_XDECREF(capi_iparam_as_array); }
    }  /* if (capi_iparam_as_array == NULL) ... else of iparam */
    /* End of cleaning variable iparam */
    if((PyObject *)capi_resid_as_array!=resid_capi) {
        Py_XDECREF(capi_resid_as_array); }
    }  /* if (capi_resid_as_array == NULL) ... else of resid */
    /* End of cleaning variable resid */
    } /*if (f2py_success) of tol*/
    /* End of cleaning variable tol */
    } /*if (f2py_success) of nev*/
    /* End of cleaning variable nev */
        STRINGFREE(which);
    }  /*if (f2py_success) of which*/
    /* End of cleaning variable which */
    } /*if (f2py_success) of bmat*/
    /* End of cleaning variable bmat */
    } /*if (f2py_success) of sigma*/
    /* End of cleaning variable sigma */
    if((PyObject *)capi_select_as_array!=select_capi) {
        Py_XDECREF(capi_select_as_array); }
    }  /* if (capi_select_as_array == NULL) ... else of select */
    /* End of cleaning variable select */
    } /*if (f2py_success) of howmny*/
    /* End of cleaning variable howmny */
    } /*if (f2py_success) of rvec*/
    /* End of cleaning variable rvec */
/*end of cleanupfrompyobj*/
    if (capi_buildvalue == NULL) {
/*routdebugfailure*/
    } else {
/*routdebugleave*/
    }
    CFUNCSMESS("Freeing memory.\n");
/*freemem*/
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_clock();
#endif
    return capi_buildvalue;
}
/******************************* end of sseupd *******************************/

/*********************************** dseupd ***********************************/
static char doc_f2py_rout__arpack_dseupd[] = "\
d,z,info = dseupd(rvec,howmny,select,sigma,bmat,which,nev,tol,resid,v,iparam,ipntr,workd,workl,info,[ldz,n,ncv,ldv,lworkl])\n\nWrapper for ``dseupd``.\
\n\nParameters\n----------\n"
"rvec : input int\n"
"howmny : input bytes\n"
"select : input rank-1 array('i') with bounds (ncv)\n"
"sigma : input float\n"
"bmat : input bytes\n"
"which : input string(len=2)\n"
"nev : input int\n"
"tol : input float\n"
"resid : input rank-1 array('d') with bounds (n)\n"
"v : input rank-2 array('d') with bounds (ldv,ncv)\n"
"iparam : input rank-1 array('i') with bounds (7)\n"
"ipntr : input rank-1 array('i') with bounds (11)\n"
"workd : input rank-1 array('d') with bounds (2 * n)\n"
"workl : input rank-1 array('d') with bounds (lworkl)\n"
"info : input int\n"
"\nOther Parameters\n----------------\n"
"ldz : input int, optional\n    Default: shape(z,0)\n"
"n : input int, optional\n    Default: len(resid)\n"
"ncv : input int, optional\n    Default: len(select)\n"
"ldv : input int, optional\n    Default: shape(v,0)\n"
"lworkl : input int, optional\n    Default: len(workl)\n"
"\nReturns\n-------\n"
"d : rank-1 array('d') with bounds (nev)\n"
"z : rank-2 array('d') with bounds (n,nev)\n"
"info : int";
/* extern void F_FUNC(dseupd,DSEUPD)(int*,character*,int*,double*,double*,int*,double*,character*,int*,string,int*,double*,double*,int*,double*,int*,int*,int*,double*,double*,int*,int*,size_t); */
static PyObject *f2py_rout__arpack_dseupd(const PyObject *capi_self,
                           PyObject *capi_args,
                           PyObject *capi_keywds,
                           void (*f2py_func)(int*,character*,int*,double*,double*,int*,double*,character*,int*,string,int*,double*,double*,int*,double*,int*,int*,int*,double*,double*,int*,int*,size_t)) {
    PyObject * volatile capi_buildvalue = NULL;
    volatile int f2py_success = 1;
/*decl*/

    int rvec = 0;
    PyObject *rvec_capi = Py_None;
    character howmny = 0;
    PyObject *howmny_capi = Py_None;
    int *select = NULL;
    npy_intp select_Dims[1] = {-1};
    const int select_Rank = 1;
    PyArrayObject *capi_select_as_array = NULL;
    int capi_select_intent = 0;
    PyObject *select_capi = Py_None;
    double *d = NULL;
    npy_intp d_Dims[1] = {-1};
    const int d_Rank = 1;
    PyArrayObject *capi_d_as_array = NULL;
    int capi_d_intent = 0;
    double *z = NULL;
    npy_intp z_Dims[2] = {-1, -1};
    const int z_Rank = 2;
    PyArrayObject *capi_z_as_array = NULL;
    int capi_z_intent = 0;
    int ldz = 0;
    PyObject *ldz_capi = Py_None;
    double sigma = 0;
    PyObject *sigma_capi = Py_None;
    character bmat = 0;
    PyObject *bmat_capi = Py_None;
    int n = 0;
    PyObject *n_capi = Py_None;
    string which = NULL;
    int slen(which);
    PyObject *which_capi = Py_None;
    int nev = 0;
    PyObject *nev_capi = Py_None;
    double tol = 0;
    PyObject *tol_capi = Py_None;
    double *resid = NULL;
    npy_intp resid_Dims[1] = {-1};
    const int resid_Rank = 1;
    PyArrayObject *capi_resid_as_array = NULL;
    int capi_resid_intent = 0;
    PyObject *resid_capi = Py_None;
    int ncv = 0;
    PyObject *ncv_capi = Py_None;
    double *v = NULL;
    npy_intp v_Dims[2] = {-1, -1};
    const int v_Rank = 2;
    PyArrayObject *capi_v_as_array = NULL;
    int capi_v_intent = 0;
    PyObject *v_capi = Py_None;
    int ldv = 0;
    PyObject *ldv_capi = Py_None;
    int *iparam = NULL;
    npy_intp iparam_Dims[1] = {-1};
    const int iparam_Rank = 1;
    PyArrayObject *capi_iparam_as_array = NULL;
    int capi_iparam_intent = 0;
    PyObject *iparam_capi = Py_None;
    int *ipntr = NULL;
    npy_intp ipntr_Dims[1] = {-1};
    const int ipntr_Rank = 1;
    PyArrayObject *capi_ipntr_as_array = NULL;
    int capi_ipntr_intent = 0;
    PyObject *ipntr_capi = Py_None;
    double *workd = NULL;
    npy_intp workd_Dims[1] = {-1};
    const int workd_Rank = 1;
    PyArrayObject *capi_workd_as_array = NULL;
    int capi_workd_intent = 0;
    PyObject *workd_capi = Py_None;
    double *workl = NULL;
    npy_intp workl_Dims[1] = {-1};
    const int workl_Rank = 1;
    PyArrayObject *capi_workl_as_array = NULL;
    int capi_workl_intent = 0;
    PyObject *workl_capi = Py_None;
    int lworkl = 0;
    PyObject *lworkl_capi = Py_None;
    int info = 0;
    PyObject *info_capi = Py_None;
    static char *capi_kwlist[] = {"rvec","howmny","select","sigma","bmat","which","nev","tol","resid","v","iparam","ipntr","workd","workl","info","ldz","n","ncv","ldv","lworkl",NULL};

/*routdebugenter*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_clock();
#endif
    if (!PyArg_ParseTupleAndKeywords(capi_args,capi_keywds,\
        "OOOOOOOOOOOOOOO|OOOOO:_arpack.dseupd",\
        capi_kwlist,&rvec_capi,&howmny_capi,&select_capi,&sigma_capi,&bmat_capi,&which_capi,&nev_capi,&tol_capi,&resid_capi,&v_capi,&iparam_capi,&ipntr_capi,&workd_capi,&workl_capi,&info_capi,&ldz_capi,&n_capi,&ncv_capi,&ldv_capi,&lworkl_capi))
        return NULL;
/*frompyobj*/
    /* Processing variable rvec */
        rvec = (int)PyObject_IsTrue(rvec_capi);
        f2py_success = 1;
    if (f2py_success) {
    /* Processing variable howmny */
        f2py_success = character_from_pyobj(&howmny,howmny_capi,"_arpack.dseupd() 2nd argument (howmny) can't be converted to character");
    if (f2py_success) {
    /* Processing variable select */
    ;
    capi_select_intent |= F2PY_INTENT_IN;
    const char * capi_errmess = "_arpack._arpack.dseupd: failed to create array from the 3rd argument `select`";
    capi_select_as_array = ndarray_from_pyobj(  NPY_INT,1,select_Dims,select_Rank,  capi_select_intent,select_capi,capi_errmess);
    if (capi_select_as_array == NULL) {
        PyObject* capi_err = PyErr_Occurred();
        if (capi_err == NULL) {
            capi_err = _arpack_error;
            PyErr_SetString(capi_err, capi_errmess);
        }
    } else {
        select = (int *)(PyArray_DATA(capi_select_as_array));

    /* Processing variable sigma */
        f2py_success = double_from_pyobj(&sigma,sigma_capi,"_arpack.dseupd() 4th argument (sigma) can't be converted to double");
    if (f2py_success) {
    /* Processing variable bmat */
        f2py_success = character_from_pyobj(&bmat,bmat_capi,"_arpack.dseupd() 5th argument (bmat) can't be converted to character");
    if (f2py_success) {
    /* Processing variable which */
    slen(which) = 2;
    f2py_success = string_from_pyobj(&which,&slen(which),"",which_capi,"string_from_pyobj failed in converting 6th argument`which' of _arpack.dseupd to C string");
    if (f2py_success) {
        STRINGPADN(which, slen(which), '\0', ' ');
    /* Processing variable nev */
        f2py_success = int_from_pyobj(&nev,nev_capi,"_arpack.dseupd() 7th argument (nev) can't be converted to int");
    if (f2py_success) {
    /* Processing variable tol */
        f2py_success = double_from_pyobj(&tol,tol_capi,"_arpack.dseupd() 8th argument (tol) can't be converted to double");
    if (f2py_success) {
    /* Processing variable resid */
    ;
    capi_resid_intent |= F2PY_INTENT_IN;
    const char * capi_errmess = "_arpack._arpack.dseupd: failed to create array from the 9th argument `resid`";
    capi_resid_as_array = ndarray_from_pyobj(  NPY_DOUBLE,1,resid_Dims,resid_Rank,  capi_resid_intent,resid_capi,capi_errmess);
    if (capi_resid_as_array == NULL) {
        PyObject* capi_err = PyErr_Occurred();
        if (capi_err == NULL) {
            capi_err = _arpack_error;
            PyErr_SetString(capi_err, capi_errmess);
        }
    } else {
        resid = (double *)(PyArray_DATA(capi_resid_as_array));

    /* Processing variable iparam */
    iparam_Dims[0]=7;
    capi_iparam_intent |= F2PY_INTENT_IN;
    const char * capi_errmess = "_arpack._arpack.dseupd: failed to create array from the 11st argument `iparam`";
    capi_iparam_as_array = ndarray_from_pyobj(  NPY_INT,1,iparam_Dims,iparam_Rank,  capi_iparam_intent,iparam_capi,capi_errmess);
    if (capi_iparam_as_array == NULL) {
        PyObject* capi_err = PyErr_Occurred();
        if (capi_err == NULL) {
            capi_err = _arpack_error;
            PyErr_SetString(capi_err, capi_errmess);
        }
    } else {
        iparam = (int *)(PyArray_DATA(capi_iparam_as_array));

    /* Processing variable ipntr */
    ipntr_Dims[0]=11;
    capi_ipntr_intent |= F2PY_INTENT_IN;
    const char * capi_errmess = "_arpack._arpack.dseupd: failed to create array from the 12nd argument `ipntr`";
    capi_ipntr_as_array = ndarray_from_pyobj(  NPY_INT,1,ipntr_Dims,ipntr_Rank,  capi_ipntr_intent,ipntr_capi,capi_errmess);
    if (capi_ipntr_as_array == NULL) {
        PyObject* capi_err = PyErr_Occurred();
        if (capi_err == NULL) {
            capi_err = _arpack_error;
            PyErr_SetString(capi_err, capi_errmess);
        }
    } else {
        ipntr = (int *)(PyArray_DATA(capi_ipntr_as_array));

    /* Processing variable workl */
    ;
    capi_workl_intent |= F2PY_INTENT_IN;
    const char * capi_errmess = "_arpack._arpack.dseupd: failed to create array from the 14th argument `workl`";
    capi_workl_as_array = ndarray_from_pyobj(  NPY_DOUBLE,1,workl_Dims,workl_Rank,  capi_workl_intent,workl_capi,capi_errmess);
    if (capi_workl_as_array == NULL) {
        PyObject* capi_err = PyErr_Occurred();
        if (capi_err == NULL) {
            capi_err = _arpack_error;
            PyErr_SetString(capi_err, capi_errmess);
        }
    } else {
        workl = (double *)(PyArray_DATA(capi_workl_as_array));

    /* Processing variable info */
        f2py_success = int_from_pyobj(&info,info_capi,"_arpack.dseupd() 15th argument (info) can't be converted to int");
    if (f2py_success) {
    /* Processing variable d */
    d_Dims[0]=nev;
    capi_d_intent |= F2PY_INTENT_OUT|F2PY_INTENT_HIDE;
    const char * capi_errmess = "_arpack._arpack.dseupd: failed to create array from the hidden `d`";
    capi_d_as_array = ndarray_from_pyobj(  NPY_DOUBLE,1,d_Dims,d_Rank,  capi_d_intent,Py_None,capi_errmess);
    if (capi_d_as_array == NULL) {
        PyObject* capi_err = PyErr_Occurred();
        if (capi_err == NULL) {
            capi_err = _arpack_error;
            PyErr_SetString(capi_err, capi_errmess);
        }
    } else {
        d = (double *)(PyArray_DATA(capi_d_as_array));

    /* Processing variable n */
    if (n_capi == Py_None) n = len(resid); else
        f2py_success = int_from_pyobj(&n,n_capi,"_arpack.dseupd() 2nd keyword (n) can't be converted to int");
    if (f2py_success) {
    CHECKSCALAR(len(resid)>=n,"len(resid)>=n","2nd keyword n","dseupd:n=%d",n) {
    /* Processing variable ncv */
    if (ncv_capi == Py_None) ncv = len(select); else
        f2py_success = int_from_pyobj(&ncv,ncv_capi,"_arpack.dseupd() 3rd keyword (ncv) can't be converted to int");
    if (f2py_success) {
    CHECKSCALAR(len(select)>=ncv,"len(select)>=ncv","3rd keyword ncv","dseupd:ncv=%d",ncv) {
    /* Processing variable v */
    v_Dims[1]=ncv;
    capi_v_intent |= F2PY_INTENT_IN;
    const char * capi_errmess = "_arpack._arpack.dseupd: failed to create array from the 10th argument `v`";
    capi_v_as_array = ndarray_from_pyobj(  NPY_DOUBLE,1,v_Dims,v_Rank,  capi_v_intent,v_capi,capi_errmess);
    if (capi_v_as_array == NULL) {
        PyObject* capi_err = PyErr_Occurred();
        if (capi_err == NULL) {
            capi_err = _arpack_error;
            PyErr_SetString(capi_err, capi_errmess);
        }
    } else {
        v = (double *)(PyArray_DATA(capi_v_as_array));

    /* Processing variable ldv */
    if (ldv_capi == Py_None) ldv = shape(v,0); else
        f2py_success = int_from_pyobj(&ldv,ldv_capi,"_arpack.dseupd() 4th keyword (ldv) can't be converted to int");
    if (f2py_success) {
    CHECKSCALAR(shape(v,0)==ldv,"shape(v,0)==ldv","4th keyword ldv","dseupd:ldv=%d",ldv) {
    /* Processing variable workd */
    workd_Dims[0]=2 * n;
    capi_workd_intent |= F2PY_INTENT_IN;
    const char * capi_errmess = "_arpack._arpack.dseupd: failed to create array from the 13rd argument `workd`";
    capi_workd_as_array = ndarray_from_pyobj(  NPY_DOUBLE,1,workd_Dims,workd_Rank,  capi_workd_intent,workd_capi,capi_errmess);
    if (capi_workd_as_array == NULL) {
        PyObject* capi_err = PyErr_Occurred();
        if (capi_err == NULL) {
            capi_err = _arpack_error;
            PyErr_SetString(capi_err, capi_errmess);
        }
    } else {
        workd = (double *)(PyArray_DATA(capi_workd_as_array));

    /* Processing variable lworkl */
    if (lworkl_capi == Py_None) lworkl = len(workl); else
        f2py_success = int_from_pyobj(&lworkl,lworkl_capi,"_arpack.dseupd() 5th keyword (lworkl) can't be converted to int");
    if (f2py_success) {
    CHECKSCALAR(len(workl)>=lworkl,"len(workl)>=lworkl","5th keyword lworkl","dseupd:lworkl=%d",lworkl) {
    /* Processing variable z */
    z_Dims[0]=n,z_Dims[1]=nev;
    capi_z_intent |= F2PY_INTENT_OUT|F2PY_INTENT_HIDE;
    const char * capi_errmess = "_arpack._arpack.dseupd: failed to create array from the hidden `z`";
    capi_z_as_array = ndarray_from_pyobj(  NPY_DOUBLE,1,z_Dims,z_Rank,  capi_z_intent,Py_None,capi_errmess);
    if (capi_z_as_array == NULL) {
        PyObject* capi_err = PyErr_Occurred();
        if (capi_err == NULL) {
            capi_err = _arpack_error;
            PyErr_SetString(capi_err, capi_errmess);
        }
    } else {
        z = (double *)(PyArray_DATA(capi_z_as_array));

    /* Processing variable ldz */
    if (ldz_capi == Py_None) ldz = shape(z,0); else
        f2py_success = int_from_pyobj(&ldz,ldz_capi,"_arpack.dseupd() 1st keyword (ldz) can't be converted to int");
    if (f2py_success) {
    CHECKSCALAR(shape(z,0)==ldz,"shape(z,0)==ldz","1st keyword ldz","dseupd:ldz=%d",ldz) {
/*end of frompyobj*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_call_clock();
#endif
/*callfortranroutine*/
            Py_BEGIN_ALLOW_THREADS
                (*f2py_func)(&rvec,&howmny,select,d,z,&ldz,&sigma,&bmat,&n,which,&nev,&tol,resid,&ncv,v,&ldv,iparam,ipntr,workd,workl,&lworkl,&info,slen(which));
            Py_END_ALLOW_THREADS
if (PyErr_Occurred())
  f2py_success = 0;
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_call_clock();
#endif
/*end of callfortranroutine*/
        if (f2py_success) {
/*pyobjfrom*/
/*end of pyobjfrom*/
        CFUNCSMESS("Building return value.\n");
        capi_buildvalue = Py_BuildValue("NNi",capi_d_as_array,capi_z_as_array,info);
/*closepyobjfrom*/
/*end of closepyobjfrom*/
        } /*if (f2py_success) after callfortranroutine*/
/*cleanupfrompyobj*/
    } /*CHECKSCALAR(shape(z,0)==ldz)*/
    } /*if (f2py_success) of ldz*/
    /* End of cleaning variable ldz */
    }  /* if (capi_z_as_array == NULL) ... else of z */
    /* End of cleaning variable z */
    } /*CHECKSCALAR(len(workl)>=lworkl)*/
    } /*if (f2py_success) of lworkl*/
    /* End of cleaning variable lworkl */
    if((PyObject *)capi_workd_as_array!=workd_capi) {
        Py_XDECREF(capi_workd_as_array); }
    }  /* if (capi_workd_as_array == NULL) ... else of workd */
    /* End of cleaning variable workd */
    } /*CHECKSCALAR(shape(v,0)==ldv)*/
    } /*if (f2py_success) of ldv*/
    /* End of cleaning variable ldv */
    if((PyObject *)capi_v_as_array!=v_capi) {
        Py_XDECREF(capi_v_as_array); }
    }  /* if (capi_v_as_array == NULL) ... else of v */
    /* End of cleaning variable v */
    } /*CHECKSCALAR(len(select)>=ncv)*/
    } /*if (f2py_success) of ncv*/
    /* End of cleaning variable ncv */
    } /*CHECKSCALAR(len(resid)>=n)*/
    } /*if (f2py_success) of n*/
    /* End of cleaning variable n */
    }  /* if (capi_d_as_array == NULL) ... else of d */
    /* End of cleaning variable d */
    } /*if (f2py_success) of info*/
    /* End of cleaning variable info */
    if((PyObject *)capi_workl_as_array!=workl_capi) {
        Py_XDECREF(capi_workl_as_array); }
    }  /* if (capi_workl_as_array == NULL) ... else of workl */
    /* End of cleaning variable workl */
    if((PyObject *)capi_ipntr_as_array!=ipntr_capi) {
        Py_XDECREF(capi_ipntr_as_array); }
    }  /* if (capi_ipntr_as_array == NULL) ... else of ipntr */
    /* End of cleaning variable ipntr */
    if((PyObject *)capi_iparam_as_array!=iparam_capi) {
        Py_XDECREF(capi_iparam_as_array); }
    }  /* if (capi_iparam_as_array == NULL) ... else of iparam */
    /* End of cleaning variable iparam */
    if((PyObject *)capi_resid_as_array!=resid_capi) {
        Py_XDECREF(capi_resid_as_array); }
    }  /* if (capi_resid_as_array == NULL) ... else of resid */
    /* End of cleaning variable resid */
    } /*if (f2py_success) of tol*/
    /* End of cleaning variable tol */
    } /*if (f2py_success) of nev*/
    /* End of cleaning variable nev */
        STRINGFREE(which);
    }  /*if (f2py_success) of which*/
    /* End of cleaning variable which */
    } /*if (f2py_success) of bmat*/
    /* End of cleaning variable bmat */
    } /*if (f2py_success) of sigma*/
    /* End of cleaning variable sigma */
    if((PyObject *)capi_select_as_array!=select_capi) {
        Py_XDECREF(capi_select_as_array); }
    }  /* if (capi_select_as_array == NULL) ... else of select */
    /* End of cleaning variable select */
    } /*if (f2py_success) of howmny*/
    /* End of cleaning variable howmny */
    } /*if (f2py_success) of rvec*/
    /* End of cleaning variable rvec */
/*end of cleanupfrompyobj*/
    if (capi_buildvalue == NULL) {
/*routdebugfailure*/
    } else {
/*routdebugleave*/
    }
    CFUNCSMESS("Freeing memory.\n");
/*freemem*/
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_clock();
#endif
    return capi_buildvalue;
}
/******************************* end of dseupd *******************************/

/*********************************** snaupd ***********************************/
static char doc_f2py_rout__arpack_snaupd[] = "\
ido,tol,resid,v,iparam,ipntr,info = snaupd(ido,bmat,which,nev,tol,resid,v,iparam,ipntr,workd,workl,info,[n,ncv,ldv,lworkl])\n\nWrapper for ``snaupd``.\
\n\nParameters\n----------\n"
"ido : input int\n"
"bmat : input string(len=1)\n"
"which : input string(len=2)\n"
"nev : input int\n"
"tol : input float\n"
"resid : input rank-1 array('f') with bounds (n)\n"
"v : input rank-2 array('f') with bounds (ldv,ncv)\n"
"iparam : input rank-1 array('i') with bounds (11)\n"
"ipntr : input rank-1 array('i') with bounds (14)\n"
"workd : in/output rank-1 array('f') with bounds (3 * n)\n"
"workl : in/output rank-1 array('f') with bounds (lworkl)\n"
"info : input int\n"
"\nOther Parameters\n----------------\n"
"n : input int, optional\n    Default: len(resid)\n"
"ncv : input int, optional\n    Default: shape(v,1)\n"
"ldv : input int, optional\n    Default: shape(v,0)\n"
"lworkl : input int, optional\n    Default: len(workl)\n"
"\nReturns\n-------\n"
"ido : int\n"
"tol : float\n"
"resid : rank-1 array('f') with bounds (n)\n"
"v : rank-2 array('f') with bounds (ldv,ncv)\n"
"iparam : rank-1 array('i') with bounds (11)\n"
"ipntr : rank-1 array('i') with bounds (14)\n"
"info : int";
/* extern void F_FUNC(snaupd,SNAUPD)(int*,string,int*,string,int*,float*,float*,int*,float*,int*,int*,int*,float*,float*,int*,int*,size_t,size_t); */
static PyObject *f2py_rout__arpack_snaupd(const PyObject *capi_self,
                           PyObject *capi_args,
                           PyObject *capi_keywds,
                           void (*f2py_func)(int*,string,int*,string,int*,float*,float*,int*,float*,int*,int*,int*,float*,float*,int*,int*,size_t,size_t)) {
    PyObject * volatile capi_buildvalue = NULL;
    volatile int f2py_success = 1;
/*decl*/

    int ido = 0;
    PyObject *ido_capi = Py_None;
    string bmat = NULL;
    int slen(bmat);
    PyObject *bmat_capi = Py_None;
    int n = 0;
    PyObject *n_capi = Py_None;
    string which = NULL;
    int slen(which);
    PyObject *which_capi = Py_None;
    int nev = 0;
    PyObject *nev_capi = Py_None;
    float tol = 0;
    PyObject *tol_capi = Py_None;
    float *resid = NULL;
    npy_intp resid_Dims[1] = {-1};
    const int resid_Rank = 1;
    PyArrayObject *capi_resid_as_array = NULL;
    int capi_resid_intent = 0;
    PyObject *resid_capi = Py_None;
    int ncv = 0;
    PyObject *ncv_capi = Py_None;
    float *v = NULL;
    npy_intp v_Dims[2] = {-1, -1};
    const int v_Rank = 2;
    PyArrayObject *capi_v_as_array = NULL;
    int capi_v_intent = 0;
    PyObject *v_capi = Py_None;
    int ldv = 0;
    PyObject *ldv_capi = Py_None;
    int *iparam = NULL;
    npy_intp iparam_Dims[1] = {-1};
    const int iparam_Rank = 1;
    PyArrayObject *capi_iparam_as_array = NULL;
    int capi_iparam_intent = 0;
    PyObject *iparam_capi = Py_None;
    int *ipntr = NULL;
    npy_intp ipntr_Dims[1] = {-1};
    const int ipntr_Rank = 1;
    PyArrayObject *capi_ipntr_as_array = NULL;
    int capi_ipntr_intent = 0;
    PyObject *ipntr_capi = Py_None;
    float *workd = NULL;
    npy_intp workd_Dims[1] = {-1};
    const int workd_Rank = 1;
    PyArrayObject *capi_workd_as_array = NULL;
    int capi_workd_intent = 0;
    PyObject *workd_capi = Py_None;
    float *workl = NULL;
    npy_intp workl_Dims[1] = {-1};
    const int workl_Rank = 1;
    PyArrayObject *capi_workl_as_array = NULL;
    int capi_workl_intent = 0;
    PyObject *workl_capi = Py_None;
    int lworkl = 0;
    PyObject *lworkl_capi = Py_None;
    int info = 0;
    PyObject *info_capi = Py_None;
    static char *capi_kwlist[] = {"ido","bmat","which","nev","tol","resid","v","iparam","ipntr","workd","workl","info","n","ncv","ldv","lworkl",NULL};

/*routdebugenter*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_clock();
#endif
    if (!PyArg_ParseTupleAndKeywords(capi_args,capi_keywds,\
        "OOOOOOOOOOOO|OOOO:_arpack.snaupd",\
        capi_kwlist,&ido_capi,&bmat_capi,&which_capi,&nev_capi,&tol_capi,&resid_capi,&v_capi,&iparam_capi,&ipntr_capi,&workd_capi,&workl_capi,&info_capi,&n_capi,&ncv_capi,&ldv_capi,&lworkl_capi))
        return NULL;
/*frompyobj*/
    /* Processing variable ido */
        f2py_success = int_from_pyobj(&ido,ido_capi,"_arpack.snaupd() 1st argument (ido) can't be converted to int");
    if (f2py_success) {
    /* Processing variable bmat */
    slen(bmat) = 1;
    f2py_success = string_from_pyobj(&bmat,&slen(bmat),"",bmat_capi,"string_from_pyobj failed in converting 2nd argument`bmat' of _arpack.snaupd to C string");
    if (f2py_success) {
        STRINGPADN(bmat, slen(bmat), '\0', ' ');
    /* Processing variable which */
    slen(which) = 2;
    f2py_success = string_from_pyobj(&which,&slen(which),"",which_capi,"string_from_pyobj failed in converting 3rd argument`which' of _arpack.snaupd to C string");
    if (f2py_success) {
        STRINGPADN(which, slen(which), '\0', ' ');
    /* Processing variable nev */
        f2py_success = int_from_pyobj(&nev,nev_capi,"_arpack.snaupd() 4th argument (nev) can't be converted to int");
    if (f2py_success) {
    /* Processing variable tol */
        f2py_success = float_from_pyobj(&tol,tol_capi,"_arpack.snaupd() 5th argument (tol) can't be converted to float");
    if (f2py_success) {
    /* Processing variable resid */
    ;
    capi_resid_intent |= F2PY_INTENT_IN|F2PY_INTENT_OUT;
    const char * capi_errmess = "_arpack._arpack.snaupd: failed to create array from the 6th argument `resid`";
    capi_resid_as_array = ndarray_from_pyobj(  NPY_FLOAT,1,resid_Dims,resid_Rank,  capi_resid_intent,resid_capi,capi_errmess);
    if (capi_resid_as_array == NULL) {
        PyObject* capi_err = PyErr_Occurred();
        if (capi_err == NULL) {
            capi_err = _arpack_error;
            PyErr_SetString(capi_err, capi_errmess);
        }
    } else {
        resid = (float *)(PyArray_DATA(capi_resid_as_array));

    /* Processing variable v */
    ;
    capi_v_intent |= F2PY_INTENT_IN|F2PY_INTENT_OUT;
    const char * capi_errmess = "_arpack._arpack.snaupd: failed to create array from the 7th argument `v`";
    capi_v_as_array = ndarray_from_pyobj(  NPY_FLOAT,1,v_Dims,v_Rank,  capi_v_intent,v_capi,capi_errmess);
    if (capi_v_as_array == NULL) {
        PyObject* capi_err = PyErr_Occurred();
        if (capi_err == NULL) {
            capi_err = _arpack_error;
            PyErr_SetString(capi_err, capi_errmess);
        }
    } else {
        v = (float *)(PyArray_DATA(capi_v_as_array));

    /* Processing variable iparam */
    iparam_Dims[0]=11;
    capi_iparam_intent |= F2PY_INTENT_IN|F2PY_INTENT_OUT;
    const char * capi_errmess = "_arpack._arpack.snaupd: failed to create array from the 8th argument `iparam`";
    capi_iparam_as_array = ndarray_from_pyobj(  NPY_INT,1,iparam_Dims,iparam_Rank,  capi_iparam_intent,iparam_capi,capi_errmess);
    if (capi_iparam_as_array == NULL) {
        PyObject* capi_err = PyErr_Occurred();
        if (capi_err == NULL) {
            capi_err = _arpack_error;
            PyErr_SetString(capi_err, capi_errmess);
        }
    } else {
        iparam = (int *)(PyArray_DATA(capi_iparam_as_array));

    /* Processing variable ipntr */
    ipntr_Dims[0]=14;
    capi_ipntr_intent |= F2PY_INTENT_IN|F2PY_INTENT_OUT;
    const char * capi_errmess = "_arpack._arpack.snaupd: failed to create array from the 9th argument `ipntr`";
    capi_ipntr_as_array = ndarray_from_pyobj(  NPY_INT,1,ipntr_Dims,ipntr_Rank,  capi_ipntr_intent,ipntr_capi,capi_errmess);
    if (capi_ipntr_as_array == NULL) {
        PyObject* capi_err = PyErr_Occurred();
        if (capi_err == NULL) {
            capi_err = _arpack_error;
            PyErr_SetString(capi_err, capi_errmess);
        }
    } else {
        ipntr = (int *)(PyArray_DATA(capi_ipntr_as_array));

    /* Processing variable workl */
    ;
    capi_workl_intent |= F2PY_INTENT_INOUT;
    const char * capi_errmess = "_arpack._arpack.snaupd: failed to create array from the 11st argument `workl`";
    capi_workl_as_array = ndarray_from_pyobj(  NPY_FLOAT,1,workl_Dims,workl_Rank,  capi_workl_intent,workl_capi,capi_errmess);
    if (capi_workl_as_array == NULL) {
        PyObject* capi_err = PyErr_Occurred();
        if (capi_err == NULL) {
            capi_err = _arpack_error;
            PyErr_SetString(capi_err, capi_errmess);
        }
    } else {
        workl = (float *)(PyArray_DATA(capi_workl_as_array));

    /* Processing variable info */
        f2py_success = int_from_pyobj(&info,info_capi,"_arpack.snaupd() 12nd argument (info) can't be converted to int");
    if (f2py_success) {
    /* Processing variable n */
    if (n_capi == Py_None) n = len(resid); else
        f2py_success = int_from_pyobj(&n,n_capi,"_arpack.snaupd() 1st keyword (n) can't be converted to int");
    if (f2py_success) {
    CHECKSCALAR(len(resid)>=n,"len(resid)>=n","1st keyword n","snaupd:n=%d",n) {
    /* Processing variable ncv */
    if (ncv_capi == Py_None) ncv = shape(v,1); else
        f2py_success = int_from_pyobj(&ncv,ncv_capi,"_arpack.snaupd() 2nd keyword (ncv) can't be converted to int");
    if (f2py_success) {
    CHECKSCALAR(shape(v,1)==ncv,"shape(v,1)==ncv","2nd keyword ncv","snaupd:ncv=%d",ncv) {
    /* Processing variable ldv */
    if (ldv_capi == Py_None) ldv = shape(v,0); else
        f2py_success = int_from_pyobj(&ldv,ldv_capi,"_arpack.snaupd() 3rd keyword (ldv) can't be converted to int");
    if (f2py_success) {
    CHECKSCALAR(shape(v,0)==ldv,"shape(v,0)==ldv","3rd keyword ldv","snaupd:ldv=%d",ldv) {
    /* Processing variable workd */
    workd_Dims[0]=3 * n;
    capi_workd_intent |= F2PY_INTENT_INOUT;
    const char * capi_errmess = "_arpack._arpack.snaupd: failed to create array from the 10th argument `workd`";
    capi_workd_as_array = ndarray_from_pyobj(  NPY_FLOAT,1,workd_Dims,workd_Rank,  capi_workd_intent,workd_capi,capi_errmess);
    if (capi_workd_as_array == NULL) {
        PyObject* capi_err = PyErr_Occurred();
        if (capi_err == NULL) {
            capi_err = _arpack_error;
            PyErr_SetString(capi_err, capi_errmess);
        }
    } else {
        workd = (float *)(PyArray_DATA(capi_workd_as_array));

    /* Processing variable lworkl */
    if (lworkl_capi == Py_None) lworkl = len(workl); else
        f2py_success = int_from_pyobj(&lworkl,lworkl_capi,"_arpack.snaupd() 4th keyword (lworkl) can't be converted to int");
    if (f2py_success) {
    CHECKSCALAR(len(workl)>=lworkl,"len(workl)>=lworkl","4th keyword lworkl","snaupd:lworkl=%d",lworkl) {
/*end of frompyobj*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_call_clock();
#endif
/*callfortranroutine*/
            Py_BEGIN_ALLOW_THREADS
                (*f2py_func)(&ido,bmat,&n,which,&nev,&tol,resid,&ncv,v,&ldv,iparam,ipntr,workd,workl,&lworkl,&info,slen(bmat),slen(which));
            Py_END_ALLOW_THREADS
if (PyErr_Occurred())
  f2py_success = 0;
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_call_clock();
#endif
/*end of callfortranroutine*/
        if (f2py_success) {
/*pyobjfrom*/
/*end of pyobjfrom*/
        CFUNCSMESS("Building return value.\n");
        capi_buildvalue = Py_BuildValue("ifNNNNi",ido,tol,capi_resid_as_array,capi_v_as_array,capi_iparam_as_array,capi_ipntr_as_array,info);
/*closepyobjfrom*/
/*end of closepyobjfrom*/
        } /*if (f2py_success) after callfortranroutine*/
/*cleanupfrompyobj*/
    } /*CHECKSCALAR(len(workl)>=lworkl)*/
    } /*if (f2py_success) of lworkl*/
    /* End of cleaning variable lworkl */
    if((PyObject *)capi_workd_as_array!=workd_capi) {
        Py_XDECREF(capi_workd_as_array); }
    }  /* if (capi_workd_as_array == NULL) ... else of workd */
    /* End of cleaning variable workd */
    } /*CHECKSCALAR(shape(v,0)==ldv)*/
    } /*if (f2py_success) of ldv*/
    /* End of cleaning variable ldv */
    } /*CHECKSCALAR(shape(v,1)==ncv)*/
    } /*if (f2py_success) of ncv*/
    /* End of cleaning variable ncv */
    } /*CHECKSCALAR(len(resid)>=n)*/
    } /*if (f2py_success) of n*/
    /* End of cleaning variable n */
    } /*if (f2py_success) of info*/
    /* End of cleaning variable info */
    if((PyObject *)capi_workl_as_array!=workl_capi) {
        Py_XDECREF(capi_workl_as_array); }
    }  /* if (capi_workl_as_array == NULL) ... else of workl */
    /* End of cleaning variable workl */
    }  /* if (capi_ipntr_as_array == NULL) ... else of ipntr */
    /* End of cleaning variable ipntr */
    }  /* if (capi_iparam_as_array == NULL) ... else of iparam */
    /* End of cleaning variable iparam */
    }  /* if (capi_v_as_array == NULL) ... else of v */
    /* End of cleaning variable v */
    }  /* if (capi_resid_as_array == NULL) ... else of resid */
    /* End of cleaning variable resid */
    } /*if (f2py_success) of tol*/
    /* End of cleaning variable tol */
    } /*if (f2py_success) of nev*/
    /* End of cleaning variable nev */
        STRINGFREE(which);
    }  /*if (f2py_success) of which*/
    /* End of cleaning variable which */
        STRINGFREE(bmat);
    }  /*if (f2py_success) of bmat*/
    /* End of cleaning variable bmat */
    } /*if (f2py_success) of ido*/
    /* End of cleaning variable ido */
/*end of cleanupfrompyobj*/
    if (capi_buildvalue == NULL) {
/*routdebugfailure*/
    } else {
/*routdebugleave*/
    }
    CFUNCSMESS("Freeing memory.\n");
/*freemem*/
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_clock();
#endif
    return capi_buildvalue;
}
/******************************* end of snaupd *******************************/

/*********************************** dnaupd ***********************************/
static char doc_f2py_rout__arpack_dnaupd[] = "\
ido,tol,resid,v,iparam,ipntr,info = dnaupd(ido,bmat,which,nev,tol,resid,v,iparam,ipntr,workd,workl,info,[n,ncv,ldv,lworkl])\n\nWrapper for ``dnaupd``.\
\n\nParameters\n----------\n"
"ido : input int\n"
"bmat : input string(len=1)\n"
"which : input string(len=2)\n"
"nev : input int\n"
"tol : input float\n"
"resid : input rank-1 array('d') with bounds (n)\n"
"v : input rank-2 array('d') with bounds (ldv,ncv)\n"
"iparam : input rank-1 array('i') with bounds (11)\n"
"ipntr : input rank-1 array('i') with bounds (14)\n"
"workd : in/output rank-1 array('d') with bounds (3 * n)\n"
"workl : in/output rank-1 array('d') with bounds (lworkl)\n"
"info : input int\n"
"\nOther Parameters\n----------------\n"
"n : input int, optional\n    Default: len(resid)\n"
"ncv : input int, optional\n    Default: shape(v,1)\n"
"ldv : input int, optional\n    Default: shape(v,0)\n"
"lworkl : input int, optional\n    Default: len(workl)\n"
"\nReturns\n-------\n"
"ido : int\n"
"tol : float\n"
"resid : rank-1 array('d') with bounds (n)\n"
"v : rank-2 array('d') with bounds (ldv,ncv)\n"
"iparam : rank-1 array('i') with bounds (11)\n"
"ipntr : rank-1 array('i') with bounds (14)\n"
"info : int";
/* extern void F_FUNC(dnaupd,DNAUPD)(int*,string,int*,string,int*,double*,double*,int*,double*,int*,int*,int*,double*,double*,int*,int*,size_t,size_t); */
static PyObject *f2py_rout__arpack_dnaupd(const PyObject *capi_self,
                           PyObject *capi_args,
                           PyObject *capi_keywds,
                           void (*f2py_func)(int*,string,int*,string,int*,double*,double*,int*,double*,int*,int*,int*,double*,double*,int*,int*,size_t,size_t)) {
    PyObject * volatile capi_buildvalue = NULL;
    volatile int f2py_success = 1;
/*decl*/

    int ido = 0;
    PyObject *ido_capi = Py_None;
    string bmat = NULL;
    int slen(bmat);
    PyObject *bmat_capi = Py_None;
    int n = 0;
    PyObject *n_capi = Py_None;
    string which = NULL;
    int slen(which);
    PyObject *which_capi = Py_None;
    int nev = 0;
    PyObject *nev_capi = Py_None;
    double tol = 0;
    PyObject *tol_capi = Py_None;
    double *resid = NULL;
    npy_intp resid_Dims[1] = {-1};
    const int resid_Rank = 1;
    PyArrayObject *capi_resid_as_array = NULL;
    int capi_resid_intent = 0;
    PyObject *resid_capi = Py_None;
    int ncv = 0;
    PyObject *ncv_capi = Py_None;
    double *v = NULL;
    npy_intp v_Dims[2] = {-1, -1};
    const int v_Rank = 2;
    PyArrayObject *capi_v_as_array = NULL;
    int capi_v_intent = 0;
    PyObject *v_capi = Py_None;
    int ldv = 0;
    PyObject *ldv_capi = Py_None;
    int *iparam = NULL;
    npy_intp iparam_Dims[1] = {-1};
    const int iparam_Rank = 1;
    PyArrayObject *capi_iparam_as_array = NULL;
    int capi_iparam_intent = 0;
    PyObject *iparam_capi = Py_None;
    int *ipntr = NULL;
    npy_intp ipntr_Dims[1] = {-1};
    const int ipntr_Rank = 1;
    PyArrayObject *capi_ipntr_as_array = NULL;
    int capi_ipntr_intent = 0;
    PyObject *ipntr_capi = Py_None;
    double *workd = NULL;
    npy_intp workd_Dims[1] = {-1};
    const int workd_Rank = 1;
    PyArrayObject *capi_workd_as_array = NULL;
    int capi_workd_intent = 0;
    PyObject *workd_capi = Py_None;
    double *workl = NULL;
    npy_intp workl_Dims[1] = {-1};
    const int workl_Rank = 1;
    PyArrayObject *capi_workl_as_array = NULL;
    int capi_workl_intent = 0;
    PyObject *workl_capi = Py_None;
    int lworkl = 0;
    PyObject *lworkl_capi = Py_None;
    int info = 0;
    PyObject *info_capi = Py_None;
    static char *capi_kwlist[] = {"ido","bmat","which","nev","tol","resid","v","iparam","ipntr","workd","workl","info","n","ncv","ldv","lworkl",NULL};

/*routdebugenter*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_clock();
#endif
    if (!PyArg_ParseTupleAndKeywords(capi_args,capi_keywds,\
        "OOOOOOOOOOOO|OOOO:_arpack.dnaupd",\
        capi_kwlist,&ido_capi,&bmat_capi,&which_capi,&nev_capi,&tol_capi,&resid_capi,&v_capi,&iparam_capi,&ipntr_capi,&workd_capi,&workl_capi,&info_capi,&n_capi,&ncv_capi,&ldv_capi,&lworkl_capi))
        return NULL;
/*frompyobj*/
    /* Processing variable ido */
        f2py_success = int_from_pyobj(&ido,ido_capi,"_arpack.dnaupd() 1st argument (ido) can't be converted to int");
    if (f2py_success) {
    /* Processing variable bmat */
    slen(bmat) = 1;
    f2py_success = string_from_pyobj(&bmat,&slen(bmat),"",bmat_capi,"string_from_pyobj failed in converting 2nd argument`bmat' of _arpack.dnaupd to C string");
    if (f2py_success) {
        STRINGPADN(bmat, slen(bmat), '\0', ' ');
    /* Processing variable which */
    slen(which) = 2;
    f2py_success = string_from_pyobj(&which,&slen(which),"",which_capi,"string_from_pyobj failed in converting 3rd argument`which' of _arpack.dnaupd to C string");
    if (f2py_success) {
        STRINGPADN(which, slen(which), '\0', ' ');
    /* Processing variable nev */
        f2py_success = int_from_pyobj(&nev,nev_capi,"_arpack.dnaupd() 4th argument (nev) can't be converted to int");
    if (f2py_success) {
    /* Processing variable tol */
        f2py_success = double_from_pyobj(&tol,tol_capi,"_arpack.dnaupd() 5th argument (tol) can't be converted to double");
    if (f2py_success) {
    /* Processing variable resid */
    ;
    capi_resid_intent |= F2PY_INTENT_IN|F2PY_INTENT_OUT;
    const char * capi_errmess = "_arpack._arpack.dnaupd: failed to create array from the 6th argument `resid`";
    capi_resid_as_array = ndarray_from_pyobj(  NPY_DOUBLE,1,resid_Dims,resid_Rank,  capi_resid_intent,resid_capi,capi_errmess);
    if (capi_resid_as_array == NULL) {
        PyObject* capi_err = PyErr_Occurred();
        if (capi_err == NULL) {
            capi_err = _arpack_error;
            PyErr_SetString(capi_err, capi_errmess);
        }
    } else {
        resid = (double *)(PyArray_DATA(capi_resid_as_array));

    /* Processing variable v */
    ;
    capi_v_intent |= F2PY_INTENT_IN|F2PY_INTENT_OUT;
    const char * capi_errmess = "_arpack._arpack.dnaupd: failed to create array from the 7th argument `v`";
    capi_v_as_array = ndarray_from_pyobj(  NPY_DOUBLE,1,v_Dims,v_Rank,  capi_v_intent,v_capi,capi_errmess);
    if (capi_v_as_array == NULL) {
        PyObject* capi_err = PyErr_Occurred();
        if (capi_err == NULL) {
            capi_err = _arpack_error;
            PyErr_SetString(capi_err, capi_errmess);
        }
    } else {
        v = (double *)(PyArray_DATA(capi_v_as_array));

    /* Processing variable iparam */
    iparam_Dims[0]=11;
    capi_iparam_intent |= F2PY_INTENT_IN|F2PY_INTENT_OUT;
    const char * capi_errmess = "_arpack._arpack.dnaupd: failed to create array from the 8th argument `iparam`";
    capi_iparam_as_array = ndarray_from_pyobj(  NPY_INT,1,iparam_Dims,iparam_Rank,  capi_iparam_intent,iparam_capi,capi_errmess);
    if (capi_iparam_as_array == NULL) {
        PyObject* capi_err = PyErr_Occurred();
        if (capi_err == NULL) {
            capi_err = _arpack_error;
            PyErr_SetString(capi_err, capi_errmess);
        }
    } else {
        iparam = (int *)(PyArray_DATA(capi_iparam_as_array));

    /* Processing variable ipntr */
    ipntr_Dims[0]=14;
    capi_ipntr_intent |= F2PY_INTENT_IN|F2PY_INTENT_OUT;
    const char * capi_errmess = "_arpack._arpack.dnaupd: failed to create array from the 9th argument `ipntr`";
    capi_ipntr_as_array = ndarray_from_pyobj(  NPY_INT,1,ipntr_Dims,ipntr_Rank,  capi_ipntr_intent,ipntr_capi,capi_errmess);
    if (capi_ipntr_as_array == NULL) {
        PyObject* capi_err = PyErr_Occurred();
        if (capi_err == NULL) {
            capi_err = _arpack_error;
            PyErr_SetString(capi_err, capi_errmess);
        }
    } else {
        ipntr = (int *)(PyArray_DATA(capi_ipntr_as_array));

    /* Processing variable workl */
    ;
    capi_workl_intent |= F2PY_INTENT_INOUT;
    const char * capi_errmess = "_arpack._arpack.dnaupd: failed to create array from the 11st argument `workl`";
    capi_workl_as_array = ndarray_from_pyobj(  NPY_DOUBLE,1,workl_Dims,workl_Rank,  capi_workl_intent,workl_capi,capi_errmess);
    if (capi_workl_as_array == NULL) {
        PyObject* capi_err = PyErr_Occurred();
        if (capi_err == NULL) {
            capi_err = _arpack_error;
            PyErr_SetString(capi_err, capi_errmess);
        }
    } else {
        workl = (double *)(PyArray_DATA(capi_workl_as_array));

    /* Processing variable info */
        f2py_success = int_from_pyobj(&info,info_capi,"_arpack.dnaupd() 12nd argument (info) can't be converted to int");
    if (f2py_success) {
    /* Processing variable n */
    if (n_capi == Py_None) n = len(resid); else
        f2py_success = int_from_pyobj(&n,n_capi,"_arpack.dnaupd() 1st keyword (n) can't be converted to int");
    if (f2py_success) {
    CHECKSCALAR(len(resid)>=n,"len(resid)>=n","1st keyword n","dnaupd:n=%d",n) {
    /* Processing variable ncv */
    if (ncv_capi == Py_None) ncv = shape(v,1); else
        f2py_success = int_from_pyobj(&ncv,ncv_capi,"_arpack.dnaupd() 2nd keyword (ncv) can't be converted to int");
    if (f2py_success) {
    CHECKSCALAR(shape(v,1)==ncv,"shape(v,1)==ncv","2nd keyword ncv","dnaupd:ncv=%d",ncv) {
    /* Processing variable ldv */
    if (ldv_capi == Py_None) ldv = shape(v,0); else
        f2py_success = int_from_pyobj(&ldv,ldv_capi,"_arpack.dnaupd() 3rd keyword (ldv) can't be converted to int");
    if (f2py_success) {
    CHECKSCALAR(shape(v,0)==ldv,"shape(v,0)==ldv","3rd keyword ldv","dnaupd:ldv=%d",ldv) {
    /* Processing variable workd */
    workd_Dims[0]=3 * n;
    capi_workd_intent |= F2PY_INTENT_INOUT;
    const char * capi_errmess = "_arpack._arpack.dnaupd: failed to create array from the 10th argument `workd`";
    capi_workd_as_array = ndarray_from_pyobj(  NPY_DOUBLE,1,workd_Dims,workd_Rank,  capi_workd_intent,workd_capi,capi_errmess);
    if (capi_workd_as_array == NULL) {
        PyObject* capi_err = PyErr_Occurred();
        if (capi_err == NULL) {
            capi_err = _arpack_error;
            PyErr_SetString(capi_err, capi_errmess);
        }
    } else {
        workd = (double *)(PyArray_DATA(capi_workd_as_array));

    /* Processing variable lworkl */
    if (lworkl_capi == Py_None) lworkl = len(workl); else
        f2py_success = int_from_pyobj(&lworkl,lworkl_capi,"_arpack.dnaupd() 4th keyword (lworkl) can't be converted to int");
    if (f2py_success) {
    CHECKSCALAR(len(workl)>=lworkl,"len(workl)>=lworkl","4th keyword lworkl","dnaupd:lworkl=%d",lworkl) {
/*end of frompyobj*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_call_clock();
#endif
/*callfortranroutine*/
            Py_BEGIN_ALLOW_THREADS
                (*f2py_func)(&ido,bmat,&n,which,&nev,&tol,resid,&ncv,v,&ldv,iparam,ipntr,workd,workl,&lworkl,&info,slen(bmat),slen(which));
            Py_END_ALLOW_THREADS
if (PyErr_Occurred())
  f2py_success = 0;
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_call_clock();
#endif
/*end of callfortranroutine*/
        if (f2py_success) {
/*pyobjfrom*/
/*end of pyobjfrom*/
        CFUNCSMESS("Building return value.\n");
        capi_buildvalue = Py_BuildValue("idNNNNi",ido,tol,capi_resid_as_array,capi_v_as_array,capi_iparam_as_array,capi_ipntr_as_array,info);
/*closepyobjfrom*/
/*end of closepyobjfrom*/
        } /*if (f2py_success) after callfortranroutine*/
/*cleanupfrompyobj*/
    } /*CHECKSCALAR(len(workl)>=lworkl)*/
    } /*if (f2py_success) of lworkl*/
    /* End of cleaning variable lworkl */
    if((PyObject *)capi_workd_as_array!=workd_capi) {
        Py_XDECREF(capi_workd_as_array); }
    }  /* if (capi_workd_as_array == NULL) ... else of workd */
    /* End of cleaning variable workd */
    } /*CHECKSCALAR(shape(v,0)==ldv)*/
    } /*if (f2py_success) of ldv*/
    /* End of cleaning variable ldv */
    } /*CHECKSCALAR(shape(v,1)==ncv)*/
    } /*if (f2py_success) of ncv*/
    /* End of cleaning variable ncv */
    } /*CHECKSCALAR(len(resid)>=n)*/
    } /*if (f2py_success) of n*/
    /* End of cleaning variable n */
    } /*if (f2py_success) of info*/
    /* End of cleaning variable info */
    if((PyObject *)capi_workl_as_array!=workl_capi) {
        Py_XDECREF(capi_workl_as_array); }
    }  /* if (capi_workl_as_array == NULL) ... else of workl */
    /* End of cleaning variable workl */
    }  /* if (capi_ipntr_as_array == NULL) ... else of ipntr */
    /* End of cleaning variable ipntr */
    }  /* if (capi_iparam_as_array == NULL) ... else of iparam */
    /* End of cleaning variable iparam */
    }  /* if (capi_v_as_array == NULL) ... else of v */
    /* End of cleaning variable v */
    }  /* if (capi_resid_as_array == NULL) ... else of resid */
    /* End of cleaning variable resid */
    } /*if (f2py_success) of tol*/
    /* End of cleaning variable tol */
    } /*if (f2py_success) of nev*/
    /* End of cleaning variable nev */
        STRINGFREE(which);
    }  /*if (f2py_success) of which*/
    /* End of cleaning variable which */
        STRINGFREE(bmat);
    }  /*if (f2py_success) of bmat*/
    /* End of cleaning variable bmat */
    } /*if (f2py_success) of ido*/
    /* End of cleaning variable ido */
/*end of cleanupfrompyobj*/
    if (capi_buildvalue == NULL) {
/*routdebugfailure*/
    } else {
/*routdebugleave*/
    }
    CFUNCSMESS("Freeing memory.\n");
/*freemem*/
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_clock();
#endif
    return capi_buildvalue;
}
/******************************* end of dnaupd *******************************/

/*********************************** sneupd ***********************************/
static char doc_f2py_rout__arpack_sneupd[] = "\
dr,di,z,info = sneupd(rvec,howmny,select,sigmar,sigmai,workev,bmat,which,nev,tol,resid,v,iparam,ipntr,workd,workl,info,[ldz,n,ncv,ldv,lworkl])\n\nWrapper for ``sneupd``.\
\n\nParameters\n----------\n"
"rvec : input int\n"
"howmny : input bytes\n"
"select : input rank-1 array('i') with bounds (ncv)\n"
"sigmar : input float\n"
"sigmai : input float\n"
"workev : input rank-1 array('f') with bounds (3 * ncv)\n"
"bmat : input bytes\n"
"which : input string(len=2)\n"
"nev : input int\n"
"tol : input float\n"
"resid : input rank-1 array('f') with bounds (n)\n"
"v : input rank-2 array('f') with bounds (n,ncv)\n"
"iparam : input rank-1 array('i') with bounds (11)\n"
"ipntr : input rank-1 array('i') with bounds (14)\n"
"workd : input rank-1 array('f') with bounds (3 * n)\n"
"workl : input rank-1 array('f') with bounds (lworkl)\n"
"info : input int\n"
"\nOther Parameters\n----------------\n"
"ldz : input int, optional\n    Default: shape(z,0)\n"
"n : input int, optional\n    Default: len(resid)\n"
"ncv : input int, optional\n    Default: len(select)\n"
"ldv : input int, optional\n    Default: shape(v,0)\n"
"lworkl : input int, optional\n    Default: len(workl)\n"
"\nReturns\n-------\n"
"dr : rank-1 array('f') with bounds (1 + nev)\n"
"di : rank-1 array('f') with bounds (1 + nev)\n"
"z : rank-2 array('f') with bounds (n,1 + nev)\n"
"info : int";
/* extern void F_FUNC(sneupd,SNEUPD)(int*,character*,int*,float*,float*,float*,int*,float*,float*,float*,character*,int*,string,int*,float*,float*,int*,float*,int*,int*,int*,float*,float*,int*,int*,size_t); */
static PyObject *f2py_rout__arpack_sneupd(const PyObject *capi_self,
                           PyObject *capi_args,
                           PyObject *capi_keywds,
                           void (*f2py_func)(int*,character*,int*,float*,float*,float*,int*,float*,float*,float*,character*,int*,string,int*,float*,float*,int*,float*,int*,int*,int*,float*,float*,int*,int*,size_t)) {
    PyObject * volatile capi_buildvalue = NULL;
    volatile int f2py_success = 1;
/*decl*/

    int rvec = 0;
    PyObject *rvec_capi = Py_None;
    character howmny = 0;
    PyObject *howmny_capi = Py_None;
    int *select = NULL;
    npy_intp select_Dims[1] = {-1};
    const int select_Rank = 1;
    PyArrayObject *capi_select_as_array = NULL;
    int capi_select_intent = 0;
    PyObject *select_capi = Py_None;
    float *dr = NULL;
    npy_intp dr_Dims[1] = {-1};
    const int dr_Rank = 1;
    PyArrayObject *capi_dr_as_array = NULL;
    int capi_dr_intent = 0;
    float *di = NULL;
    npy_intp di_Dims[1] = {-1};
    const int di_Rank = 1;
    PyArrayObject *capi_di_as_array = NULL;
    int capi_di_intent = 0;
    float *z = NULL;
    npy_intp z_Dims[2] = {-1, -1};
    const int z_Rank = 2;
    PyArrayObject *capi_z_as_array = NULL;
    int capi_z_intent = 0;
    int ldz = 0;
    PyObject *ldz_capi = Py_None;
    float sigmar = 0;
    PyObject *sigmar_capi = Py_None;
    float sigmai = 0;
    PyObject *sigmai_capi = Py_None;
    float *workev = NULL;
    npy_intp workev_Dims[1] = {-1};
    const int workev_Rank = 1;
    PyArrayObject *capi_workev_as_array = NULL;
    int capi_workev_intent = 0;
    PyObject *workev_capi = Py_None;
    character bmat = 0;
    PyObject *bmat_capi = Py_None;
    int n = 0;
    PyObject *n_capi = Py_None;
    string which = NULL;
    int slen(which);
    PyObject *which_capi = Py_None;
    int nev = 0;
    PyObject *nev_capi = Py_None;
    float tol = 0;
    PyObject *tol_capi = Py_None;
    float *resid = NULL;
    npy_intp resid_Dims[1] = {-1};
    const int resid_Rank = 1;
    PyArrayObject *capi_resid_as_array = NULL;
    int capi_resid_intent = 0;
    PyObject *resid_capi = Py_None;
    int ncv = 0;
    PyObject *ncv_capi = Py_None;
    float *v = NULL;
    npy_intp v_Dims[2] = {-1, -1};
    const int v_Rank = 2;
    PyArrayObject *capi_v_as_array = NULL;
    int capi_v_intent = 0;
    PyObject *v_capi = Py_None;
    int ldv = 0;
    PyObject *ldv_capi = Py_None;
    int *iparam = NULL;
    npy_intp iparam_Dims[1] = {-1};
    const int iparam_Rank = 1;
    PyArrayObject *capi_iparam_as_array = NULL;
    int capi_iparam_intent = 0;
    PyObject *iparam_capi = Py_None;
    int *ipntr = NULL;
    npy_intp ipntr_Dims[1] = {-1};
    const int ipntr_Rank = 1;
    PyArrayObject *capi_ipntr_as_array = NULL;
    int capi_ipntr_intent = 0;
    PyObject *ipntr_capi = Py_None;
    float *workd = NULL;
    npy_intp workd_Dims[1] = {-1};
    const int workd_Rank = 1;
    PyArrayObject *capi_workd_as_array = NULL;
    int capi_workd_intent = 0;
    PyObject *workd_capi = Py_None;
    float *workl = NULL;
    npy_intp workl_Dims[1] = {-1};
    const int workl_Rank = 1;
    PyArrayObject *capi_workl_as_array = NULL;
    int capi_workl_intent = 0;
    PyObject *workl_capi = Py_None;
    int lworkl = 0;
    PyObject *lworkl_capi = Py_None;
    int info = 0;
    PyObject *info_capi = Py_None;
    static char *capi_kwlist[] = {"rvec","howmny","select","sigmar","sigmai","workev","bmat","which","nev","tol","resid","v","iparam","ipntr","workd","workl","info","ldz","n","ncv","ldv","lworkl",NULL};

/*routdebugenter*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_clock();
#endif
    if (!PyArg_ParseTupleAndKeywords(capi_args,capi_keywds,\
        "OOOOOOOOOOOOOOOOO|OOOOO:_arpack.sneupd",\
        capi_kwlist,&rvec_capi,&howmny_capi,&select_capi,&sigmar_capi,&sigmai_capi,&workev_capi,&bmat_capi,&which_capi,&nev_capi,&tol_capi,&resid_capi,&v_capi,&iparam_capi,&ipntr_capi,&workd_capi,&workl_capi,&info_capi,&ldz_capi,&n_capi,&ncv_capi,&ldv_capi,&lworkl_capi))
        return NULL;
/*frompyobj*/
    /* Processing variable rvec */
        rvec = (int)PyObject_IsTrue(rvec_capi);
        f2py_success = 1;
    if (f2py_success) {
    /* Processing variable howmny */
        f2py_success = character_from_pyobj(&howmny,howmny_capi,"_arpack.sneupd() 2nd argument (howmny) can't be converted to character");
    if (f2py_success) {
    /* Processing variable select */
    ;
    capi_select_intent |= F2PY_INTENT_IN;
    const char * capi_errmess = "_arpack._arpack.sneupd: failed to create array from the 3rd argument `select`";
    capi_select_as_array = ndarray_from_pyobj(  NPY_INT,1,select_Dims,select_Rank,  capi_select_intent,select_capi,capi_errmess);
    if (capi_select_as_array == NULL) {
        PyObject* capi_err = PyErr_Occurred();
        if (capi_err == NULL) {
            capi_err = _arpack_error;
            PyErr_SetString(capi_err, capi_errmess);
        }
    } else {
        select = (int *)(PyArray_DATA(capi_select_as_array));

    /* Processing variable sigmar */
        f2py_success = float_from_pyobj(&sigmar,sigmar_capi,"_arpack.sneupd() 4th argument (sigmar) can't be converted to float");
    if (f2py_success) {
    /* Processing variable sigmai */
        f2py_success = float_from_pyobj(&sigmai,sigmai_capi,"_arpack.sneupd() 5th argument (sigmai) can't be converted to float");
    if (f2py_success) {
    /* Processing variable bmat */
        f2py_success = character_from_pyobj(&bmat,bmat_capi,"_arpack.sneupd() 7th argument (bmat) can't be converted to character");
    if (f2py_success) {
    /* Processing variable which */
    slen(which) = 2;
    f2py_success = string_from_pyobj(&which,&slen(which),"",which_capi,"string_from_pyobj failed in converting 8th argument`which' of _arpack.sneupd to C string");
    if (f2py_success) {
        STRINGPADN(which, slen(which), '\0', ' ');
    /* Processing variable nev */
        f2py_success = int_from_pyobj(&nev,nev_capi,"_arpack.sneupd() 9th argument (nev) can't be converted to int");
    if (f2py_success) {
    /* Processing variable tol */
        f2py_success = float_from_pyobj(&tol,tol_capi,"_arpack.sneupd() 10th argument (tol) can't be converted to float");
    if (f2py_success) {
    /* Processing variable resid */
    ;
    capi_resid_intent |= F2PY_INTENT_IN;
    const char * capi_errmess = "_arpack._arpack.sneupd: failed to create array from the 11st argument `resid`";
    capi_resid_as_array = ndarray_from_pyobj(  NPY_FLOAT,1,resid_Dims,resid_Rank,  capi_resid_intent,resid_capi,capi_errmess);
    if (capi_resid_as_array == NULL) {
        PyObject* capi_err = PyErr_Occurred();
        if (capi_err == NULL) {
            capi_err = _arpack_error;
            PyErr_SetString(capi_err, capi_errmess);
        }
    } else {
        resid = (float *)(PyArray_DATA(capi_resid_as_array));

    /* Processing variable iparam */
    iparam_Dims[0]=11;
    capi_iparam_intent |= F2PY_INTENT_IN;
    const char * capi_errmess = "_arpack._arpack.sneupd: failed to create array from the 13rd argument `iparam`";
    capi_iparam_as_array = ndarray_from_pyobj(  NPY_INT,1,iparam_Dims,iparam_Rank,  capi_iparam_intent,iparam_capi,capi_errmess);
    if (capi_iparam_as_array == NULL) {
        PyObject* capi_err = PyErr_Occurred();
        if (capi_err == NULL) {
            capi_err = _arpack_error;
            PyErr_SetString(capi_err, capi_errmess);
        }
    } else {
        iparam = (int *)(PyArray_DATA(capi_iparam_as_array));

    /* Processing variable ipntr */
    ipntr_Dims[0]=14;
    capi_ipntr_intent |= F2PY_INTENT_IN;
    const char * capi_errmess = "_arpack._arpack.sneupd: failed to create array from the 14th argument `ipntr`";
    capi_ipntr_as_array = ndarray_from_pyobj(  NPY_INT,1,ipntr_Dims,ipntr_Rank,  capi_ipntr_intent,ipntr_capi,capi_errmess);
    if (capi_ipntr_as_array == NULL) {
        PyObject* capi_err = PyErr_Occurred();
        if (capi_err == NULL) {
            capi_err = _arpack_error;
            PyErr_SetString(capi_err, capi_errmess);
        }
    } else {
        ipntr = (int *)(PyArray_DATA(capi_ipntr_as_array));

    /* Processing variable workl */
    ;
    capi_workl_intent |= F2PY_INTENT_IN;
    const char * capi_errmess = "_arpack._arpack.sneupd: failed to create array from the 16th argument `workl`";
    capi_workl_as_array = ndarray_from_pyobj(  NPY_FLOAT,1,workl_Dims,workl_Rank,  capi_workl_intent,workl_capi,capi_errmess);
    if (capi_workl_as_array == NULL) {
        PyObject* capi_err = PyErr_Occurred();
        if (capi_err == NULL) {
            capi_err = _arpack_error;
            PyErr_SetString(capi_err, capi_errmess);
        }
    } else {
        workl = (float *)(PyArray_DATA(capi_workl_as_array));

    /* Processing variable info */
        f2py_success = int_from_pyobj(&info,info_capi,"_arpack.sneupd() 17th argument (info) can't be converted to int");
    if (f2py_success) {
    /* Processing variable dr */
    dr_Dims[0]=1 + nev;
    capi_dr_intent |= F2PY_INTENT_OUT|F2PY_INTENT_HIDE;
    const char * capi_errmess = "_arpack._arpack.sneupd: failed to create array from the hidden `dr`";
    capi_dr_as_array = ndarray_from_pyobj(  NPY_FLOAT,1,dr_Dims,dr_Rank,  capi_dr_intent,Py_None,capi_errmess);
    if (capi_dr_as_array == NULL) {
        PyObject* capi_err = PyErr_Occurred();
        if (capi_err == NULL) {
            capi_err = _arpack_error;
            PyErr_SetString(capi_err, capi_errmess);
        }
    } else {
        dr = (float *)(PyArray_DATA(capi_dr_as_array));

    /* Processing variable di */
    di_Dims[0]=1 + nev;
    capi_di_intent |= F2PY_INTENT_OUT|F2PY_INTENT_HIDE;
    const char * capi_errmess = "_arpack._arpack.sneupd: failed to create array from the hidden `di`";
    capi_di_as_array = ndarray_from_pyobj(  NPY_FLOAT,1,di_Dims,di_Rank,  capi_di_intent,Py_None,capi_errmess);
    if (capi_di_as_array == NULL) {
        PyObject* capi_err = PyErr_Occurred();
        if (capi_err == NULL) {
            capi_err = _arpack_error;
            PyErr_SetString(capi_err, capi_errmess);
        }
    } else {
        di = (float *)(PyArray_DATA(capi_di_as_array));

    /* Processing variable n */
    if (n_capi == Py_None) n = len(resid); else
        f2py_success = int_from_pyobj(&n,n_capi,"_arpack.sneupd() 2nd keyword (n) can't be converted to int");
    if (f2py_success) {
    CHECKSCALAR(len(resid)>=n,"len(resid)>=n","2nd keyword n","sneupd:n=%d",n) {
    /* Processing variable ncv */
    if (ncv_capi == Py_None) ncv = len(select); else
        f2py_success = int_from_pyobj(&ncv,ncv_capi,"_arpack.sneupd() 3rd keyword (ncv) can't be converted to int");
    if (f2py_success) {
    CHECKSCALAR(len(select)>=ncv,"len(select)>=ncv","3rd keyword ncv","sneupd:ncv=%d",ncv) {
    /* Processing variable v */
    v_Dims[0]=n,v_Dims[1]=ncv;
    capi_v_intent |= F2PY_INTENT_IN;
    const char * capi_errmess = "_arpack._arpack.sneupd: failed to create array from the 12nd argument `v`";
    capi_v_as_array = ndarray_from_pyobj(  NPY_FLOAT,1,v_Dims,v_Rank,  capi_v_intent,v_capi,capi_errmess);
    if (capi_v_as_array == NULL) {
        PyObject* capi_err = PyErr_Occurred();
        if (capi_err == NULL) {
            capi_err = _arpack_error;
            PyErr_SetString(capi_err, capi_errmess);
        }
    } else {
        v = (float *)(PyArray_DATA(capi_v_as_array));

    /* Processing variable ldv */
    if (ldv_capi == Py_None) ldv = shape(v,0); else
        f2py_success = int_from_pyobj(&ldv,ldv_capi,"_arpack.sneupd() 4th keyword (ldv) can't be converted to int");
    if (f2py_success) {
    CHECKSCALAR(shape(v,0)==ldv,"shape(v,0)==ldv","4th keyword ldv","sneupd:ldv=%d",ldv) {
    /* Processing variable workd */
    workd_Dims[0]=3 * n;
    capi_workd_intent |= F2PY_INTENT_IN;
    const char * capi_errmess = "_arpack._arpack.sneupd: failed to create array from the 15th argument `workd`";
    capi_workd_as_array = ndarray_from_pyobj(  NPY_FLOAT,1,workd_Dims,workd_Rank,  capi_workd_intent,workd_capi,capi_errmess);
    if (capi_workd_as_array == NULL) {
        PyObject* capi_err = PyErr_Occurred();
        if (capi_err == NULL) {
            capi_err = _arpack_error;
            PyErr_SetString(capi_err, capi_errmess);
        }
    } else {
        workd = (float *)(PyArray_DATA(capi_workd_as_array));

    /* Processing variable lworkl */
    if (lworkl_capi == Py_None) lworkl = len(workl); else
        f2py_success = int_from_pyobj(&lworkl,lworkl_capi,"_arpack.sneupd() 5th keyword (lworkl) can't be converted to int");
    if (f2py_success) {
    CHECKSCALAR(len(workl)>=lworkl,"len(workl)>=lworkl","5th keyword lworkl","sneupd:lworkl=%d",lworkl) {
    /* Processing variable z */
    z_Dims[0]=n,z_Dims[1]=1 + nev;
    capi_z_intent |= F2PY_INTENT_OUT|F2PY_INTENT_HIDE;
    const char * capi_errmess = "_arpack._arpack.sneupd: failed to create array from the hidden `z`";
    capi_z_as_array = ndarray_from_pyobj(  NPY_FLOAT,1,z_Dims,z_Rank,  capi_z_intent,Py_None,capi_errmess);
    if (capi_z_as_array == NULL) {
        PyObject* capi_err = PyErr_Occurred();
        if (capi_err == NULL) {
            capi_err = _arpack_error;
            PyErr_SetString(capi_err, capi_errmess);
        }
    } else {
        z = (float *)(PyArray_DATA(capi_z_as_array));

    /* Processing variable ldz */
    if (ldz_capi == Py_None) ldz = shape(z,0); else
        f2py_success = int_from_pyobj(&ldz,ldz_capi,"_arpack.sneupd() 1st keyword (ldz) can't be converted to int");
    if (f2py_success) {
    CHECKSCALAR(shape(z,0)==ldz,"shape(z,0)==ldz","1st keyword ldz","sneupd:ldz=%d",ldz) {
    /* Processing variable workev */
    workev_Dims[0]=3 * ncv;
    capi_workev_intent |= F2PY_INTENT_IN;
    const char * capi_errmess = "_arpack._arpack.sneupd: failed to create array from the 6th argument `workev`";
    capi_workev_as_array = ndarray_from_pyobj(  NPY_FLOAT,1,workev_Dims,workev_Rank,  capi_workev_intent,workev_capi,capi_errmess);
    if (capi_workev_as_array == NULL) {
        PyObject* capi_err = PyErr_Occurred();
        if (capi_err == NULL) {
            capi_err = _arpack_error;
            PyErr_SetString(capi_err, capi_errmess);
        }
    } else {
        workev = (float *)(PyArray_DATA(capi_workev_as_array));

/*end of frompyobj*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_call_clock();
#endif
/*callfortranroutine*/
            Py_BEGIN_ALLOW_THREADS
                (*f2py_func)(&rvec,&howmny,select,dr,di,z,&ldz,&sigmar,&sigmai,workev,&bmat,&n,which,&nev,&tol,resid,&ncv,v,&ldv,iparam,ipntr,workd,workl,&lworkl,&info,slen(which));
            Py_END_ALLOW_THREADS
if (PyErr_Occurred())
  f2py_success = 0;
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_call_clock();
#endif
/*end of callfortranroutine*/
        if (f2py_success) {
/*pyobjfrom*/
/*end of pyobjfrom*/
        CFUNCSMESS("Building return value.\n");
        capi_buildvalue = Py_BuildValue("NNNi",capi_dr_as_array,capi_di_as_array,capi_z_as_array,info);
/*closepyobjfrom*/
/*end of closepyobjfrom*/
        } /*if (f2py_success) after callfortranroutine*/
/*cleanupfrompyobj*/
    if((PyObject *)capi_workev_as_array!=workev_capi) {
        Py_XDECREF(capi_workev_as_array); }
    }  /* if (capi_workev_as_array == NULL) ... else of workev */
    /* End of cleaning variable workev */
    } /*CHECKSCALAR(shape(z,0)==ldz)*/
    } /*if (f2py_success) of ldz*/
    /* End of cleaning variable ldz */
    }  /* if (capi_z_as_array == NULL) ... else of z */
    /* End of cleaning variable z */
    } /*CHECKSCALAR(len(workl)>=lworkl)*/
    } /*if (f2py_success) of lworkl*/
    /* End of cleaning variable lworkl */
    if((PyObject *)capi_workd_as_array!=workd_capi) {
        Py_XDECREF(capi_workd_as_array); }
    }  /* if (capi_workd_as_array == NULL) ... else of workd */
    /* End of cleaning variable workd */
    } /*CHECKSCALAR(shape(v,0)==ldv)*/
    } /*if (f2py_success) of ldv*/
    /* End of cleaning variable ldv */
    if((PyObject *)capi_v_as_array!=v_capi) {
        Py_XDECREF(capi_v_as_array); }
    }  /* if (capi_v_as_array == NULL) ... else of v */
    /* End of cleaning variable v */
    } /*CHECKSCALAR(len(select)>=ncv)*/
    } /*if (f2py_success) of ncv*/
    /* End of cleaning variable ncv */
    } /*CHECKSCALAR(len(resid)>=n)*/
    } /*if (f2py_success) of n*/
    /* End of cleaning variable n */
    }  /* if (capi_di_as_array == NULL) ... else of di */
    /* End of cleaning variable di */
    }  /* if (capi_dr_as_array == NULL) ... else of dr */
    /* End of cleaning variable dr */
    } /*if (f2py_success) of info*/
    /* End of cleaning variable info */
    if((PyObject *)capi_workl_as_array!=workl_capi) {
        Py_XDECREF(capi_workl_as_array); }
    }  /* if (capi_workl_as_array == NULL) ... else of workl */
    /* End of cleaning variable workl */
    if((PyObject *)capi_ipntr_as_array!=ipntr_capi) {
        Py_XDECREF(capi_ipntr_as_array); }
    }  /* if (capi_ipntr_as_array == NULL) ... else of ipntr */
    /* End of cleaning variable ipntr */
    if((PyObject *)capi_iparam_as_array!=iparam_capi) {
        Py_XDECREF(capi_iparam_as_array); }
    }  /* if (capi_iparam_as_array == NULL) ... else of iparam */
    /* End of cleaning variable iparam */
    if((PyObject *)capi_resid_as_array!=resid_capi) {
        Py_XDECREF(capi_resid_as_array); }
    }  /* if (capi_resid_as_array == NULL) ... else of resid */
    /* End of cleaning variable resid */
    } /*if (f2py_success) of tol*/
    /* End of cleaning variable tol */
    } /*if (f2py_success) of nev*/
    /* End of cleaning variable nev */
        STRINGFREE(which);
    }  /*if (f2py_success) of which*/
    /* End of cleaning variable which */
    } /*if (f2py_success) of bmat*/
    /* End of cleaning variable bmat */
    } /*if (f2py_success) of sigmai*/
    /* End of cleaning variable sigmai */
    } /*if (f2py_success) of sigmar*/
    /* End of cleaning variable sigmar */
    if((PyObject *)capi_select_as_array!=select_capi) {
        Py_XDECREF(capi_select_as_array); }
    }  /* if (capi_select_as_array == NULL) ... else of select */
    /* End of cleaning variable select */
    } /*if (f2py_success) of howmny*/
    /* End of cleaning variable howmny */
    } /*if (f2py_success) of rvec*/
    /* End of cleaning variable rvec */
/*end of cleanupfrompyobj*/
    if (capi_buildvalue == NULL) {
/*routdebugfailure*/
    } else {
/*routdebugleave*/
    }
    CFUNCSMESS("Freeing memory.\n");
/*freemem*/
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_clock();
#endif
    return capi_buildvalue;
}
/******************************* end of sneupd *******************************/

/*********************************** dneupd ***********************************/
static char doc_f2py_rout__arpack_dneupd[] = "\
dr,di,z,info = dneupd(rvec,howmny,select,sigmar,sigmai,workev,bmat,which,nev,tol,resid,v,iparam,ipntr,workd,workl,info,[ldz,n,ncv,ldv,lworkl])\n\nWrapper for ``dneupd``.\
\n\nParameters\n----------\n"
"rvec : input int\n"
"howmny : input bytes\n"
"select : input rank-1 array('i') with bounds (ncv)\n"
"sigmar : input float\n"
"sigmai : input float\n"
"workev : input rank-1 array('d') with bounds (3 * ncv)\n"
"bmat : input bytes\n"
"which : input string(len=2)\n"
"nev : input int\n"
"tol : input float\n"
"resid : input rank-1 array('d') with bounds (n)\n"
"v : input rank-2 array('d') with bounds (n,ncv)\n"
"iparam : input rank-1 array('i') with bounds (11)\n"
"ipntr : input rank-1 array('i') with bounds (14)\n"
"workd : input rank-1 array('d') with bounds (3 * n)\n"
"workl : input rank-1 array('d') with bounds (lworkl)\n"
"info : input int\n"
"\nOther Parameters\n----------------\n"
"ldz : input int, optional\n    Default: shape(z,0)\n"
"n : input int, optional\n    Default: len(resid)\n"
"ncv : input int, optional\n    Default: len(select)\n"
"ldv : input int, optional\n    Default: shape(v,0)\n"
"lworkl : input int, optional\n    Default: len(workl)\n"
"\nReturns\n-------\n"
"dr : rank-1 array('d') with bounds (1 + nev)\n"
"di : rank-1 array('d') with bounds (1 + nev)\n"
"z : rank-2 array('d') with bounds (n,1 + nev)\n"
"info : int";
/* extern void F_FUNC(dneupd,DNEUPD)(int*,character*,int*,double*,double*,double*,int*,double*,double*,double*,character*,int*,string,int*,double*,double*,int*,double*,int*,int*,int*,double*,double*,int*,int*,size_t); */
static PyObject *f2py_rout__arpack_dneupd(const PyObject *capi_self,
                           PyObject *capi_args,
                           PyObject *capi_keywds,
                           void (*f2py_func)(int*,character*,int*,double*,double*,double*,int*,double*,double*,double*,character*,int*,string,int*,double*,double*,int*,double*,int*,int*,int*,double*,double*,int*,int*,size_t)) {
    PyObject * volatile capi_buildvalue = NULL;
    volatile int f2py_success = 1;
/*decl*/

    int rvec = 0;
    PyObject *rvec_capi = Py_None;
    character howmny = 0;
    PyObject *howmny_capi = Py_None;
    int *select = NULL;
    npy_intp select_Dims[1] = {-1};
    const int select_Rank = 1;
    PyArrayObject *capi_select_as_array = NULL;
    int capi_select_intent = 0;
    PyObject *select_capi = Py_None;
    double *dr = NULL;
    npy_intp dr_Dims[1] = {-1};
    const int dr_Rank = 1;
    PyArrayObject *capi_dr_as_array = NULL;
    int capi_dr_intent = 0;
    double *di = NULL;
    npy_intp di_Dims[1] = {-1};
    const int di_Rank = 1;
    PyArrayObject *capi_di_as_array = NULL;
    int capi_di_intent = 0;
    double *z = NULL;
    npy_intp z_Dims[2] = {-1, -1};
    const int z_Rank = 2;
    PyArrayObject *capi_z_as_array = NULL;
    int capi_z_intent = 0;
    int ldz = 0;
    PyObject *ldz_capi = Py_None;
    double sigmar = 0;
    PyObject *sigmar_capi = Py_None;
    double sigmai = 0;
    PyObject *sigmai_capi = Py_None;
    double *workev = NULL;
    npy_intp workev_Dims[1] = {-1};
    const int workev_Rank = 1;
    PyArrayObject *capi_workev_as_array = NULL;
    int capi_workev_intent = 0;
    PyObject *workev_capi = Py_None;
    character bmat = 0;
    PyObject *bmat_capi = Py_None;
    int n = 0;
    PyObject *n_capi = Py_None;
    string which = NULL;
    int slen(which);
    PyObject *which_capi = Py_None;
    int nev = 0;
    PyObject *nev_capi = Py_None;
    double tol = 0;
    PyObject *tol_capi = Py_None;
    double *resid = NULL;
    npy_intp resid_Dims[1] = {-1};
    const int resid_Rank = 1;
    PyArrayObject *capi_resid_as_array = NULL;
    int capi_resid_intent = 0;
    PyObject *resid_capi = Py_None;
    int ncv = 0;
    PyObject *ncv_capi = Py_None;
    double *v = NULL;
    npy_intp v_Dims[2] = {-1, -1};
    const int v_Rank = 2;
    PyArrayObject *capi_v_as_array = NULL;
    int capi_v_intent = 0;
    PyObject *v_capi = Py_None;
    int ldv = 0;
    PyObject *ldv_capi = Py_None;
    int *iparam = NULL;
    npy_intp iparam_Dims[1] = {-1};
    const int iparam_Rank = 1;
    PyArrayObject *capi_iparam_as_array = NULL;
    int capi_iparam_intent = 0;
    PyObject *iparam_capi = Py_None;
    int *ipntr = NULL;
    npy_intp ipntr_Dims[1] = {-1};
    const int ipntr_Rank = 1;
    PyArrayObject *capi_ipntr_as_array = NULL;
    int capi_ipntr_intent = 0;
    PyObject *ipntr_capi = Py_None;
    double *workd = NULL;
    npy_intp workd_Dims[1] = {-1};
    const int workd_Rank = 1;
    PyArrayObject *capi_workd_as_array = NULL;
    int capi_workd_intent = 0;
    PyObject *workd_capi = Py_None;
    double *workl = NULL;
    npy_intp workl_Dims[1] = {-1};
    const int workl_Rank = 1;
    PyArrayObject *capi_workl_as_array = NULL;
    int capi_workl_intent = 0;
    PyObject *workl_capi = Py_None;
    int lworkl = 0;
    PyObject *lworkl_capi = Py_None;
    int info = 0;
    PyObject *info_capi = Py_None;
    static char *capi_kwlist[] = {"rvec","howmny","select","sigmar","sigmai","workev","bmat","which","nev","tol","resid","v","iparam","ipntr","workd","workl","info","ldz","n","ncv","ldv","lworkl",NULL};

/*routdebugenter*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_clock();
#endif
    if (!PyArg_ParseTupleAndKeywords(capi_args,capi_keywds,\
        "OOOOOOOOOOOOOOOOO|OOOOO:_arpack.dneupd",\
        capi_kwlist,&rvec_capi,&howmny_capi,&select_capi,&sigmar_capi,&sigmai_capi,&workev_capi,&bmat_capi,&which_capi,&nev_capi,&tol_capi,&resid_capi,&v_capi,&iparam_capi,&ipntr_capi,&workd_capi,&workl_capi,&info_capi,&ldz_capi,&n_capi,&ncv_capi,&ldv_capi,&lworkl_capi))
        return NULL;
/*frompyobj*/
    /* Processing variable rvec */
        rvec = (int)PyObject_IsTrue(rvec_capi);
        f2py_success = 1;
    if (f2py_success) {
    /* Processing variable howmny */
        f2py_success = character_from_pyobj(&howmny,howmny_capi,"_arpack.dneupd() 2nd argument (howmny) can't be converted to character");
    if (f2py_success) {
    /* Processing variable select */
    ;
    capi_select_intent |= F2PY_INTENT_IN;
    const char * capi_errmess = "_arpack._arpack.dneupd: failed to create array from the 3rd argument `select`";
    capi_select_as_array = ndarray_from_pyobj(  NPY_INT,1,select_Dims,select_Rank,  capi_select_intent,select_capi,capi_errmess);
    if (capi_select_as_array == NULL) {
        PyObject* capi_err = PyErr_Occurred();
        if (capi_err == NULL) {
            capi_err = _arpack_error;
            PyErr_SetString(capi_err, capi_errmess);
        }
    } else {
        select = (int *)(PyArray_DATA(capi_select_as_array));

    /* Processing variable sigmar */
        f2py_success = double_from_pyobj(&sigmar,sigmar_capi,"_arpack.dneupd() 4th argument (sigmar) can't be converted to double");
    if (f2py_success) {
    /* Processing variable sigmai */
        f2py_success = double_from_pyobj(&sigmai,sigmai_capi,"_arpack.dneupd() 5th argument (sigmai) can't be converted to double");
    if (f2py_success) {
    /* Processing variable bmat */
        f2py_success = character_from_pyobj(&bmat,bmat_capi,"_arpack.dneupd() 7th argument (bmat) can't be converted to character");
    if (f2py_success) {
    /* Processing variable which */
    slen(which) = 2;
    f2py_success = string_from_pyobj(&which,&slen(which),"",which_capi,"string_from_pyobj failed in converting 8th argument`which' of _arpack.dneupd to C string");
    if (f2py_success) {
        STRINGPADN(which, slen(which), '\0', ' ');
    /* Processing variable nev */
        f2py_success = int_from_pyobj(&nev,nev_capi,"_arpack.dneupd() 9th argument (nev) can't be converted to int");
    if (f2py_success) {
    /* Processing variable tol */
        f2py_success = double_from_pyobj(&tol,tol_capi,"_arpack.dneupd() 10th argument (tol) can't be converted to double");
    if (f2py_success) {
    /* Processing variable resid */
    ;
    capi_resid_intent |= F2PY_INTENT_IN;
    const char * capi_errmess = "_arpack._arpack.dneupd: failed to create array from the 11st argument `resid`";
    capi_resid_as_array = ndarray_from_pyobj(  NPY_DOUBLE,1,resid_Dims,resid_Rank,  capi_resid_intent,resid_capi,capi_errmess);
    if (capi_resid_as_array == NULL) {
        PyObject* capi_err = PyErr_Occurred();
        if (capi_err == NULL) {
            capi_err = _arpack_error;
            PyErr_SetString(capi_err, capi_errmess);
        }
    } else {
        resid = (double *)(PyArray_DATA(capi_resid_as_array));

    /* Processing variable iparam */
    iparam_Dims[0]=11;
    capi_iparam_intent |= F2PY_INTENT_IN;
    const char * capi_errmess = "_arpack._arpack.dneupd: failed to create array from the 13rd argument `iparam`";
    capi_iparam_as_array = ndarray_from_pyobj(  NPY_INT,1,iparam_Dims,iparam_Rank,  capi_iparam_intent,iparam_capi,capi_errmess);
    if (capi_iparam_as_array == NULL) {
        PyObject* capi_err = PyErr_Occurred();
        if (capi_err == NULL) {
            capi_err = _arpack_error;
            PyErr_SetString(capi_err, capi_errmess);
        }
    } else {
        iparam = (int *)(PyArray_DATA(capi_iparam_as_array));

    /* Processing variable ipntr */
    ipntr_Dims[0]=14;
    capi_ipntr_intent |= F2PY_INTENT_IN;
    const char * capi_errmess = "_arpack._arpack.dneupd: failed to create array from the 14th argument `ipntr`";
    capi_ipntr_as_array = ndarray_from_pyobj(  NPY_INT,1,ipntr_Dims,ipntr_Rank,  capi_ipntr_intent,ipntr_capi,capi_errmess);
    if (capi_ipntr_as_array == NULL) {
        PyObject* capi_err = PyErr_Occurred();
        if (capi_err == NULL) {
            capi_err = _arpack_error;
            PyErr_SetString(capi_err, capi_errmess);
        }
    } else {
        ipntr = (int *)(PyArray_DATA(capi_ipntr_as_array));

    /* Processing variable workl */
    ;
    capi_workl_intent |= F2PY_INTENT_IN;
    const char * capi_errmess = "_arpack._arpack.dneupd: failed to create array from the 16th argument `workl`";
    capi_workl_as_array = ndarray_from_pyobj(  NPY_DOUBLE,1,workl_Dims,workl_Rank,  capi_workl_intent,workl_capi,capi_errmess);
    if (capi_workl_as_array == NULL) {
        PyObject* capi_err = PyErr_Occurred();
        if (capi_err == NULL) {
            capi_err = _arpack_error;
            PyErr_SetString(capi_err, capi_errmess);
        }
    } else {
        workl = (double *)(PyArray_DATA(capi_workl_as_array));

    /* Processing variable info */
        f2py_success = int_from_pyobj(&info,info_capi,"_arpack.dneupd() 17th argument (info) can't be converted to int");
    if (f2py_success) {
    /* Processing variable dr */
    dr_Dims[0]=1 + nev;
    capi_dr_intent |= F2PY_INTENT_OUT|F2PY_INTENT_HIDE;
    const char * capi_errmess = "_arpack._arpack.dneupd: failed to create array from the hidden `dr`";
    capi_dr_as_array = ndarray_from_pyobj(  NPY_DOUBLE,1,dr_Dims,dr_Rank,  capi_dr_intent,Py_None,capi_errmess);
    if (capi_dr_as_array == NULL) {
        PyObject* capi_err = PyErr_Occurred();
        if (capi_err == NULL) {
            capi_err = _arpack_error;
            PyErr_SetString(capi_err, capi_errmess);
        }
    } else {
        dr = (double *)(PyArray_DATA(capi_dr_as_array));

    /* Processing variable di */
    di_Dims[0]=1 + nev;
    capi_di_intent |= F2PY_INTENT_OUT|F2PY_INTENT_HIDE;
    const char * capi_errmess = "_arpack._arpack.dneupd: failed to create array from the hidden `di`";
    capi_di_as_array = ndarray_from_pyobj(  NPY_DOUBLE,1,di_Dims,di_Rank,  capi_di_intent,Py_None,capi_errmess);
    if (capi_di_as_array == NULL) {
        PyObject* capi_err = PyErr_Occurred();
        if (capi_err == NULL) {
            capi_err = _arpack_error;
            PyErr_SetString(capi_err, capi_errmess);
        }
    } else {
        di = (double *)(PyArray_DATA(capi_di_as_array));

    /* Processing variable n */
    if (n_capi == Py_None) n = len(resid); else
        f2py_success = int_from_pyobj(&n,n_capi,"_arpack.dneupd() 2nd keyword (n) can't be converted to int");
    if (f2py_success) {
    CHECKSCALAR(len(resid)>=n,"len(resid)>=n","2nd keyword n","dneupd:n=%d",n) {
    /* Processing variable ncv */
    if (ncv_capi == Py_None) ncv = len(select); else
        f2py_success = int_from_pyobj(&ncv,ncv_capi,"_arpack.dneupd() 3rd keyword (ncv) can't be converted to int");
    if (f2py_success) {
    CHECKSCALAR(len(select)>=ncv,"len(select)>=ncv","3rd keyword ncv","dneupd:ncv=%d",ncv) {
    /* Processing variable v */
    v_Dims[0]=n,v_Dims[1]=ncv;
    capi_v_intent |= F2PY_INTENT_IN;
    const char * capi_errmess = "_arpack._arpack.dneupd: failed to create array from the 12nd argument `v`";
    capi_v_as_array = ndarray_from_pyobj(  NPY_DOUBLE,1,v_Dims,v_Rank,  capi_v_intent,v_capi,capi_errmess);
    if (capi_v_as_array == NULL) {
        PyObject* capi_err = PyErr_Occurred();
        if (capi_err == NULL) {
            capi_err = _arpack_error;
            PyErr_SetString(capi_err, capi_errmess);
        }
    } else {
        v = (double *)(PyArray_DATA(capi_v_as_array));

    /* Processing variable ldv */
    if (ldv_capi == Py_None) ldv = shape(v,0); else
        f2py_success = int_from_pyobj(&ldv,ldv_capi,"_arpack.dneupd() 4th keyword (ldv) can't be converted to int");
    if (f2py_success) {
    CHECKSCALAR(shape(v,0)==ldv,"shape(v,0)==ldv","4th keyword ldv","dneupd:ldv=%d",ldv) {
    /* Processing variable workd */
    workd_Dims[0]=3 * n;
    capi_workd_intent |= F2PY_INTENT_IN;
    const char * capi_errmess = "_arpack._arpack.dneupd: failed to create array from the 15th argument `workd`";
    capi_workd_as_array = ndarray_from_pyobj(  NPY_DOUBLE,1,workd_Dims,workd_Rank,  capi_workd_intent,workd_capi,capi_errmess);
    if (capi_workd_as_array == NULL) {
        PyObject* capi_err = PyErr_Occurred();
        if (capi_err == NULL) {
            capi_err = _arpack_error;
            PyErr_SetString(capi_err, capi_errmess);
        }
    } else {
        workd = (double *)(PyArray_DATA(capi_workd_as_array));

    /* Processing variable lworkl */
    if (lworkl_capi == Py_None) lworkl = len(workl); else
        f2py_success = int_from_pyobj(&lworkl,lworkl_capi,"_arpack.dneupd() 5th keyword (lworkl) can't be converted to int");
    if (f2py_success) {
    CHECKSCALAR(len(workl)>=lworkl,"len(workl)>=lworkl","5th keyword lworkl","dneupd:lworkl=%d",lworkl) {
    /* Processing variable z */
    z_Dims[0]=n,z_Dims[1]=1 + nev;
    capi_z_intent |= F2PY_INTENT_OUT|F2PY_INTENT_HIDE;
    const char * capi_errmess = "_arpack._arpack.dneupd: failed to create array from the hidden `z`";
    capi_z_as_array = ndarray_from_pyobj(  NPY_DOUBLE,1,z_Dims,z_Rank,  capi_z_intent,Py_None,capi_errmess);
    if (capi_z_as_array == NULL) {
        PyObject* capi_err = PyErr_Occurred();
        if (capi_err == NULL) {
            capi_err = _arpack_error;
            PyErr_SetString(capi_err, capi_errmess);
        }
    } else {
        z = (double *)(PyArray_DATA(capi_z_as_array));

    /* Processing variable ldz */
    if (ldz_capi == Py_None) ldz = shape(z,0); else
        f2py_success = int_from_pyobj(&ldz,ldz_capi,"_arpack.dneupd() 1st keyword (ldz) can't be converted to int");
    if (f2py_success) {
    CHECKSCALAR(shape(z,0)==ldz,"shape(z,0)==ldz","1st keyword ldz","dneupd:ldz=%d",ldz) {
    /* Processing variable workev */
    workev_Dims[0]=3 * ncv;
    capi_workev_intent |= F2PY_INTENT_IN;
    const char * capi_errmess = "_arpack._arpack.dneupd: failed to create array from the 6th argument `workev`";
    capi_workev_as_array = ndarray_from_pyobj(  NPY_DOUBLE,1,workev_Dims,workev_Rank,  capi_workev_intent,workev_capi,capi_errmess);
    if (capi_workev_as_array == NULL) {
        PyObject* capi_err = PyErr_Occurred();
        if (capi_err == NULL) {
            capi_err = _arpack_error;
            PyErr_SetString(capi_err, capi_errmess);
        }
    } else {
        workev = (double *)(PyArray_DATA(capi_workev_as_array));

/*end of frompyobj*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_call_clock();
#endif
/*callfortranroutine*/
            Py_BEGIN_ALLOW_THREADS
                (*f2py_func)(&rvec,&howmny,select,dr,di,z,&ldz,&sigmar,&sigmai,workev,&bmat,&n,which,&nev,&tol,resid,&ncv,v,&ldv,iparam,ipntr,workd,workl,&lworkl,&info,slen(which));
            Py_END_ALLOW_THREADS
if (PyErr_Occurred())
  f2py_success = 0;
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_call_clock();
#endif
/*end of callfortranroutine*/
        if (f2py_success) {
/*pyobjfrom*/
/*end of pyobjfrom*/
        CFUNCSMESS("Building return value.\n");
        capi_buildvalue = Py_BuildValue("NNNi",capi_dr_as_array,capi_di_as_array,capi_z_as_array,info);
/*closepyobjfrom*/
/*end of closepyobjfrom*/
        } /*if (f2py_success) after callfortranroutine*/
/*cleanupfrompyobj*/
    if((PyObject *)capi_workev_as_array!=workev_capi) {
        Py_XDECREF(capi_workev_as_array); }
    }  /* if (capi_workev_as_array == NULL) ... else of workev */
    /* End of cleaning variable workev */
    } /*CHECKSCALAR(shape(z,0)==ldz)*/
    } /*if (f2py_success) of ldz*/
    /* End of cleaning variable ldz */
    }  /* if (capi_z_as_array == NULL) ... else of z */
    /* End of cleaning variable z */
    } /*CHECKSCALAR(len(workl)>=lworkl)*/
    } /*if (f2py_success) of lworkl*/
    /* End of cleaning variable lworkl */
    if((PyObject *)capi_workd_as_array!=workd_capi) {
        Py_XDECREF(capi_workd_as_array); }
    }  /* if (capi_workd_as_array == NULL) ... else of workd */
    /* End of cleaning variable workd */
    } /*CHECKSCALAR(shape(v,0)==ldv)*/
    } /*if (f2py_success) of ldv*/
    /* End of cleaning variable ldv */
    if((PyObject *)capi_v_as_array!=v_capi) {
        Py_XDECREF(capi_v_as_array); }
    }  /* if (capi_v_as_array == NULL) ... else of v */
    /* End of cleaning variable v */
    } /*CHECKSCALAR(len(select)>=ncv)*/
    } /*if (f2py_success) of ncv*/
    /* End of cleaning variable ncv */
    } /*CHECKSCALAR(len(resid)>=n)*/
    } /*if (f2py_success) of n*/
    /* End of cleaning variable n */
    }  /* if (capi_di_as_array == NULL) ... else of di */
    /* End of cleaning variable di */
    }  /* if (capi_dr_as_array == NULL) ... else of dr */
    /* End of cleaning variable dr */
    } /*if (f2py_success) of info*/
    /* End of cleaning variable info */
    if((PyObject *)capi_workl_as_array!=workl_capi) {
        Py_XDECREF(capi_workl_as_array); }
    }  /* if (capi_workl_as_array == NULL) ... else of workl */
    /* End of cleaning variable workl */
    if((PyObject *)capi_ipntr_as_array!=ipntr_capi) {
        Py_XDECREF(capi_ipntr_as_array); }
    }  /* if (capi_ipntr_as_array == NULL) ... else of ipntr */
    /* End of cleaning variable ipntr */
    if((PyObject *)capi_iparam_as_array!=iparam_capi) {
        Py_XDECREF(capi_iparam_as_array); }
    }  /* if (capi_iparam_as_array == NULL) ... else of iparam */
    /* End of cleaning variable iparam */
    if((PyObject *)capi_resid_as_array!=resid_capi) {
        Py_XDECREF(capi_resid_as_array); }
    }  /* if (capi_resid_as_array == NULL) ... else of resid */
    /* End of cleaning variable resid */
    } /*if (f2py_success) of tol*/
    /* End of cleaning variable tol */
    } /*if (f2py_success) of nev*/
    /* End of cleaning variable nev */
        STRINGFREE(which);
    }  /*if (f2py_success) of which*/
    /* End of cleaning variable which */
    } /*if (f2py_success) of bmat*/
    /* End of cleaning variable bmat */
    } /*if (f2py_success) of sigmai*/
    /* End of cleaning variable sigmai */
    } /*if (f2py_success) of sigmar*/
    /* End of cleaning variable sigmar */
    if((PyObject *)capi_select_as_array!=select_capi) {
        Py_XDECREF(capi_select_as_array); }
    }  /* if (capi_select_as_array == NULL) ... else of select */
    /* End of cleaning variable select */
    } /*if (f2py_success) of howmny*/
    /* End of cleaning variable howmny */
    } /*if (f2py_success) of rvec*/
    /* End of cleaning variable rvec */
/*end of cleanupfrompyobj*/
    if (capi_buildvalue == NULL) {
/*routdebugfailure*/
    } else {
/*routdebugleave*/
    }
    CFUNCSMESS("Freeing memory.\n");
/*freemem*/
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_clock();
#endif
    return capi_buildvalue;
}
/******************************* end of dneupd *******************************/

/*********************************** cnaupd ***********************************/
static char doc_f2py_rout__arpack_cnaupd[] = "\
ido,tol,resid,v,iparam,ipntr,info = cnaupd(ido,bmat,which,nev,tol,resid,v,iparam,ipntr,workd,workl,rwork,info,[n,ncv,ldv,lworkl])\n\nWrapper for ``cnaupd``.\
\n\nParameters\n----------\n"
"ido : input int\n"
"bmat : input string(len=1)\n"
"which : input string(len=2)\n"
"nev : input int\n"
"tol : input float\n"
"resid : input rank-1 array('F') with bounds (n)\n"
"v : input rank-2 array('F') with bounds (ldv,ncv)\n"
"iparam : input rank-1 array('i') with bounds (11)\n"
"ipntr : input rank-1 array('i') with bounds (14)\n"
"workd : in/output rank-1 array('F') with bounds (3 * n)\n"
"workl : in/output rank-1 array('F') with bounds (lworkl)\n"
"rwork : in/output rank-1 array('f') with bounds (ncv)\n"
"info : input int\n"
"\nOther Parameters\n----------------\n"
"n : input int, optional\n    Default: len(resid)\n"
"ncv : input int, optional\n    Default: shape(v,1)\n"
"ldv : input int, optional\n    Default: shape(v,0)\n"
"lworkl : input int, optional\n    Default: len(workl)\n"
"\nReturns\n-------\n"
"ido : int\n"
"tol : float\n"
"resid : rank-1 array('F') with bounds (n)\n"
"v : rank-2 array('F') with bounds (ldv,ncv)\n"
"iparam : rank-1 array('i') with bounds (11)\n"
"ipntr : rank-1 array('i') with bounds (14)\n"
"info : int";
/* extern void F_FUNC(cnaupd,CNAUPD)(int*,string,int*,string,int*,float*,complex_float*,int*,complex_float*,int*,int*,int*,complex_float*,complex_float*,int*,float*,int*,size_t,size_t); */
static PyObject *f2py_rout__arpack_cnaupd(const PyObject *capi_self,
                           PyObject *capi_args,
                           PyObject *capi_keywds,
                           void (*f2py_func)(int*,string,int*,string,int*,float*,complex_float*,int*,complex_float*,int*,int*,int*,complex_float*,complex_float*,int*,float*,int*,size_t,size_t)) {
    PyObject * volatile capi_buildvalue = NULL;
    volatile int f2py_success = 1;
/*decl*/

    int ido = 0;
    PyObject *ido_capi = Py_None;
    string bmat = NULL;
    int slen(bmat);
    PyObject *bmat_capi = Py_None;
    int n = 0;
    PyObject *n_capi = Py_None;
    string which = NULL;
    int slen(which);
    PyObject *which_capi = Py_None;
    int nev = 0;
    PyObject *nev_capi = Py_None;
    float tol = 0;
    PyObject *tol_capi = Py_None;
    complex_float *resid = NULL;
    npy_intp resid_Dims[1] = {-1};
    const int resid_Rank = 1;
    PyArrayObject *capi_resid_as_array = NULL;
    int capi_resid_intent = 0;
    PyObject *resid_capi = Py_None;
    int ncv = 0;
    PyObject *ncv_capi = Py_None;
    complex_float *v = NULL;
    npy_intp v_Dims[2] = {-1, -1};
    const int v_Rank = 2;
    PyArrayObject *capi_v_as_array = NULL;
    int capi_v_intent = 0;
    PyObject *v_capi = Py_None;
    int ldv = 0;
    PyObject *ldv_capi = Py_None;
    int *iparam = NULL;
    npy_intp iparam_Dims[1] = {-1};
    const int iparam_Rank = 1;
    PyArrayObject *capi_iparam_as_array = NULL;
    int capi_iparam_intent = 0;
    PyObject *iparam_capi = Py_None;
    int *ipntr = NULL;
    npy_intp ipntr_Dims[1] = {-1};
    const int ipntr_Rank = 1;
    PyArrayObject *capi_ipntr_as_array = NULL;
    int capi_ipntr_intent = 0;
    PyObject *ipntr_capi = Py_None;
    complex_float *workd = NULL;
    npy_intp workd_Dims[1] = {-1};
    const int workd_Rank = 1;
    PyArrayObject *capi_workd_as_array = NULL;
    int capi_workd_intent = 0;
    PyObject *workd_capi = Py_None;
    complex_float *workl = NULL;
    npy_intp workl_Dims[1] = {-1};
    const int workl_Rank = 1;
    PyArrayObject *capi_workl_as_array = NULL;
    int capi_workl_intent = 0;
    PyObject *workl_capi = Py_None;
    int lworkl = 0;
    PyObject *lworkl_capi = Py_None;
    float *rwork = NULL;
    npy_intp rwork_Dims[1] = {-1};
    const int rwork_Rank = 1;
    PyArrayObject *capi_rwork_as_array = NULL;
    int capi_rwork_intent = 0;
    PyObject *rwork_capi = Py_None;
    int info = 0;
    PyObject *info_capi = Py_None;
    static char *capi_kwlist[] = {"ido","bmat","which","nev","tol","resid","v","iparam","ipntr","workd","workl","rwork","info","n","ncv","ldv","lworkl",NULL};

/*routdebugenter*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_clock();
#endif
    if (!PyArg_ParseTupleAndKeywords(capi_args,capi_keywds,\
        "OOOOOOOOOOOOO|OOOO:_arpack.cnaupd",\
        capi_kwlist,&ido_capi,&bmat_capi,&which_capi,&nev_capi,&tol_capi,&resid_capi,&v_capi,&iparam_capi,&ipntr_capi,&workd_capi,&workl_capi,&rwork_capi,&info_capi,&n_capi,&ncv_capi,&ldv_capi,&lworkl_capi))
        return NULL;
/*frompyobj*/
    /* Processing variable ido */
        f2py_success = int_from_pyobj(&ido,ido_capi,"_arpack.cnaupd() 1st argument (ido) can't be converted to int");
    if (f2py_success) {
    /* Processing variable bmat */
    slen(bmat) = 1;
    f2py_success = string_from_pyobj(&bmat,&slen(bmat),"",bmat_capi,"string_from_pyobj failed in converting 2nd argument`bmat' of _arpack.cnaupd to C string");
    if (f2py_success) {
        STRINGPADN(bmat, slen(bmat), '\0', ' ');
    /* Processing variable which */
    slen(which) = 2;
    f2py_success = string_from_pyobj(&which,&slen(which),"",which_capi,"string_from_pyobj failed in converting 3rd argument`which' of _arpack.cnaupd to C string");
    if (f2py_success) {
        STRINGPADN(which, slen(which), '\0', ' ');
    /* Processing variable nev */
        f2py_success = int_from_pyobj(&nev,nev_capi,"_arpack.cnaupd() 4th argument (nev) can't be converted to int");
    if (f2py_success) {
    /* Processing variable tol */
        f2py_success = float_from_pyobj(&tol,tol_capi,"_arpack.cnaupd() 5th argument (tol) can't be converted to float");
    if (f2py_success) {
    /* Processing variable resid */
    ;
    capi_resid_intent |= F2PY_INTENT_IN|F2PY_INTENT_OUT;
    const char * capi_errmess = "_arpack._arpack.cnaupd: failed to create array from the 6th argument `resid`";
    capi_resid_as_array = ndarray_from_pyobj(  NPY_CFLOAT,1,resid_Dims,resid_Rank,  capi_resid_intent,resid_capi,capi_errmess);
    if (capi_resid_as_array == NULL) {
        PyObject* capi_err = PyErr_Occurred();
        if (capi_err == NULL) {
            capi_err = _arpack_error;
            PyErr_SetString(capi_err, capi_errmess);
        }
    } else {
        resid = (complex_float *)(PyArray_DATA(capi_resid_as_array));

    /* Processing variable v */
    ;
    capi_v_intent |= F2PY_INTENT_IN|F2PY_INTENT_OUT;
    const char * capi_errmess = "_arpack._arpack.cnaupd: failed to create array from the 7th argument `v`";
    capi_v_as_array = ndarray_from_pyobj(  NPY_CFLOAT,1,v_Dims,v_Rank,  capi_v_intent,v_capi,capi_errmess);
    if (capi_v_as_array == NULL) {
        PyObject* capi_err = PyErr_Occurred();
        if (capi_err == NULL) {
            capi_err = _arpack_error;
            PyErr_SetString(capi_err, capi_errmess);
        }
    } else {
        v = (complex_float *)(PyArray_DATA(capi_v_as_array));

    /* Processing variable iparam */
    iparam_Dims[0]=11;
    capi_iparam_intent |= F2PY_INTENT_IN|F2PY_INTENT_OUT;
    const char * capi_errmess = "_arpack._arpack.cnaupd: failed to create array from the 8th argument `iparam`";
    capi_iparam_as_array = ndarray_from_pyobj(  NPY_INT,1,iparam_Dims,iparam_Rank,  capi_iparam_intent,iparam_capi,capi_errmess);
    if (capi_iparam_as_array == NULL) {
        PyObject* capi_err = PyErr_Occurred();
        if (capi_err == NULL) {
            capi_err = _arpack_error;
            PyErr_SetString(capi_err, capi_errmess);
        }
    } else {
        iparam = (int *)(PyArray_DATA(capi_iparam_as_array));

    /* Processing variable ipntr */
    ipntr_Dims[0]=14;
    capi_ipntr_intent |= F2PY_INTENT_IN|F2PY_INTENT_OUT;
    const char * capi_errmess = "_arpack._arpack.cnaupd: failed to create array from the 9th argument `ipntr`";
    capi_ipntr_as_array = ndarray_from_pyobj(  NPY_INT,1,ipntr_Dims,ipntr_Rank,  capi_ipntr_intent,ipntr_capi,capi_errmess);
    if (capi_ipntr_as_array == NULL) {
        PyObject* capi_err = PyErr_Occurred();
        if (capi_err == NULL) {
            capi_err = _arpack_error;
            PyErr_SetString(capi_err, capi_errmess);
        }
    } else {
        ipntr = (int *)(PyArray_DATA(capi_ipntr_as_array));

    /* Processing variable workl */
    ;
    capi_workl_intent |= F2PY_INTENT_INOUT;
    const char * capi_errmess = "_arpack._arpack.cnaupd: failed to create array from the 11st argument `workl`";
    capi_workl_as_array = ndarray_from_pyobj(  NPY_CFLOAT,1,workl_Dims,workl_Rank,  capi_workl_intent,workl_capi,capi_errmess);
    if (capi_workl_as_array == NULL) {
        PyObject* capi_err = PyErr_Occurred();
        if (capi_err == NULL) {
            capi_err = _arpack_error;
            PyErr_SetString(capi_err, capi_errmess);
        }
    } else {
        workl = (complex_float *)(PyArray_DATA(capi_workl_as_array));

    /* Processing variable info */
        f2py_success = int_from_pyobj(&info,info_capi,"_arpack.cnaupd() 13rd argument (info) can't be converted to int");
    if (f2py_success) {
    /* Processing variable n */
    if (n_capi == Py_None) n = len(resid); else
        f2py_success = int_from_pyobj(&n,n_capi,"_arpack.cnaupd() 1st keyword (n) can't be converted to int");
    if (f2py_success) {
    CHECKSCALAR(len(resid)>=n,"len(resid)>=n","1st keyword n","cnaupd:n=%d",n) {
    /* Processing variable ncv */
    if (ncv_capi == Py_None) ncv = shape(v,1); else
        f2py_success = int_from_pyobj(&ncv,ncv_capi,"_arpack.cnaupd() 2nd keyword (ncv) can't be converted to int");
    if (f2py_success) {
    CHECKSCALAR(shape(v,1)==ncv,"shape(v,1)==ncv","2nd keyword ncv","cnaupd:ncv=%d",ncv) {
    /* Processing variable ldv */
    if (ldv_capi == Py_None) ldv = shape(v,0); else
        f2py_success = int_from_pyobj(&ldv,ldv_capi,"_arpack.cnaupd() 3rd keyword (ldv) can't be converted to int");
    if (f2py_success) {
    CHECKSCALAR(shape(v,0)==ldv,"shape(v,0)==ldv","3rd keyword ldv","cnaupd:ldv=%d",ldv) {
    /* Processing variable workd */
    workd_Dims[0]=3 * n;
    capi_workd_intent |= F2PY_INTENT_INOUT;
    const char * capi_errmess = "_arpack._arpack.cnaupd: failed to create array from the 10th argument `workd`";
    capi_workd_as_array = ndarray_from_pyobj(  NPY_CFLOAT,1,workd_Dims,workd_Rank,  capi_workd_intent,workd_capi,capi_errmess);
    if (capi_workd_as_array == NULL) {
        PyObject* capi_err = PyErr_Occurred();
        if (capi_err == NULL) {
            capi_err = _arpack_error;
            PyErr_SetString(capi_err, capi_errmess);
        }
    } else {
        workd = (complex_float *)(PyArray_DATA(capi_workd_as_array));

    /* Processing variable lworkl */
    if (lworkl_capi == Py_None) lworkl = len(workl); else
        f2py_success = int_from_pyobj(&lworkl,lworkl_capi,"_arpack.cnaupd() 4th keyword (lworkl) can't be converted to int");
    if (f2py_success) {
    CHECKSCALAR(len(workl)>=lworkl,"len(workl)>=lworkl","4th keyword lworkl","cnaupd:lworkl=%d",lworkl) {
    /* Processing variable rwork */
    rwork_Dims[0]=ncv;
    capi_rwork_intent |= F2PY_INTENT_INOUT;
    const char * capi_errmess = "_arpack._arpack.cnaupd: failed to create array from the 12nd argument `rwork`";
    capi_rwork_as_array = ndarray_from_pyobj(  NPY_FLOAT,1,rwork_Dims,rwork_Rank,  capi_rwork_intent,rwork_capi,capi_errmess);
    if (capi_rwork_as_array == NULL) {
        PyObject* capi_err = PyErr_Occurred();
        if (capi_err == NULL) {
            capi_err = _arpack_error;
            PyErr_SetString(capi_err, capi_errmess);
        }
    } else {
        rwork = (float *)(PyArray_DATA(capi_rwork_as_array));

/*end of frompyobj*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_call_clock();
#endif
/*callfortranroutine*/
            Py_BEGIN_ALLOW_THREADS
                (*f2py_func)(&ido,bmat,&n,which,&nev,&tol,resid,&ncv,v,&ldv,iparam,ipntr,workd,workl,&lworkl,rwork,&info,slen(bmat),slen(which));
            Py_END_ALLOW_THREADS
if (PyErr_Occurred())
  f2py_success = 0;
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_call_clock();
#endif
/*end of callfortranroutine*/
        if (f2py_success) {
/*pyobjfrom*/
/*end of pyobjfrom*/
        CFUNCSMESS("Building return value.\n");
        capi_buildvalue = Py_BuildValue("ifNNNNi",ido,tol,capi_resid_as_array,capi_v_as_array,capi_iparam_as_array,capi_ipntr_as_array,info);
/*closepyobjfrom*/
/*end of closepyobjfrom*/
        } /*if (f2py_success) after callfortranroutine*/
/*cleanupfrompyobj*/
    if((PyObject *)capi_rwork_as_array!=rwork_capi) {
        Py_XDECREF(capi_rwork_as_array); }
    }  /* if (capi_rwork_as_array == NULL) ... else of rwork */
    /* End of cleaning variable rwork */
    } /*CHECKSCALAR(len(workl)>=lworkl)*/
    } /*if (f2py_success) of lworkl*/
    /* End of cleaning variable lworkl */
    if((PyObject *)capi_workd_as_array!=workd_capi) {
        Py_XDECREF(capi_workd_as_array); }
    }  /* if (capi_workd_as_array == NULL) ... else of workd */
    /* End of cleaning variable workd */
    } /*CHECKSCALAR(shape(v,0)==ldv)*/
    } /*if (f2py_success) of ldv*/
    /* End of cleaning variable ldv */
    } /*CHECKSCALAR(shape(v,1)==ncv)*/
    } /*if (f2py_success) of ncv*/
    /* End of cleaning variable ncv */
    } /*CHECKSCALAR(len(resid)>=n)*/
    } /*if (f2py_success) of n*/
    /* End of cleaning variable n */
    } /*if (f2py_success) of info*/
    /* End of cleaning variable info */
    if((PyObject *)capi_workl_as_array!=workl_capi) {
        Py_XDECREF(capi_workl_as_array); }
    }  /* if (capi_workl_as_array == NULL) ... else of workl */
    /* End of cleaning variable workl */
    }  /* if (capi_ipntr_as_array == NULL) ... else of ipntr */
    /* End of cleaning variable ipntr */
    }  /* if (capi_iparam_as_array == NULL) ... else of iparam */
    /* End of cleaning variable iparam */
    }  /* if (capi_v_as_array == NULL) ... else of v */
    /* End of cleaning variable v */
    }  /* if (capi_resid_as_array == NULL) ... else of resid */
    /* End of cleaning variable resid */
    } /*if (f2py_success) of tol*/
    /* End of cleaning variable tol */
    } /*if (f2py_success) of nev*/
    /* End of cleaning variable nev */
        STRINGFREE(which);
    }  /*if (f2py_success) of which*/
    /* End of cleaning variable which */
        STRINGFREE(bmat);
    }  /*if (f2py_success) of bmat*/
    /* End of cleaning variable bmat */
    } /*if (f2py_success) of ido*/
    /* End of cleaning variable ido */
/*end of cleanupfrompyobj*/
    if (capi_buildvalue == NULL) {
/*routdebugfailure*/
    } else {
/*routdebugleave*/
    }
    CFUNCSMESS("Freeing memory.\n");
/*freemem*/
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_clock();
#endif
    return capi_buildvalue;
}
/******************************* end of cnaupd *******************************/

/*********************************** znaupd ***********************************/
static char doc_f2py_rout__arpack_znaupd[] = "\
ido,tol,resid,v,iparam,ipntr,info = znaupd(ido,bmat,which,nev,tol,resid,v,iparam,ipntr,workd,workl,rwork,info,[n,ncv,ldv,lworkl])\n\nWrapper for ``znaupd``.\
\n\nParameters\n----------\n"
"ido : input int\n"
"bmat : input string(len=1)\n"
"which : input string(len=2)\n"
"nev : input int\n"
"tol : input float\n"
"resid : input rank-1 array('D') with bounds (n)\n"
"v : input rank-2 array('D') with bounds (ldv,ncv)\n"
"iparam : input rank-1 array('i') with bounds (11)\n"
"ipntr : input rank-1 array('i') with bounds (14)\n"
"workd : in/output rank-1 array('D') with bounds (3 * n)\n"
"workl : in/output rank-1 array('D') with bounds (lworkl)\n"
"rwork : in/output rank-1 array('d') with bounds (ncv)\n"
"info : input int\n"
"\nOther Parameters\n----------------\n"
"n : input int, optional\n    Default: len(resid)\n"
"ncv : input int, optional\n    Default: shape(v,1)\n"
"ldv : input int, optional\n    Default: shape(v,0)\n"
"lworkl : input int, optional\n    Default: len(workl)\n"
"\nReturns\n-------\n"
"ido : int\n"
"tol : float\n"
"resid : rank-1 array('D') with bounds (n)\n"
"v : rank-2 array('D') with bounds (ldv,ncv)\n"
"iparam : rank-1 array('i') with bounds (11)\n"
"ipntr : rank-1 array('i') with bounds (14)\n"
"info : int";
/* extern void F_FUNC(znaupd,ZNAUPD)(int*,string,int*,string,int*,double*,complex_double*,int*,complex_double*,int*,int*,int*,complex_double*,complex_double*,int*,double*,int*,size_t,size_t); */
static PyObject *f2py_rout__arpack_znaupd(const PyObject *capi_self,
                           PyObject *capi_args,
                           PyObject *capi_keywds,
                           void (*f2py_func)(int*,string,int*,string,int*,double*,complex_double*,int*,complex_double*,int*,int*,int*,complex_double*,complex_double*,int*,double*,int*,size_t,size_t)) {
    PyObject * volatile capi_buildvalue = NULL;
    volatile int f2py_success = 1;
/*decl*/

    int ido = 0;
    PyObject *ido_capi = Py_None;
    string bmat = NULL;
    int slen(bmat);
    PyObject *bmat_capi = Py_None;
    int n = 0;
    PyObject *n_capi = Py_None;
    string which = NULL;
    int slen(which);
    PyObject *which_capi = Py_None;
    int nev = 0;
    PyObject *nev_capi = Py_None;
    double tol = 0;
    PyObject *tol_capi = Py_None;
    complex_double *resid = NULL;
    npy_intp resid_Dims[1] = {-1};
    const int resid_Rank = 1;
    PyArrayObject *capi_resid_as_array = NULL;
    int capi_resid_intent = 0;
    PyObject *resid_capi = Py_None;
    int ncv = 0;
    PyObject *ncv_capi = Py_None;
    complex_double *v = NULL;
    npy_intp v_Dims[2] = {-1, -1};
    const int v_Rank = 2;
    PyArrayObject *capi_v_as_array = NULL;
    int capi_v_intent = 0;
    PyObject *v_capi = Py_None;
    int ldv = 0;
    PyObject *ldv_capi = Py_None;
    int *iparam = NULL;
    npy_intp iparam_Dims[1] = {-1};
    const int iparam_Rank = 1;
    PyArrayObject *capi_iparam_as_array = NULL;
    int capi_iparam_intent = 0;
    PyObject *iparam_capi = Py_None;
    int *ipntr = NULL;
    npy_intp ipntr_Dims[1] = {-1};
    const int ipntr_Rank = 1;
    PyArrayObject *capi_ipntr_as_array = NULL;
    int capi_ipntr_intent = 0;
    PyObject *ipntr_capi = Py_None;
    complex_double *workd = NULL;
    npy_intp workd_Dims[1] = {-1};
    const int workd_Rank = 1;
    PyArrayObject *capi_workd_as_array = NULL;
    int capi_workd_intent = 0;
    PyObject *workd_capi = Py_None;
    complex_double *workl = NULL;
    npy_intp workl_Dims[1] = {-1};
    const int workl_Rank = 1;
    PyArrayObject *capi_workl_as_array = NULL;
    int capi_workl_intent = 0;
    PyObject *workl_capi = Py_None;
    int lworkl = 0;
    PyObject *lworkl_capi = Py_None;
    double *rwork = NULL;
    npy_intp rwork_Dims[1] = {-1};
    const int rwork_Rank = 1;
    PyArrayObject *capi_rwork_as_array = NULL;
    int capi_rwork_intent = 0;
    PyObject *rwork_capi = Py_None;
    int info = 0;
    PyObject *info_capi = Py_None;
    static char *capi_kwlist[] = {"ido","bmat","which","nev","tol","resid","v","iparam","ipntr","workd","workl","rwork","info","n","ncv","ldv","lworkl",NULL};

/*routdebugenter*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_clock();
#endif
    if (!PyArg_ParseTupleAndKeywords(capi_args,capi_keywds,\
        "OOOOOOOOOOOOO|OOOO:_arpack.znaupd",\
        capi_kwlist,&ido_capi,&bmat_capi,&which_capi,&nev_capi,&tol_capi,&resid_capi,&v_capi,&iparam_capi,&ipntr_capi,&workd_capi,&workl_capi,&rwork_capi,&info_capi,&n_capi,&ncv_capi,&ldv_capi,&lworkl_capi))
        return NULL;
/*frompyobj*/
    /* Processing variable ido */
        f2py_success = int_from_pyobj(&ido,ido_capi,"_arpack.znaupd() 1st argument (ido) can't be converted to int");
    if (f2py_success) {
    /* Processing variable bmat */
    slen(bmat) = 1;
    f2py_success = string_from_pyobj(&bmat,&slen(bmat),"",bmat_capi,"string_from_pyobj failed in converting 2nd argument`bmat' of _arpack.znaupd to C string");
    if (f2py_success) {
        STRINGPADN(bmat, slen(bmat), '\0', ' ');
    /* Processing variable which */
    slen(which) = 2;
    f2py_success = string_from_pyobj(&which,&slen(which),"",which_capi,"string_from_pyobj failed in converting 3rd argument`which' of _arpack.znaupd to C string");
    if (f2py_success) {
        STRINGPADN(which, slen(which), '\0', ' ');
    /* Processing variable nev */
        f2py_success = int_from_pyobj(&nev,nev_capi,"_arpack.znaupd() 4th argument (nev) can't be converted to int");
    if (f2py_success) {
    /* Processing variable tol */
        f2py_success = double_from_pyobj(&tol,tol_capi,"_arpack.znaupd() 5th argument (tol) can't be converted to double");
    if (f2py_success) {
    /* Processing variable resid */
    ;
    capi_resid_intent |= F2PY_INTENT_IN|F2PY_INTENT_OUT;
    const char * capi_errmess = "_arpack._arpack.znaupd: failed to create array from the 6th argument `resid`";
    capi_resid_as_array = ndarray_from_pyobj(  NPY_CDOUBLE,1,resid_Dims,resid_Rank,  capi_resid_intent,resid_capi,capi_errmess);
    if (capi_resid_as_array == NULL) {
        PyObject* capi_err = PyErr_Occurred();
        if (capi_err == NULL) {
            capi_err = _arpack_error;
            PyErr_SetString(capi_err, capi_errmess);
        }
    } else {
        resid = (complex_double *)(PyArray_DATA(capi_resid_as_array));

    /* Processing variable v */
    ;
    capi_v_intent |= F2PY_INTENT_IN|F2PY_INTENT_OUT;
    const char * capi_errmess = "_arpack._arpack.znaupd: failed to create array from the 7th argument `v`";
    capi_v_as_array = ndarray_from_pyobj(  NPY_CDOUBLE,1,v_Dims,v_Rank,  capi_v_intent,v_capi,capi_errmess);
    if (capi_v_as_array == NULL) {
        PyObject* capi_err = PyErr_Occurred();
        if (capi_err == NULL) {
            capi_err = _arpack_error;
            PyErr_SetString(capi_err, capi_errmess);
        }
    } else {
        v = (complex_double *)(PyArray_DATA(capi_v_as_array));

    /* Processing variable iparam */
    iparam_Dims[0]=11;
    capi_iparam_intent |= F2PY_INTENT_IN|F2PY_INTENT_OUT;
    const char * capi_errmess = "_arpack._arpack.znaupd: failed to create array from the 8th argument `iparam`";
    capi_iparam_as_array = ndarray_from_pyobj(  NPY_INT,1,iparam_Dims,iparam_Rank,  capi_iparam_intent,iparam_capi,capi_errmess);
    if (capi_iparam_as_array == NULL) {
        PyObject* capi_err = PyErr_Occurred();
        if (capi_err == NULL) {
            capi_err = _arpack_error;
            PyErr_SetString(capi_err, capi_errmess);
        }
    } else {
        iparam = (int *)(PyArray_DATA(capi_iparam_as_array));

    /* Processing variable ipntr */
    ipntr_Dims[0]=14;
    capi_ipntr_intent |= F2PY_INTENT_IN|F2PY_INTENT_OUT;
    const char * capi_errmess = "_arpack._arpack.znaupd: failed to create array from the 9th argument `ipntr`";
    capi_ipntr_as_array = ndarray_from_pyobj(  NPY_INT,1,ipntr_Dims,ipntr_Rank,  capi_ipntr_intent,ipntr_capi,capi_errmess);
    if (capi_ipntr_as_array == NULL) {
        PyObject* capi_err = PyErr_Occurred();
        if (capi_err == NULL) {
            capi_err = _arpack_error;
            PyErr_SetString(capi_err, capi_errmess);
        }
    } else {
        ipntr = (int *)(PyArray_DATA(capi_ipntr_as_array));

    /* Processing variable workl */
    ;
    capi_workl_intent |= F2PY_INTENT_INOUT;
    const char * capi_errmess = "_arpack._arpack.znaupd: failed to create array from the 11st argument `workl`";
    capi_workl_as_array = ndarray_from_pyobj(  NPY_CDOUBLE,1,workl_Dims,workl_Rank,  capi_workl_intent,workl_capi,capi_errmess);
    if (capi_workl_as_array == NULL) {
        PyObject* capi_err = PyErr_Occurred();
        if (capi_err == NULL) {
            capi_err = _arpack_error;
            PyErr_SetString(capi_err, capi_errmess);
        }
    } else {
        workl = (complex_double *)(PyArray_DATA(capi_workl_as_array));

    /* Processing variable info */
        f2py_success = int_from_pyobj(&info,info_capi,"_arpack.znaupd() 13rd argument (info) can't be converted to int");
    if (f2py_success) {
    /* Processing variable n */
    if (n_capi == Py_None) n = len(resid); else
        f2py_success = int_from_pyobj(&n,n_capi,"_arpack.znaupd() 1st keyword (n) can't be converted to int");
    if (f2py_success) {
    CHECKSCALAR(len(resid)>=n,"len(resid)>=n","1st keyword n","znaupd:n=%d",n) {
    /* Processing variable ncv */
    if (ncv_capi == Py_None) ncv = shape(v,1); else
        f2py_success = int_from_pyobj(&ncv,ncv_capi,"_arpack.znaupd() 2nd keyword (ncv) can't be converted to int");
    if (f2py_success) {
    CHECKSCALAR(shape(v,1)==ncv,"shape(v,1)==ncv","2nd keyword ncv","znaupd:ncv=%d",ncv) {
    /* Processing variable ldv */
    if (ldv_capi == Py_None) ldv = shape(v,0); else
        f2py_success = int_from_pyobj(&ldv,ldv_capi,"_arpack.znaupd() 3rd keyword (ldv) can't be converted to int");
    if (f2py_success) {
    CHECKSCALAR(shape(v,0)==ldv,"shape(v,0)==ldv","3rd keyword ldv","znaupd:ldv=%d",ldv) {
    /* Processing variable workd */
    workd_Dims[0]=3 * n;
    capi_workd_intent |= F2PY_INTENT_INOUT;
    const char * capi_errmess = "_arpack._arpack.znaupd: failed to create array from the 10th argument `workd`";
    capi_workd_as_array = ndarray_from_pyobj(  NPY_CDOUBLE,1,workd_Dims,workd_Rank,  capi_workd_intent,workd_capi,capi_errmess);
    if (capi_workd_as_array == NULL) {
        PyObject* capi_err = PyErr_Occurred();
        if (capi_err == NULL) {
            capi_err = _arpack_error;
            PyErr_SetString(capi_err, capi_errmess);
        }
    } else {
        workd = (complex_double *)(PyArray_DATA(capi_workd_as_array));

    /* Processing variable lworkl */
    if (lworkl_capi == Py_None) lworkl = len(workl); else
        f2py_success = int_from_pyobj(&lworkl,lworkl_capi,"_arpack.znaupd() 4th keyword (lworkl) can't be converted to int");
    if (f2py_success) {
    CHECKSCALAR(len(workl)>=lworkl,"len(workl)>=lworkl","4th keyword lworkl","znaupd:lworkl=%d",lworkl) {
    /* Processing variable rwork */
    rwork_Dims[0]=ncv;
    capi_rwork_intent |= F2PY_INTENT_INOUT;
    const char * capi_errmess = "_arpack._arpack.znaupd: failed to create array from the 12nd argument `rwork`";
    capi_rwork_as_array = ndarray_from_pyobj(  NPY_DOUBLE,1,rwork_Dims,rwork_Rank,  capi_rwork_intent,rwork_capi,capi_errmess);
    if (capi_rwork_as_array == NULL) {
        PyObject* capi_err = PyErr_Occurred();
        if (capi_err == NULL) {
            capi_err = _arpack_error;
            PyErr_SetString(capi_err, capi_errmess);
        }
    } else {
        rwork = (double *)(PyArray_DATA(capi_rwork_as_array));

/*end of frompyobj*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_call_clock();
#endif
/*callfortranroutine*/
            Py_BEGIN_ALLOW_THREADS
                (*f2py_func)(&ido,bmat,&n,which,&nev,&tol,resid,&ncv,v,&ldv,iparam,ipntr,workd,workl,&lworkl,rwork,&info,slen(bmat),slen(which));
            Py_END_ALLOW_THREADS
if (PyErr_Occurred())
  f2py_success = 0;
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_call_clock();
#endif
/*end of callfortranroutine*/
        if (f2py_success) {
/*pyobjfrom*/
/*end of pyobjfrom*/
        CFUNCSMESS("Building return value.\n");
        capi_buildvalue = Py_BuildValue("idNNNNi",ido,tol,capi_resid_as_array,capi_v_as_array,capi_iparam_as_array,capi_ipntr_as_array,info);
/*closepyobjfrom*/
/*end of closepyobjfrom*/
        } /*if (f2py_success) after callfortranroutine*/
/*cleanupfrompyobj*/
    if((PyObject *)capi_rwork_as_array!=rwork_capi) {
        Py_XDECREF(capi_rwork_as_array); }
    }  /* if (capi_rwork_as_array == NULL) ... else of rwork */
    /* End of cleaning variable rwork */
    } /*CHECKSCALAR(len(workl)>=lworkl)*/
    } /*if (f2py_success) of lworkl*/
    /* End of cleaning variable lworkl */
    if((PyObject *)capi_workd_as_array!=workd_capi) {
        Py_XDECREF(capi_workd_as_array); }
    }  /* if (capi_workd_as_array == NULL) ... else of workd */
    /* End of cleaning variable workd */
    } /*CHECKSCALAR(shape(v,0)==ldv)*/
    } /*if (f2py_success) of ldv*/
    /* End of cleaning variable ldv */
    } /*CHECKSCALAR(shape(v,1)==ncv)*/
    } /*if (f2py_success) of ncv*/
    /* End of cleaning variable ncv */
    } /*CHECKSCALAR(len(resid)>=n)*/
    } /*if (f2py_success) of n*/
    /* End of cleaning variable n */
    } /*if (f2py_success) of info*/
    /* End of cleaning variable info */
    if((PyObject *)capi_workl_as_array!=workl_capi) {
        Py_XDECREF(capi_workl_as_array); }
    }  /* if (capi_workl_as_array == NULL) ... else of workl */
    /* End of cleaning variable workl */
    }  /* if (capi_ipntr_as_array == NULL) ... else of ipntr */
    /* End of cleaning variable ipntr */
    }  /* if (capi_iparam_as_array == NULL) ... else of iparam */
    /* End of cleaning variable iparam */
    }  /* if (capi_v_as_array == NULL) ... else of v */
    /* End of cleaning variable v */
    }  /* if (capi_resid_as_array == NULL) ... else of resid */
    /* End of cleaning variable resid */
    } /*if (f2py_success) of tol*/
    /* End of cleaning variable tol */
    } /*if (f2py_success) of nev*/
    /* End of cleaning variable nev */
        STRINGFREE(which);
    }  /*if (f2py_success) of which*/
    /* End of cleaning variable which */
        STRINGFREE(bmat);
    }  /*if (f2py_success) of bmat*/
    /* End of cleaning variable bmat */
    } /*if (f2py_success) of ido*/
    /* End of cleaning variable ido */
/*end of cleanupfrompyobj*/
    if (capi_buildvalue == NULL) {
/*routdebugfailure*/
    } else {
/*routdebugleave*/
    }
    CFUNCSMESS("Freeing memory.\n");
/*freemem*/
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_clock();
#endif
    return capi_buildvalue;
}
/******************************* end of znaupd *******************************/

/*********************************** cneupd ***********************************/
static char doc_f2py_rout__arpack_cneupd[] = "\
d,z,info = cneupd(rvec,howmny,select,sigma,workev,bmat,which,nev,tol,resid,v,iparam,ipntr,workd,workl,rwork,info,[ldz,n,ncv,ldv,lworkl])\n\nWrapper for ``cneupd``.\
\n\nParameters\n----------\n"
"rvec : input int\n"
"howmny : input bytes\n"
"select : input rank-1 array('i') with bounds (ncv)\n"
"sigma : input complex\n"
"workev : input rank-1 array('F') with bounds (3 * ncv)\n"
"bmat : input bytes\n"
"which : input string(len=2)\n"
"nev : input int\n"
"tol : input float\n"
"resid : input rank-1 array('F') with bounds (n)\n"
"v : input rank-2 array('F') with bounds (ldv,ncv)\n"
"iparam : input rank-1 array('i') with bounds (11)\n"
"ipntr : input rank-1 array('i') with bounds (14)\n"
"workd : input rank-1 array('F') with bounds (3 * n)\n"
"workl : input rank-1 array('F') with bounds (lworkl)\n"
"rwork : input rank-1 array('f') with bounds (ncv)\n"
"info : input int\n"
"\nOther Parameters\n----------------\n"
"ldz : input int, optional\n    Default: shape(z,0)\n"
"n : input int, optional\n    Default: len(resid)\n"
"ncv : input int, optional\n    Default: len(select)\n"
"ldv : input int, optional\n    Default: shape(v,0)\n"
"lworkl : input int, optional\n    Default: len(workl)\n"
"\nReturns\n-------\n"
"d : rank-1 array('F') with bounds (nev)\n"
"z : rank-2 array('F') with bounds (n,nev)\n"
"info : int";
/* extern void F_FUNC(cneupd,CNEUPD)(int*,character*,int*,complex_float*,complex_float*,int*,complex_float*,complex_float*,character*,int*,string,int*,float*,complex_float*,int*,complex_float*,int*,int*,int*,complex_float*,complex_float*,int*,float*,int*,size_t); */
static PyObject *f2py_rout__arpack_cneupd(const PyObject *capi_self,
                           PyObject *capi_args,
                           PyObject *capi_keywds,
                           void (*f2py_func)(int*,character*,int*,complex_float*,complex_float*,int*,complex_float*,complex_float*,character*,int*,string,int*,float*,complex_float*,int*,complex_float*,int*,int*,int*,complex_float*,complex_float*,int*,float*,int*,size_t)) {
    PyObject * volatile capi_buildvalue = NULL;
    volatile int f2py_success = 1;
/*decl*/

    int rvec = 0;
    PyObject *rvec_capi = Py_None;
    character howmny = 0;
    PyObject *howmny_capi = Py_None;
    int *select = NULL;
    npy_intp select_Dims[1] = {-1};
    const int select_Rank = 1;
    PyArrayObject *capi_select_as_array = NULL;
    int capi_select_intent = 0;
    PyObject *select_capi = Py_None;
    complex_float *d = NULL;
    npy_intp d_Dims[1] = {-1};
    const int d_Rank = 1;
    PyArrayObject *capi_d_as_array = NULL;
    int capi_d_intent = 0;
    complex_float *z = NULL;
    npy_intp z_Dims[2] = {-1, -1};
    const int z_Rank = 2;
    PyArrayObject *capi_z_as_array = NULL;
    int capi_z_intent = 0;
    int ldz = 0;
    PyObject *ldz_capi = Py_None;
    complex_float sigma;
    PyObject *sigma_capi = Py_None;
    complex_float *workev = NULL;
    npy_intp workev_Dims[1] = {-1};
    const int workev_Rank = 1;
    PyArrayObject *capi_workev_as_array = NULL;
    int capi_workev_intent = 0;
    PyObject *workev_capi = Py_None;
    character bmat = 0;
    PyObject *bmat_capi = Py_None;
    int n = 0;
    PyObject *n_capi = Py_None;
    string which = NULL;
    int slen(which);
    PyObject *which_capi = Py_None;
    int nev = 0;
    PyObject *nev_capi = Py_None;
    float tol = 0;
    PyObject *tol_capi = Py_None;
    complex_float *resid = NULL;
    npy_intp resid_Dims[1] = {-1};
    const int resid_Rank = 1;
    PyArrayObject *capi_resid_as_array = NULL;
    int capi_resid_intent = 0;
    PyObject *resid_capi = Py_None;
    int ncv = 0;
    PyObject *ncv_capi = Py_None;
    complex_float *v = NULL;
    npy_intp v_Dims[2] = {-1, -1};
    const int v_Rank = 2;
    PyArrayObject *capi_v_as_array = NULL;
    int capi_v_intent = 0;
    PyObject *v_capi = Py_None;
    int ldv = 0;
    PyObject *ldv_capi = Py_None;
    int *iparam = NULL;
    npy_intp iparam_Dims[1] = {-1};
    const int iparam_Rank = 1;
    PyArrayObject *capi_iparam_as_array = NULL;
    int capi_iparam_intent = 0;
    PyObject *iparam_capi = Py_None;
    int *ipntr = NULL;
    npy_intp ipntr_Dims[1] = {-1};
    const int ipntr_Rank = 1;
    PyArrayObject *capi_ipntr_as_array = NULL;
    int capi_ipntr_intent = 0;
    PyObject *ipntr_capi = Py_None;
    complex_float *workd = NULL;
    npy_intp workd_Dims[1] = {-1};
    const int workd_Rank = 1;
    PyArrayObject *capi_workd_as_array = NULL;
    int capi_workd_intent = 0;
    PyObject *workd_capi = Py_None;
    complex_float *workl = NULL;
    npy_intp workl_Dims[1] = {-1};
    const int workl_Rank = 1;
    PyArrayObject *capi_workl_as_array = NULL;
    int capi_workl_intent = 0;
    PyObject *workl_capi = Py_None;
    int lworkl = 0;
    PyObject *lworkl_capi = Py_None;
    float *rwork = NULL;
    npy_intp rwork_Dims[1] = {-1};
    const int rwork_Rank = 1;
    PyArrayObject *capi_rwork_as_array = NULL;
    int capi_rwork_intent = 0;
    PyObject *rwork_capi = Py_None;
    int info = 0;
    PyObject *info_capi = Py_None;
    static char *capi_kwlist[] = {"rvec","howmny","select","sigma","workev","bmat","which","nev","tol","resid","v","iparam","ipntr","workd","workl","rwork","info","ldz","n","ncv","ldv","lworkl",NULL};

/*routdebugenter*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_clock();
#endif
    if (!PyArg_ParseTupleAndKeywords(capi_args,capi_keywds,\
        "OOOOOOOOOOOOOOOOO|OOOOO:_arpack.cneupd",\
        capi_kwlist,&rvec_capi,&howmny_capi,&select_capi,&sigma_capi,&workev_capi,&bmat_capi,&which_capi,&nev_capi,&tol_capi,&resid_capi,&v_capi,&iparam_capi,&ipntr_capi,&workd_capi,&workl_capi,&rwork_capi,&info_capi,&ldz_capi,&n_capi,&ncv_capi,&ldv_capi,&lworkl_capi))
        return NULL;
/*frompyobj*/
    /* Processing variable rvec */
        rvec = (int)PyObject_IsTrue(rvec_capi);
        f2py_success = 1;
    if (f2py_success) {
    /* Processing variable howmny */
        f2py_success = character_from_pyobj(&howmny,howmny_capi,"_arpack.cneupd() 2nd argument (howmny) can't be converted to character");
    if (f2py_success) {
    /* Processing variable select */
    ;
    capi_select_intent |= F2PY_INTENT_IN;
    const char * capi_errmess = "_arpack._arpack.cneupd: failed to create array from the 3rd argument `select`";
    capi_select_as_array = ndarray_from_pyobj(  NPY_INT,1,select_Dims,select_Rank,  capi_select_intent,select_capi,capi_errmess);
    if (capi_select_as_array == NULL) {
        PyObject* capi_err = PyErr_Occurred();
        if (capi_err == NULL) {
            capi_err = _arpack_error;
            PyErr_SetString(capi_err, capi_errmess);
        }
    } else {
        select = (int *)(PyArray_DATA(capi_select_as_array));

    /* Processing variable sigma */
        f2py_success = complex_float_from_pyobj(&sigma,sigma_capi,"_arpack.cneupd() 4th argument (sigma) can't be converted to complex_float");
    if (f2py_success) {
    /* Processing variable bmat */
        f2py_success = character_from_pyobj(&bmat,bmat_capi,"_arpack.cneupd() 6th argument (bmat) can't be converted to character");
    if (f2py_success) {
    /* Processing variable which */
    slen(which) = 2;
    f2py_success = string_from_pyobj(&which,&slen(which),"",which_capi,"string_from_pyobj failed in converting 7th argument`which' of _arpack.cneupd to C string");
    if (f2py_success) {
        STRINGPADN(which, slen(which), '\0', ' ');
    /* Processing variable nev */
        f2py_success = int_from_pyobj(&nev,nev_capi,"_arpack.cneupd() 8th argument (nev) can't be converted to int");
    if (f2py_success) {
    /* Processing variable tol */
        f2py_success = float_from_pyobj(&tol,tol_capi,"_arpack.cneupd() 9th argument (tol) can't be converted to float");
    if (f2py_success) {
    /* Processing variable resid */
    ;
    capi_resid_intent |= F2PY_INTENT_IN;
    const char * capi_errmess = "_arpack._arpack.cneupd: failed to create array from the 10th argument `resid`";
    capi_resid_as_array = ndarray_from_pyobj(  NPY_CFLOAT,1,resid_Dims,resid_Rank,  capi_resid_intent,resid_capi,capi_errmess);
    if (capi_resid_as_array == NULL) {
        PyObject* capi_err = PyErr_Occurred();
        if (capi_err == NULL) {
            capi_err = _arpack_error;
            PyErr_SetString(capi_err, capi_errmess);
        }
    } else {
        resid = (complex_float *)(PyArray_DATA(capi_resid_as_array));

    /* Processing variable iparam */
    iparam_Dims[0]=11;
    capi_iparam_intent |= F2PY_INTENT_IN;
    const char * capi_errmess = "_arpack._arpack.cneupd: failed to create array from the 12nd argument `iparam`";
    capi_iparam_as_array = ndarray_from_pyobj(  NPY_INT,1,iparam_Dims,iparam_Rank,  capi_iparam_intent,iparam_capi,capi_errmess);
    if (capi_iparam_as_array == NULL) {
        PyObject* capi_err = PyErr_Occurred();
        if (capi_err == NULL) {
            capi_err = _arpack_error;
            PyErr_SetString(capi_err, capi_errmess);
        }
    } else {
        iparam = (int *)(PyArray_DATA(capi_iparam_as_array));

    /* Processing variable ipntr */
    ipntr_Dims[0]=14;
    capi_ipntr_intent |= F2PY_INTENT_IN;
    const char * capi_errmess = "_arpack._arpack.cneupd: failed to create array from the 13rd argument `ipntr`";
    capi_ipntr_as_array = ndarray_from_pyobj(  NPY_INT,1,ipntr_Dims,ipntr_Rank,  capi_ipntr_intent,ipntr_capi,capi_errmess);
    if (capi_ipntr_as_array == NULL) {
        PyObject* capi_err = PyErr_Occurred();
        if (capi_err == NULL) {
            capi_err = _arpack_error;
            PyErr_SetString(capi_err, capi_errmess);
        }
    } else {
        ipntr = (int *)(PyArray_DATA(capi_ipntr_as_array));

    /* Processing variable workl */
    ;
    capi_workl_intent |= F2PY_INTENT_IN;
    const char * capi_errmess = "_arpack._arpack.cneupd: failed to create array from the 15th argument `workl`";
    capi_workl_as_array = ndarray_from_pyobj(  NPY_CFLOAT,1,workl_Dims,workl_Rank,  capi_workl_intent,workl_capi,capi_errmess);
    if (capi_workl_as_array == NULL) {
        PyObject* capi_err = PyErr_Occurred();
        if (capi_err == NULL) {
            capi_err = _arpack_error;
            PyErr_SetString(capi_err, capi_errmess);
        }
    } else {
        workl = (complex_float *)(PyArray_DATA(capi_workl_as_array));

    /* Processing variable info */
        f2py_success = int_from_pyobj(&info,info_capi,"_arpack.cneupd() 17th argument (info) can't be converted to int");
    if (f2py_success) {
    /* Processing variable d */
    d_Dims[0]=nev;
    capi_d_intent |= F2PY_INTENT_OUT|F2PY_INTENT_HIDE;
    const char * capi_errmess = "_arpack._arpack.cneupd: failed to create array from the hidden `d`";
    capi_d_as_array = ndarray_from_pyobj(  NPY_CFLOAT,1,d_Dims,d_Rank,  capi_d_intent,Py_None,capi_errmess);
    if (capi_d_as_array == NULL) {
        PyObject* capi_err = PyErr_Occurred();
        if (capi_err == NULL) {
            capi_err = _arpack_error;
            PyErr_SetString(capi_err, capi_errmess);
        }
    } else {
        d = (complex_float *)(PyArray_DATA(capi_d_as_array));

    /* Processing variable n */
    if (n_capi == Py_None) n = len(resid); else
        f2py_success = int_from_pyobj(&n,n_capi,"_arpack.cneupd() 2nd keyword (n) can't be converted to int");
    if (f2py_success) {
    CHECKSCALAR(len(resid)>=n,"len(resid)>=n","2nd keyword n","cneupd:n=%d",n) {
    /* Processing variable ncv */
    if (ncv_capi == Py_None) ncv = len(select); else
        f2py_success = int_from_pyobj(&ncv,ncv_capi,"_arpack.cneupd() 3rd keyword (ncv) can't be converted to int");
    if (f2py_success) {
    CHECKSCALAR(len(select)>=ncv,"len(select)>=ncv","3rd keyword ncv","cneupd:ncv=%d",ncv) {
    /* Processing variable v */
    v_Dims[1]=ncv;
    capi_v_intent |= F2PY_INTENT_IN;
    const char * capi_errmess = "_arpack._arpack.cneupd: failed to create array from the 11st argument `v`";
    capi_v_as_array = ndarray_from_pyobj(  NPY_CFLOAT,1,v_Dims,v_Rank,  capi_v_intent,v_capi,capi_errmess);
    if (capi_v_as_array == NULL) {
        PyObject* capi_err = PyErr_Occurred();
        if (capi_err == NULL) {
            capi_err = _arpack_error;
            PyErr_SetString(capi_err, capi_errmess);
        }
    } else {
        v = (complex_float *)(PyArray_DATA(capi_v_as_array));

    /* Processing variable ldv */
    if (ldv_capi == Py_None) ldv = shape(v,0); else
        f2py_success = int_from_pyobj(&ldv,ldv_capi,"_arpack.cneupd() 4th keyword (ldv) can't be converted to int");
    if (f2py_success) {
    CHECKSCALAR(shape(v,0)==ldv,"shape(v,0)==ldv","4th keyword ldv","cneupd:ldv=%d",ldv) {
    /* Processing variable workd */
    workd_Dims[0]=3 * n;
    capi_workd_intent |= F2PY_INTENT_IN;
    const char * capi_errmess = "_arpack._arpack.cneupd: failed to create array from the 14th argument `workd`";
    capi_workd_as_array = ndarray_from_pyobj(  NPY_CFLOAT,1,workd_Dims,workd_Rank,  capi_workd_intent,workd_capi,capi_errmess);
    if (capi_workd_as_array == NULL) {
        PyObject* capi_err = PyErr_Occurred();
        if (capi_err == NULL) {
            capi_err = _arpack_error;
            PyErr_SetString(capi_err, capi_errmess);
        }
    } else {
        workd = (complex_float *)(PyArray_DATA(capi_workd_as_array));

    /* Processing variable lworkl */
    if (lworkl_capi == Py_None) lworkl = len(workl); else
        f2py_success = int_from_pyobj(&lworkl,lworkl_capi,"_arpack.cneupd() 5th keyword (lworkl) can't be converted to int");
    if (f2py_success) {
    CHECKSCALAR(len(workl)>=lworkl,"len(workl)>=lworkl","5th keyword lworkl","cneupd:lworkl=%d",lworkl) {
    /* Processing variable rwork */
    rwork_Dims[0]=ncv;
    capi_rwork_intent |= F2PY_INTENT_IN;
    const char * capi_errmess = "_arpack._arpack.cneupd: failed to create array from the 16th argument `rwork`";
    capi_rwork_as_array = ndarray_from_pyobj(  NPY_FLOAT,1,rwork_Dims,rwork_Rank,  capi_rwork_intent,rwork_capi,capi_errmess);
    if (capi_rwork_as_array == NULL) {
        PyObject* capi_err = PyErr_Occurred();
        if (capi_err == NULL) {
            capi_err = _arpack_error;
            PyErr_SetString(capi_err, capi_errmess);
        }
    } else {
        rwork = (float *)(PyArray_DATA(capi_rwork_as_array));

    /* Processing variable z */
    z_Dims[0]=n,z_Dims[1]=nev;
    capi_z_intent |= F2PY_INTENT_OUT|F2PY_INTENT_HIDE;
    const char * capi_errmess = "_arpack._arpack.cneupd: failed to create array from the hidden `z`";
    capi_z_as_array = ndarray_from_pyobj(  NPY_CFLOAT,1,z_Dims,z_Rank,  capi_z_intent,Py_None,capi_errmess);
    if (capi_z_as_array == NULL) {
        PyObject* capi_err = PyErr_Occurred();
        if (capi_err == NULL) {
            capi_err = _arpack_error;
            PyErr_SetString(capi_err, capi_errmess);
        }
    } else {
        z = (complex_float *)(PyArray_DATA(capi_z_as_array));

    /* Processing variable ldz */
    if (ldz_capi == Py_None) ldz = shape(z,0); else
        f2py_success = int_from_pyobj(&ldz,ldz_capi,"_arpack.cneupd() 1st keyword (ldz) can't be converted to int");
    if (f2py_success) {
    CHECKSCALAR(shape(z,0)==ldz,"shape(z,0)==ldz","1st keyword ldz","cneupd:ldz=%d",ldz) {
    /* Processing variable workev */
    workev_Dims[0]=3 * ncv;
    capi_workev_intent |= F2PY_INTENT_IN;
    const char * capi_errmess = "_arpack._arpack.cneupd: failed to create array from the 5th argument `workev`";
    capi_workev_as_array = ndarray_from_pyobj(  NPY_CFLOAT,1,workev_Dims,workev_Rank,  capi_workev_intent,workev_capi,capi_errmess);
    if (capi_workev_as_array == NULL) {
        PyObject* capi_err = PyErr_Occurred();
        if (capi_err == NULL) {
            capi_err = _arpack_error;
            PyErr_SetString(capi_err, capi_errmess);
        }
    } else {
        workev = (complex_float *)(PyArray_DATA(capi_workev_as_array));

/*end of frompyobj*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_call_clock();
#endif
/*callfortranroutine*/
            Py_BEGIN_ALLOW_THREADS
                (*f2py_func)(&rvec,&howmny,select,d,z,&ldz,&sigma,workev,&bmat,&n,which,&nev,&tol,resid,&ncv,v,&ldv,iparam,ipntr,workd,workl,&lworkl,rwork,&info,slen(which));
            Py_END_ALLOW_THREADS
if (PyErr_Occurred())
  f2py_success = 0;
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_call_clock();
#endif
/*end of callfortranroutine*/
        if (f2py_success) {
/*pyobjfrom*/
/*end of pyobjfrom*/
        CFUNCSMESS("Building return value.\n");
        capi_buildvalue = Py_BuildValue("NNi",capi_d_as_array,capi_z_as_array,info);
/*closepyobjfrom*/
/*end of closepyobjfrom*/
        } /*if (f2py_success) after callfortranroutine*/
/*cleanupfrompyobj*/
    if((PyObject *)capi_workev_as_array!=workev_capi) {
        Py_XDECREF(capi_workev_as_array); }
    }  /* if (capi_workev_as_array == NULL) ... else of workev */
    /* End of cleaning variable workev */
    } /*CHECKSCALAR(shape(z,0)==ldz)*/
    } /*if (f2py_success) of ldz*/
    /* End of cleaning variable ldz */
    }  /* if (capi_z_as_array == NULL) ... else of z */
    /* End of cleaning variable z */
    if((PyObject *)capi_rwork_as_array!=rwork_capi) {
        Py_XDECREF(capi_rwork_as_array); }
    }  /* if (capi_rwork_as_array == NULL) ... else of rwork */
    /* End of cleaning variable rwork */
    } /*CHECKSCALAR(len(workl)>=lworkl)*/
    } /*if (f2py_success) of lworkl*/
    /* End of cleaning variable lworkl */
    if((PyObject *)capi_workd_as_array!=workd_capi) {
        Py_XDECREF(capi_workd_as_array); }
    }  /* if (capi_workd_as_array == NULL) ... else of workd */
    /* End of cleaning variable workd */
    } /*CHECKSCALAR(shape(v,0)==ldv)*/
    } /*if (f2py_success) of ldv*/
    /* End of cleaning variable ldv */
    if((PyObject *)capi_v_as_array!=v_capi) {
        Py_XDECREF(capi_v_as_array); }
    }  /* if (capi_v_as_array == NULL) ... else of v */
    /* End of cleaning variable v */
    } /*CHECKSCALAR(len(select)>=ncv)*/
    } /*if (f2py_success) of ncv*/
    /* End of cleaning variable ncv */
    } /*CHECKSCALAR(len(resid)>=n)*/
    } /*if (f2py_success) of n*/
    /* End of cleaning variable n */
    }  /* if (capi_d_as_array == NULL) ... else of d */
    /* End of cleaning variable d */
    } /*if (f2py_success) of info*/
    /* End of cleaning variable info */
    if((PyObject *)capi_workl_as_array!=workl_capi) {
        Py_XDECREF(capi_workl_as_array); }
    }  /* if (capi_workl_as_array == NULL) ... else of workl */
    /* End of cleaning variable workl */
    if((PyObject *)capi_ipntr_as_array!=ipntr_capi) {
        Py_XDECREF(capi_ipntr_as_array); }
    }  /* if (capi_ipntr_as_array == NULL) ... else of ipntr */
    /* End of cleaning variable ipntr */
    if((PyObject *)capi_iparam_as_array!=iparam_capi) {
        Py_XDECREF(capi_iparam_as_array); }
    }  /* if (capi_iparam_as_array == NULL) ... else of iparam */
    /* End of cleaning variable iparam */
    if((PyObject *)capi_resid_as_array!=resid_capi) {
        Py_XDECREF(capi_resid_as_array); }
    }  /* if (capi_resid_as_array == NULL) ... else of resid */
    /* End of cleaning variable resid */
    } /*if (f2py_success) of tol*/
    /* End of cleaning variable tol */
    } /*if (f2py_success) of nev*/
    /* End of cleaning variable nev */
        STRINGFREE(which);
    }  /*if (f2py_success) of which*/
    /* End of cleaning variable which */
    } /*if (f2py_success) of bmat*/
    /* End of cleaning variable bmat */
    }  /*if (f2py_success) of sigma frompyobj*/
    /* End of cleaning variable sigma */
    if((PyObject *)capi_select_as_array!=select_capi) {
        Py_XDECREF(capi_select_as_array); }
    }  /* if (capi_select_as_array == NULL) ... else of select */
    /* End of cleaning variable select */
    } /*if (f2py_success) of howmny*/
    /* End of cleaning variable howmny */
    } /*if (f2py_success) of rvec*/
    /* End of cleaning variable rvec */
/*end of cleanupfrompyobj*/
    if (capi_buildvalue == NULL) {
/*routdebugfailure*/
    } else {
/*routdebugleave*/
    }
    CFUNCSMESS("Freeing memory.\n");
/*freemem*/
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_clock();
#endif
    return capi_buildvalue;
}
/******************************* end of cneupd *******************************/

/*********************************** zneupd ***********************************/
static char doc_f2py_rout__arpack_zneupd[] = "\
d,z,info = zneupd(rvec,howmny,select,sigma,workev,bmat,which,nev,tol,resid,v,iparam,ipntr,workd,workl,rwork,info,[ldz,n,ncv,ldv,lworkl])\n\nWrapper for ``zneupd``.\
\n\nParameters\n----------\n"
"rvec : input int\n"
"howmny : input bytes\n"
"select : input rank-1 array('i') with bounds (ncv)\n"
"sigma : input complex\n"
"workev : input rank-1 array('D') with bounds (3 * ncv)\n"
"bmat : input bytes\n"
"which : input string(len=2)\n"
"nev : input int\n"
"tol : input float\n"
"resid : input rank-1 array('D') with bounds (n)\n"
"v : input rank-2 array('D') with bounds (ldv,ncv)\n"
"iparam : input rank-1 array('i') with bounds (11)\n"
"ipntr : input rank-1 array('i') with bounds (14)\n"
"workd : input rank-1 array('D') with bounds (3 * n)\n"
"workl : input rank-1 array('D') with bounds (lworkl)\n"
"rwork : input rank-1 array('d') with bounds (ncv)\n"
"info : input int\n"
"\nOther Parameters\n----------------\n"
"ldz : input int, optional\n    Default: shape(z,0)\n"
"n : input int, optional\n    Default: len(resid)\n"
"ncv : input int, optional\n    Default: len(select)\n"
"ldv : input int, optional\n    Default: shape(v,0)\n"
"lworkl : input int, optional\n    Default: len(workl)\n"
"\nReturns\n-------\n"
"d : rank-1 array('D') with bounds (nev)\n"
"z : rank-2 array('D') with bounds (n,nev)\n"
"info : int";
/* extern void F_FUNC(zneupd,ZNEUPD)(int*,character*,int*,complex_double*,complex_double*,int*,complex_double*,complex_double*,character*,int*,string,int*,double*,complex_double*,int*,complex_double*,int*,int*,int*,complex_double*,complex_double*,int*,double*,int*,size_t); */
static PyObject *f2py_rout__arpack_zneupd(const PyObject *capi_self,
                           PyObject *capi_args,
                           PyObject *capi_keywds,
                           void (*f2py_func)(int*,character*,int*,complex_double*,complex_double*,int*,complex_double*,complex_double*,character*,int*,string,int*,double*,complex_double*,int*,complex_double*,int*,int*,int*,complex_double*,complex_double*,int*,double*,int*,size_t)) {
    PyObject * volatile capi_buildvalue = NULL;
    volatile int f2py_success = 1;
/*decl*/

    int rvec = 0;
    PyObject *rvec_capi = Py_None;
    character howmny = 0;
    PyObject *howmny_capi = Py_None;
    int *select = NULL;
    npy_intp select_Dims[1] = {-1};
    const int select_Rank = 1;
    PyArrayObject *capi_select_as_array = NULL;
    int capi_select_intent = 0;
    PyObject *select_capi = Py_None;
    complex_double *d = NULL;
    npy_intp d_Dims[1] = {-1};
    const int d_Rank = 1;
    PyArrayObject *capi_d_as_array = NULL;
    int capi_d_intent = 0;
    complex_double *z = NULL;
    npy_intp z_Dims[2] = {-1, -1};
    const int z_Rank = 2;
    PyArrayObject *capi_z_as_array = NULL;
    int capi_z_intent = 0;
    int ldz = 0;
    PyObject *ldz_capi = Py_None;
    complex_double sigma;
    PyObject *sigma_capi = Py_None;
    complex_double *workev = NULL;
    npy_intp workev_Dims[1] = {-1};
    const int workev_Rank = 1;
    PyArrayObject *capi_workev_as_array = NULL;
    int capi_workev_intent = 0;
    PyObject *workev_capi = Py_None;
    character bmat = 0;
    PyObject *bmat_capi = Py_None;
    int n = 0;
    PyObject *n_capi = Py_None;
    string which = NULL;
    int slen(which);
    PyObject *which_capi = Py_None;
    int nev = 0;
    PyObject *nev_capi = Py_None;
    double tol = 0;
    PyObject *tol_capi = Py_None;
    complex_double *resid = NULL;
    npy_intp resid_Dims[1] = {-1};
    const int resid_Rank = 1;
    PyArrayObject *capi_resid_as_array = NULL;
    int capi_resid_intent = 0;
    PyObject *resid_capi = Py_None;
    int ncv = 0;
    PyObject *ncv_capi = Py_None;
    complex_double *v = NULL;
    npy_intp v_Dims[2] = {-1, -1};
    const int v_Rank = 2;
    PyArrayObject *capi_v_as_array = NULL;
    int capi_v_intent = 0;
    PyObject *v_capi = Py_None;
    int ldv = 0;
    PyObject *ldv_capi = Py_None;
    int *iparam = NULL;
    npy_intp iparam_Dims[1] = {-1};
    const int iparam_Rank = 1;
    PyArrayObject *capi_iparam_as_array = NULL;
    int capi_iparam_intent = 0;
    PyObject *iparam_capi = Py_None;
    int *ipntr = NULL;
    npy_intp ipntr_Dims[1] = {-1};
    const int ipntr_Rank = 1;
    PyArrayObject *capi_ipntr_as_array = NULL;
    int capi_ipntr_intent = 0;
    PyObject *ipntr_capi = Py_None;
    complex_double *workd = NULL;
    npy_intp workd_Dims[1] = {-1};
    const int workd_Rank = 1;
    PyArrayObject *capi_workd_as_array = NULL;
    int capi_workd_intent = 0;
    PyObject *workd_capi = Py_None;
    complex_double *workl = NULL;
    npy_intp workl_Dims[1] = {-1};
    const int workl_Rank = 1;
    PyArrayObject *capi_workl_as_array = NULL;
    int capi_workl_intent = 0;
    PyObject *workl_capi = Py_None;
    int lworkl = 0;
    PyObject *lworkl_capi = Py_None;
    double *rwork = NULL;
    npy_intp rwork_Dims[1] = {-1};
    const int rwork_Rank = 1;
    PyArrayObject *capi_rwork_as_array = NULL;
    int capi_rwork_intent = 0;
    PyObject *rwork_capi = Py_None;
    int info = 0;
    PyObject *info_capi = Py_None;
    static char *capi_kwlist[] = {"rvec","howmny","select","sigma","workev","bmat","which","nev","tol","resid","v","iparam","ipntr","workd","workl","rwork","info","ldz","n","ncv","ldv","lworkl",NULL};

/*routdebugenter*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_clock();
#endif
    if (!PyArg_ParseTupleAndKeywords(capi_args,capi_keywds,\
        "OOOOOOOOOOOOOOOOO|OOOOO:_arpack.zneupd",\
        capi_kwlist,&rvec_capi,&howmny_capi,&select_capi,&sigma_capi,&workev_capi,&bmat_capi,&which_capi,&nev_capi,&tol_capi,&resid_capi,&v_capi,&iparam_capi,&ipntr_capi,&workd_capi,&workl_capi,&rwork_capi,&info_capi,&ldz_capi,&n_capi,&ncv_capi,&ldv_capi,&lworkl_capi))
        return NULL;
/*frompyobj*/
    /* Processing variable rvec */
        rvec = (int)PyObject_IsTrue(rvec_capi);
        f2py_success = 1;
    if (f2py_success) {
    /* Processing variable howmny */
        f2py_success = character_from_pyobj(&howmny,howmny_capi,"_arpack.zneupd() 2nd argument (howmny) can't be converted to character");
    if (f2py_success) {
    /* Processing variable select */
    ;
    capi_select_intent |= F2PY_INTENT_IN;
    const char * capi_errmess = "_arpack._arpack.zneupd: failed to create array from the 3rd argument `select`";
    capi_select_as_array = ndarray_from_pyobj(  NPY_INT,1,select_Dims,select_Rank,  capi_select_intent,select_capi,capi_errmess);
    if (capi_select_as_array == NULL) {
        PyObject* capi_err = PyErr_Occurred();
        if (capi_err == NULL) {
            capi_err = _arpack_error;
            PyErr_SetString(capi_err, capi_errmess);
        }
    } else {
        select = (int *)(PyArray_DATA(capi_select_as_array));

    /* Processing variable sigma */
        f2py_success = complex_double_from_pyobj(&sigma,sigma_capi,"_arpack.zneupd() 4th argument (sigma) can't be converted to complex_double");
    if (f2py_success) {
    /* Processing variable bmat */
        f2py_success = character_from_pyobj(&bmat,bmat_capi,"_arpack.zneupd() 6th argument (bmat) can't be converted to character");
    if (f2py_success) {
    /* Processing variable which */
    slen(which) = 2;
    f2py_success = string_from_pyobj(&which,&slen(which),"",which_capi,"string_from_pyobj failed in converting 7th argument`which' of _arpack.zneupd to C string");
    if (f2py_success) {
        STRINGPADN(which, slen(which), '\0', ' ');
    /* Processing variable nev */
        f2py_success = int_from_pyobj(&nev,nev_capi,"_arpack.zneupd() 8th argument (nev) can't be converted to int");
    if (f2py_success) {
    /* Processing variable tol */
        f2py_success = double_from_pyobj(&tol,tol_capi,"_arpack.zneupd() 9th argument (tol) can't be converted to double");
    if (f2py_success) {
    /* Processing variable resid */
    ;
    capi_resid_intent |= F2PY_INTENT_IN;
    const char * capi_errmess = "_arpack._arpack.zneupd: failed to create array from the 10th argument `resid`";
    capi_resid_as_array = ndarray_from_pyobj(  NPY_CDOUBLE,1,resid_Dims,resid_Rank,  capi_resid_intent,resid_capi,capi_errmess);
    if (capi_resid_as_array == NULL) {
        PyObject* capi_err = PyErr_Occurred();
        if (capi_err == NULL) {
            capi_err = _arpack_error;
            PyErr_SetString(capi_err, capi_errmess);
        }
    } else {
        resid = (complex_double *)(PyArray_DATA(capi_resid_as_array));

    /* Processing variable iparam */
    iparam_Dims[0]=11;
    capi_iparam_intent |= F2PY_INTENT_IN;
    const char * capi_errmess = "_arpack._arpack.zneupd: failed to create array from the 12nd argument `iparam`";
    capi_iparam_as_array = ndarray_from_pyobj(  NPY_INT,1,iparam_Dims,iparam_Rank,  capi_iparam_intent,iparam_capi,capi_errmess);
    if (capi_iparam_as_array == NULL) {
        PyObject* capi_err = PyErr_Occurred();
        if (capi_err == NULL) {
            capi_err = _arpack_error;
            PyErr_SetString(capi_err, capi_errmess);
        }
    } else {
        iparam = (int *)(PyArray_DATA(capi_iparam_as_array));

    /* Processing variable ipntr */
    ipntr_Dims[0]=14;
    capi_ipntr_intent |= F2PY_INTENT_IN;
    const char * capi_errmess = "_arpack._arpack.zneupd: failed to create array from the 13rd argument `ipntr`";
    capi_ipntr_as_array = ndarray_from_pyobj(  NPY_INT,1,ipntr_Dims,ipntr_Rank,  capi_ipntr_intent,ipntr_capi,capi_errmess);
    if (capi_ipntr_as_array == NULL) {
        PyObject* capi_err = PyErr_Occurred();
        if (capi_err == NULL) {
            capi_err = _arpack_error;
            PyErr_SetString(capi_err, capi_errmess);
        }
    } else {
        ipntr = (int *)(PyArray_DATA(capi_ipntr_as_array));

    /* Processing variable workl */
    ;
    capi_workl_intent |= F2PY_INTENT_IN;
    const char * capi_errmess = "_arpack._arpack.zneupd: failed to create array from the 15th argument `workl`";
    capi_workl_as_array = ndarray_from_pyobj(  NPY_CDOUBLE,1,workl_Dims,workl_Rank,  capi_workl_intent,workl_capi,capi_errmess);
    if (capi_workl_as_array == NULL) {
        PyObject* capi_err = PyErr_Occurred();
        if (capi_err == NULL) {
            capi_err = _arpack_error;
            PyErr_SetString(capi_err, capi_errmess);
        }
    } else {
        workl = (complex_double *)(PyArray_DATA(capi_workl_as_array));

    /* Processing variable info */
        f2py_success = int_from_pyobj(&info,info_capi,"_arpack.zneupd() 17th argument (info) can't be converted to int");
    if (f2py_success) {
    /* Processing variable d */
    d_Dims[0]=nev;
    capi_d_intent |= F2PY_INTENT_OUT|F2PY_INTENT_HIDE;
    const char * capi_errmess = "_arpack._arpack.zneupd: failed to create array from the hidden `d`";
    capi_d_as_array = ndarray_from_pyobj(  NPY_CDOUBLE,1,d_Dims,d_Rank,  capi_d_intent,Py_None,capi_errmess);
    if (capi_d_as_array == NULL) {
        PyObject* capi_err = PyErr_Occurred();
        if (capi_err == NULL) {
            capi_err = _arpack_error;
            PyErr_SetString(capi_err, capi_errmess);
        }
    } else {
        d = (complex_double *)(PyArray_DATA(capi_d_as_array));

    /* Processing variable n */
    if (n_capi == Py_None) n = len(resid); else
        f2py_success = int_from_pyobj(&n,n_capi,"_arpack.zneupd() 2nd keyword (n) can't be converted to int");
    if (f2py_success) {
    CHECKSCALAR(len(resid)>=n,"len(resid)>=n","2nd keyword n","zneupd:n=%d",n) {
    /* Processing variable ncv */
    if (ncv_capi == Py_None) ncv = len(select); else
        f2py_success = int_from_pyobj(&ncv,ncv_capi,"_arpack.zneupd() 3rd keyword (ncv) can't be converted to int");
    if (f2py_success) {
    CHECKSCALAR(len(select)>=ncv,"len(select)>=ncv","3rd keyword ncv","zneupd:ncv=%d",ncv) {
    /* Processing variable v */
    v_Dims[1]=ncv;
    capi_v_intent |= F2PY_INTENT_IN;
    const char * capi_errmess = "_arpack._arpack.zneupd: failed to create array from the 11st argument `v`";
    capi_v_as_array = ndarray_from_pyobj(  NPY_CDOUBLE,1,v_Dims,v_Rank,  capi_v_intent,v_capi,capi_errmess);
    if (capi_v_as_array == NULL) {
        PyObject* capi_err = PyErr_Occurred();
        if (capi_err == NULL) {
            capi_err = _arpack_error;
            PyErr_SetString(capi_err, capi_errmess);
        }
    } else {
        v = (complex_double *)(PyArray_DATA(capi_v_as_array));

    /* Processing variable ldv */
    if (ldv_capi == Py_None) ldv = shape(v,0); else
        f2py_success = int_from_pyobj(&ldv,ldv_capi,"_arpack.zneupd() 4th keyword (ldv) can't be converted to int");
    if (f2py_success) {
    CHECKSCALAR(shape(v,0)==ldv,"shape(v,0)==ldv","4th keyword ldv","zneupd:ldv=%d",ldv) {
    /* Processing variable workd */
    workd_Dims[0]=3 * n;
    capi_workd_intent |= F2PY_INTENT_IN;
    const char * capi_errmess = "_arpack._arpack.zneupd: failed to create array from the 14th argument `workd`";
    capi_workd_as_array = ndarray_from_pyobj(  NPY_CDOUBLE,1,workd_Dims,workd_Rank,  capi_workd_intent,workd_capi,capi_errmess);
    if (capi_workd_as_array == NULL) {
        PyObject* capi_err = PyErr_Occurred();
        if (capi_err == NULL) {
            capi_err = _arpack_error;
            PyErr_SetString(capi_err, capi_errmess);
        }
    } else {
        workd = (complex_double *)(PyArray_DATA(capi_workd_as_array));

    /* Processing variable lworkl */
    if (lworkl_capi == Py_None) lworkl = len(workl); else
        f2py_success = int_from_pyobj(&lworkl,lworkl_capi,"_arpack.zneupd() 5th keyword (lworkl) can't be converted to int");
    if (f2py_success) {
    CHECKSCALAR(len(workl)>=lworkl,"len(workl)>=lworkl","5th keyword lworkl","zneupd:lworkl=%d",lworkl) {
    /* Processing variable rwork */
    rwork_Dims[0]=ncv;
    capi_rwork_intent |= F2PY_INTENT_IN;
    const char * capi_errmess = "_arpack._arpack.zneupd: failed to create array from the 16th argument `rwork`";
    capi_rwork_as_array = ndarray_from_pyobj(  NPY_DOUBLE,1,rwork_Dims,rwork_Rank,  capi_rwork_intent,rwork_capi,capi_errmess);
    if (capi_rwork_as_array == NULL) {
        PyObject* capi_err = PyErr_Occurred();
        if (capi_err == NULL) {
            capi_err = _arpack_error;
            PyErr_SetString(capi_err, capi_errmess);
        }
    } else {
        rwork = (double *)(PyArray_DATA(capi_rwork_as_array));

    /* Processing variable z */
    z_Dims[0]=n,z_Dims[1]=nev;
    capi_z_intent |= F2PY_INTENT_OUT|F2PY_INTENT_HIDE;
    const char * capi_errmess = "_arpack._arpack.zneupd: failed to create array from the hidden `z`";
    capi_z_as_array = ndarray_from_pyobj(  NPY_CDOUBLE,1,z_Dims,z_Rank,  capi_z_intent,Py_None,capi_errmess);
    if (capi_z_as_array == NULL) {
        PyObject* capi_err = PyErr_Occurred();
        if (capi_err == NULL) {
            capi_err = _arpack_error;
            PyErr_SetString(capi_err, capi_errmess);
        }
    } else {
        z = (complex_double *)(PyArray_DATA(capi_z_as_array));

    /* Processing variable ldz */
    if (ldz_capi == Py_None) ldz = shape(z,0); else
        f2py_success = int_from_pyobj(&ldz,ldz_capi,"_arpack.zneupd() 1st keyword (ldz) can't be converted to int");
    if (f2py_success) {
    CHECKSCALAR(shape(z,0)==ldz,"shape(z,0)==ldz","1st keyword ldz","zneupd:ldz=%d",ldz) {
    /* Processing variable workev */
    workev_Dims[0]=3 * ncv;
    capi_workev_intent |= F2PY_INTENT_IN;
    const char * capi_errmess = "_arpack._arpack.zneupd: failed to create array from the 5th argument `workev`";
    capi_workev_as_array = ndarray_from_pyobj(  NPY_CDOUBLE,1,workev_Dims,workev_Rank,  capi_workev_intent,workev_capi,capi_errmess);
    if (capi_workev_as_array == NULL) {
        PyObject* capi_err = PyErr_Occurred();
        if (capi_err == NULL) {
            capi_err = _arpack_error;
            PyErr_SetString(capi_err, capi_errmess);
        }
    } else {
        workev = (complex_double *)(PyArray_DATA(capi_workev_as_array));

/*end of frompyobj*/
#ifdef F2PY_REPORT_ATEXIT
f2py_start_call_clock();
#endif
/*callfortranroutine*/
            Py_BEGIN_ALLOW_THREADS
                (*f2py_func)(&rvec,&howmny,select,d,z,&ldz,&sigma,workev,&bmat,&n,which,&nev,&tol,resid,&ncv,v,&ldv,iparam,ipntr,workd,workl,&lworkl,rwork,&info,slen(which));
            Py_END_ALLOW_THREADS
if (PyErr_Occurred())
  f2py_success = 0;
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_call_clock();
#endif
/*end of callfortranroutine*/
        if (f2py_success) {
/*pyobjfrom*/
/*end of pyobjfrom*/
        CFUNCSMESS("Building return value.\n");
        capi_buildvalue = Py_BuildValue("NNi",capi_d_as_array,capi_z_as_array,info);
/*closepyobjfrom*/
/*end of closepyobjfrom*/
        } /*if (f2py_success) after callfortranroutine*/
/*cleanupfrompyobj*/
    if((PyObject *)capi_workev_as_array!=workev_capi) {
        Py_XDECREF(capi_workev_as_array); }
    }  /* if (capi_workev_as_array == NULL) ... else of workev */
    /* End of cleaning variable workev */
    } /*CHECKSCALAR(shape(z,0)==ldz)*/
    } /*if (f2py_success) of ldz*/
    /* End of cleaning variable ldz */
    }  /* if (capi_z_as_array == NULL) ... else of z */
    /* End of cleaning variable z */
    if((PyObject *)capi_rwork_as_array!=rwork_capi) {
        Py_XDECREF(capi_rwork_as_array); }
    }  /* if (capi_rwork_as_array == NULL) ... else of rwork */
    /* End of cleaning variable rwork */
    } /*CHECKSCALAR(len(workl)>=lworkl)*/
    } /*if (f2py_success) of lworkl*/
    /* End of cleaning variable lworkl */
    if((PyObject *)capi_workd_as_array!=workd_capi) {
        Py_XDECREF(capi_workd_as_array); }
    }  /* if (capi_workd_as_array == NULL) ... else of workd */
    /* End of cleaning variable workd */
    } /*CHECKSCALAR(shape(v,0)==ldv)*/
    } /*if (f2py_success) of ldv*/
    /* End of cleaning variable ldv */
    if((PyObject *)capi_v_as_array!=v_capi) {
        Py_XDECREF(capi_v_as_array); }
    }  /* if (capi_v_as_array == NULL) ... else of v */
    /* End of cleaning variable v */
    } /*CHECKSCALAR(len(select)>=ncv)*/
    } /*if (f2py_success) of ncv*/
    /* End of cleaning variable ncv */
    } /*CHECKSCALAR(len(resid)>=n)*/
    } /*if (f2py_success) of n*/
    /* End of cleaning variable n */
    }  /* if (capi_d_as_array == NULL) ... else of d */
    /* End of cleaning variable d */
    } /*if (f2py_success) of info*/
    /* End of cleaning variable info */
    if((PyObject *)capi_workl_as_array!=workl_capi) {
        Py_XDECREF(capi_workl_as_array); }
    }  /* if (capi_workl_as_array == NULL) ... else of workl */
    /* End of cleaning variable workl */
    if((PyObject *)capi_ipntr_as_array!=ipntr_capi) {
        Py_XDECREF(capi_ipntr_as_array); }
    }  /* if (capi_ipntr_as_array == NULL) ... else of ipntr */
    /* End of cleaning variable ipntr */
    if((PyObject *)capi_iparam_as_array!=iparam_capi) {
        Py_XDECREF(capi_iparam_as_array); }
    }  /* if (capi_iparam_as_array == NULL) ... else of iparam */
    /* End of cleaning variable iparam */
    if((PyObject *)capi_resid_as_array!=resid_capi) {
        Py_XDECREF(capi_resid_as_array); }
    }  /* if (capi_resid_as_array == NULL) ... else of resid */
    /* End of cleaning variable resid */
    } /*if (f2py_success) of tol*/
    /* End of cleaning variable tol */
    } /*if (f2py_success) of nev*/
    /* End of cleaning variable nev */
        STRINGFREE(which);
    }  /*if (f2py_success) of which*/
    /* End of cleaning variable which */
    } /*if (f2py_success) of bmat*/
    /* End of cleaning variable bmat */
    }  /*if (f2py_success) of sigma frompyobj*/
    /* End of cleaning variable sigma */
    if((PyObject *)capi_select_as_array!=select_capi) {
        Py_XDECREF(capi_select_as_array); }
    }  /* if (capi_select_as_array == NULL) ... else of select */
    /* End of cleaning variable select */
    } /*if (f2py_success) of howmny*/
    /* End of cleaning variable howmny */
    } /*if (f2py_success) of rvec*/
    /* End of cleaning variable rvec */
/*end of cleanupfrompyobj*/
    if (capi_buildvalue == NULL) {
/*routdebugfailure*/
    } else {
/*routdebugleave*/
    }
    CFUNCSMESS("Freeing memory.\n");
/*freemem*/
#ifdef F2PY_REPORT_ATEXIT
f2py_stop_clock();
#endif
    return capi_buildvalue;
}
/******************************* end of zneupd *******************************/
/*eof body*/

/******************* See f2py2e/f90mod_rules.py: buildhooks *******************/
/*need_f90modhooks*/

/************** See f2py2e/rules.py: module_rules['modulebody'] **************/

/******************* See f2py2e/common_rules.py: buildhooks *******************/

static FortranDataDef f2py_debug_def[] = {
  {"logfil",0,{{-1}},NPY_INT, 1},
  {"ndigit",0,{{-1}},NPY_INT, 1},
  {"mgetv0",0,{{-1}},NPY_INT, 1},
  {"msaupd",0,{{-1}},NPY_INT, 1},
  {"msaup2",0,{{-1}},NPY_INT, 1},
  {"msaitr",0,{{-1}},NPY_INT, 1},
  {"mseigt",0,{{-1}},NPY_INT, 1},
  {"msapps",0,{{-1}},NPY_INT, 1},
  {"msgets",0,{{-1}},NPY_INT, 1},
  {"mseupd",0,{{-1}},NPY_INT, 1},
  {"mnaupd",0,{{-1}},NPY_INT, 1},
  {"mnaup2",0,{{-1}},NPY_INT, 1},
  {"mnaitr",0,{{-1}},NPY_INT, 1},
  {"mneigh",0,{{-1}},NPY_INT, 1},
  {"mnapps",0,{{-1}},NPY_INT, 1},
  {"mngets",0,{{-1}},NPY_INT, 1},
  {"mneupd",0,{{-1}},NPY_INT, 1},
  {"mcaupd",0,{{-1}},NPY_INT, 1},
  {"mcaup2",0,{{-1}},NPY_INT, 1},
  {"mcaitr",0,{{-1}},NPY_INT, 1},
  {"mceigh",0,{{-1}},NPY_INT, 1},
  {"mcapps",0,{{-1}},NPY_INT, 1},
  {"mcgets",0,{{-1}},NPY_INT, 1},
  {"mceupd",0,{{-1}},NPY_INT, 1},
  {NULL}
};
static void f2py_setup_debug(char *logfil,char *ndigit,char *mgetv0,char *msaupd,char *msaup2,char *msaitr,char *mseigt,char *msapps,char *msgets,char *mseupd,char *mnaupd,char *mnaup2,char *mnaitr,char *mneigh,char *mnapps,char *mngets,char *mneupd,char *mcaupd,char *mcaup2,char *mcaitr,char *mceigh,char *mcapps,char *mcgets,char *mceupd) {
  int i_f2py=0;
  f2py_debug_def[i_f2py++].data = logfil;
  f2py_debug_def[i_f2py++].data = ndigit;
  f2py_debug_def[i_f2py++].data = mgetv0;
  f2py_debug_def[i_f2py++].data = msaupd;
  f2py_debug_def[i_f2py++].data = msaup2;
  f2py_debug_def[i_f2py++].data = msaitr;
  f2py_debug_def[i_f2py++].data = mseigt;
  f2py_debug_def[i_f2py++].data = msapps;
  f2py_debug_def[i_f2py++].data = msgets;
  f2py_debug_def[i_f2py++].data = mseupd;
  f2py_debug_def[i_f2py++].data = mnaupd;
  f2py_debug_def[i_f2py++].data = mnaup2;
  f2py_debug_def[i_f2py++].data = mnaitr;
  f2py_debug_def[i_f2py++].data = mneigh;
  f2py_debug_def[i_f2py++].data = mnapps;
  f2py_debug_def[i_f2py++].data = mngets;
  f2py_debug_def[i_f2py++].data = mneupd;
  f2py_debug_def[i_f2py++].data = mcaupd;
  f2py_debug_def[i_f2py++].data = mcaup2;
  f2py_debug_def[i_f2py++].data = mcaitr;
  f2py_debug_def[i_f2py++].data = mceigh;
  f2py_debug_def[i_f2py++].data = mcapps;
  f2py_debug_def[i_f2py++].data = mcgets;
  f2py_debug_def[i_f2py++].data = mceupd;
}
extern void F_FUNC(f2pyinitdebug,F2PYINITDEBUG)(void(*)(char*,char*,char*,char*,char*,char*,char*,char*,char*,char*,char*,char*,char*,char*,char*,char*,char*,char*,char*,char*,char*,char*,char*,char*));
static void f2py_init_debug(void) {
  F_FUNC(f2pyinitdebug,F2PYINITDEBUG)(f2py_setup_debug);
}

static FortranDataDef f2py_timing_def[] = {
  {"nopx",0,{{-1}},NPY_INT, 1},
  {"nbx",0,{{-1}},NPY_INT, 1},
  {"nrorth",0,{{-1}},NPY_INT, 1},
  {"nitref",0,{{-1}},NPY_INT, 1},
  {"nrstrt",0,{{-1}},NPY_INT, 1},
  {"tsaupd",0,{{-1}},NPY_FLOAT, 1},
  {"tsaup2",0,{{-1}},NPY_FLOAT, 1},
  {"tsaitr",0,{{-1}},NPY_FLOAT, 1},
  {"tseigt",0,{{-1}},NPY_FLOAT, 1},
  {"tsgets",0,{{-1}},NPY_FLOAT, 1},
  {"tsapps",0,{{-1}},NPY_FLOAT, 1},
  {"tsconv",0,{{-1}},NPY_FLOAT, 1},
  {"tnaupd",0,{{-1}},NPY_FLOAT, 1},
  {"tnaup2",0,{{-1}},NPY_FLOAT, 1},
  {"tnaitr",0,{{-1}},NPY_FLOAT, 1},
  {"tneigh",0,{{-1}},NPY_FLOAT, 1},
  {"tngets",0,{{-1}},NPY_FLOAT, 1},
  {"tnapps",0,{{-1}},NPY_FLOAT, 1},
  {"tnconv",0,{{-1}},NPY_FLOAT, 1},
  {"tcaupd",0,{{-1}},NPY_FLOAT, 1},
  {"tcaup2",0,{{-1}},NPY_FLOAT, 1},
  {"tcaitr",0,{{-1}},NPY_FLOAT, 1},
  {"tceigh",0,{{-1}},NPY_FLOAT, 1},
  {"tcgets",0,{{-1}},NPY_FLOAT, 1},
  {"tcapps",0,{{-1}},NPY_FLOAT, 1},
  {"tcconv",0,{{-1}},NPY_FLOAT, 1},
  {"tmvopx",0,{{-1}},NPY_FLOAT, 1},
  {"tmvbx",0,{{-1}},NPY_FLOAT, 1},
  {"tgetv0",0,{{-1}},NPY_FLOAT, 1},
  {"titref",0,{{-1}},NPY_FLOAT, 1},
  {"trvec",0,{{-1}},NPY_FLOAT, 1},
  {NULL}
};
static void f2py_setup_timing(char *nopx,char *nbx,char *nrorth,char *nitref,char *nrstrt,char *tsaupd,char *tsaup2,char *tsaitr,char *tseigt,char *tsgets,char *tsapps,char *tsconv,char *tnaupd,char *tnaup2,char *tnaitr,char *tneigh,char *tngets,char *tnapps,char *tnconv,char *tcaupd,char *tcaup2,char *tcaitr,char *tceigh,char *tcgets,char *tcapps,char *tcconv,char *tmvopx,char *tmvbx,char *tgetv0,char *titref,char *trvec) {
  int i_f2py=0;
  f2py_timing_def[i_f2py++].data = nopx;
  f2py_timing_def[i_f2py++].data = nbx;
  f2py_timing_def[i_f2py++].data = nrorth;
  f2py_timing_def[i_f2py++].data = nitref;
  f2py_timing_def[i_f2py++].data = nrstrt;
  f2py_timing_def[i_f2py++].data = tsaupd;
  f2py_timing_def[i_f2py++].data = tsaup2;
  f2py_timing_def[i_f2py++].data = tsaitr;
  f2py_timing_def[i_f2py++].data = tseigt;
  f2py_timing_def[i_f2py++].data = tsgets;
  f2py_timing_def[i_f2py++].data = tsapps;
  f2py_timing_def[i_f2py++].data = tsconv;
  f2py_timing_def[i_f2py++].data = tnaupd;
  f2py_timing_def[i_f2py++].data = tnaup2;
  f2py_timing_def[i_f2py++].data = tnaitr;
  f2py_timing_def[i_f2py++].data = tneigh;
  f2py_timing_def[i_f2py++].data = tngets;
  f2py_timing_def[i_f2py++].data = tnapps;
  f2py_timing_def[i_f2py++].data = tnconv;
  f2py_timing_def[i_f2py++].data = tcaupd;
  f2py_timing_def[i_f2py++].data = tcaup2;
  f2py_timing_def[i_f2py++].data = tcaitr;
  f2py_timing_def[i_f2py++].data = tceigh;
  f2py_timing_def[i_f2py++].data = tcgets;
  f2py_timing_def[i_f2py++].data = tcapps;
  f2py_timing_def[i_f2py++].data = tcconv;
  f2py_timing_def[i_f2py++].data = tmvopx;
  f2py_timing_def[i_f2py++].data = tmvbx;
  f2py_timing_def[i_f2py++].data = tgetv0;
  f2py_timing_def[i_f2py++].data = titref;
  f2py_timing_def[i_f2py++].data = trvec;
}
extern void F_FUNC(f2pyinittiming,F2PYINITTIMING)(void(*)(char*,char*,char*,char*,char*,char*,char*,char*,char*,char*,char*,char*,char*,char*,char*,char*,char*,char*,char*,char*,char*,char*,char*,char*,char*,char*,char*,char*,char*,char*,char*));
static void f2py_init_timing(void) {
  F_FUNC(f2pyinittiming,F2PYINITTIMING)(f2py_setup_timing);
}

/*need_commonhooks*/

/**************************** See f2py2e/rules.py ****************************/

static FortranDataDef f2py_routine_defs[] = {
    {"ssaupd",-1,{{-1}},0,0,(char *)  F_FUNC(ssaupd,SSAUPD),  (f2py_init_func)f2py_rout__arpack_ssaupd,doc_f2py_rout__arpack_ssaupd},
    {"dsaupd",-1,{{-1}},0,0,(char *)  F_FUNC(dsaupd,DSAUPD),  (f2py_init_func)f2py_rout__arpack_dsaupd,doc_f2py_rout__arpack_dsaupd},
    {"sseupd",-1,{{-1}},0,0,(char *)  F_FUNC(sseupd,SSEUPD),  (f2py_init_func)f2py_rout__arpack_sseupd,doc_f2py_rout__arpack_sseupd},
    {"dseupd",-1,{{-1}},0,0,(char *)  F_FUNC(dseupd,DSEUPD),  (f2py_init_func)f2py_rout__arpack_dseupd,doc_f2py_rout__arpack_dseupd},
    {"snaupd",-1,{{-1}},0,0,(char *)  F_FUNC(snaupd,SNAUPD),  (f2py_init_func)f2py_rout__arpack_snaupd,doc_f2py_rout__arpack_snaupd},
    {"dnaupd",-1,{{-1}},0,0,(char *)  F_FUNC(dnaupd,DNAUPD),  (f2py_init_func)f2py_rout__arpack_dnaupd,doc_f2py_rout__arpack_dnaupd},
    {"sneupd",-1,{{-1}},0,0,(char *)  F_FUNC(sneupd,SNEUPD),  (f2py_init_func)f2py_rout__arpack_sneupd,doc_f2py_rout__arpack_sneupd},
    {"dneupd",-1,{{-1}},0,0,(char *)  F_FUNC(dneupd,DNEUPD),  (f2py_init_func)f2py_rout__arpack_dneupd,doc_f2py_rout__arpack_dneupd},
    {"cnaupd",-1,{{-1}},0,0,(char *)  F_FUNC(cnaupd,CNAUPD),  (f2py_init_func)f2py_rout__arpack_cnaupd,doc_f2py_rout__arpack_cnaupd},
    {"znaupd",-1,{{-1}},0,0,(char *)  F_FUNC(znaupd,ZNAUPD),  (f2py_init_func)f2py_rout__arpack_znaupd,doc_f2py_rout__arpack_znaupd},
    {"cneupd",-1,{{-1}},0,0,(char *)  F_FUNC(cneupd,CNEUPD),  (f2py_init_func)f2py_rout__arpack_cneupd,doc_f2py_rout__arpack_cneupd},
    {"zneupd",-1,{{-1}},0,0,(char *)  F_FUNC(zneupd,ZNEUPD),  (f2py_init_func)f2py_rout__arpack_zneupd,doc_f2py_rout__arpack_zneupd},

/*eof routine_defs*/
    {NULL}
};

static PyMethodDef f2py_module_methods[] = {

    {NULL,NULL}
};

static struct PyModuleDef moduledef = {
    PyModuleDef_HEAD_INIT,
    "_arpack",
    NULL,
    -1,
    f2py_module_methods,
    NULL,
    NULL,
    NULL,
    NULL
};

PyMODINIT_FUNC PyInit__arpack(void) {
    int i;
    PyObject *m,*d, *s, *tmp;
    m = _arpack_module = PyModule_Create(&moduledef);
    Py_SET_TYPE(&PyFortran_Type, &PyType_Type);
    import_array();
    if (PyErr_Occurred())
        {PyErr_SetString(PyExc_ImportError, "can't initialize module _arpack (failed to import numpy)"); return m;}
    d = PyModule_GetDict(m);
    s = PyUnicode_FromString("1.24.3");
    PyDict_SetItemString(d, "__version__", s);
    Py_DECREF(s);
    s = PyUnicode_FromString(
        "This module '_arpack' is auto-generated with f2py (version:1.24.3).\nFunctions:\n"
"    ido,tol,resid,v,iparam,ipntr,info = ssaupd(ido,bmat,which,nev,tol,resid,v,iparam,ipntr,workd,workl,info,n=len(resid),ncv=shape(v,1),ldv=shape(v,0),lworkl=len(workl))\n"
"    ido,tol,resid,v,iparam,ipntr,info = dsaupd(ido,bmat,which,nev,tol,resid,v,iparam,ipntr,workd,workl,info,n=len(resid),ncv=shape(v,1),ldv=shape(v,0),lworkl=len(workl))\n"
"    d,z,info = sseupd(rvec,howmny,select,sigma,bmat,which,nev,tol,resid,v,iparam,ipntr,workd,workl,info,ldz=shape(z,0),n=len(resid),ncv=len(select),ldv=shape(v,0),lworkl=len(workl))\n"
"    d,z,info = dseupd(rvec,howmny,select,sigma,bmat,which,nev,tol,resid,v,iparam,ipntr,workd,workl,info,ldz=shape(z,0),n=len(resid),ncv=len(select),ldv=shape(v,0),lworkl=len(workl))\n"
"    ido,tol,resid,v,iparam,ipntr,info = snaupd(ido,bmat,which,nev,tol,resid,v,iparam,ipntr,workd,workl,info,n=len(resid),ncv=shape(v,1),ldv=shape(v,0),lworkl=len(workl))\n"
"    ido,tol,resid,v,iparam,ipntr,info = dnaupd(ido,bmat,which,nev,tol,resid,v,iparam,ipntr,workd,workl,info,n=len(resid),ncv=shape(v,1),ldv=shape(v,0),lworkl=len(workl))\n"
"    dr,di,z,info = sneupd(rvec,howmny,select,sigmar,sigmai,workev,bmat,which,nev,tol,resid,v,iparam,ipntr,workd,workl,info,ldz=shape(z,0),n=len(resid),ncv=len(select),ldv=shape(v,0),lworkl=len(workl))\n"
"    dr,di,z,info = dneupd(rvec,howmny,select,sigmar,sigmai,workev,bmat,which,nev,tol,resid,v,iparam,ipntr,workd,workl,info,ldz=shape(z,0),n=len(resid),ncv=len(select),ldv=shape(v,0),lworkl=len(workl))\n"
"    ido,tol,resid,v,iparam,ipntr,info = cnaupd(ido,bmat,which,nev,tol,resid,v,iparam,ipntr,workd,workl,rwork,info,n=len(resid),ncv=shape(v,1),ldv=shape(v,0),lworkl=len(workl))\n"
"    ido,tol,resid,v,iparam,ipntr,info = znaupd(ido,bmat,which,nev,tol,resid,v,iparam,ipntr,workd,workl,rwork,info,n=len(resid),ncv=shape(v,1),ldv=shape(v,0),lworkl=len(workl))\n"
"    d,z,info = cneupd(rvec,howmny,select,sigma,workev,bmat,which,nev,tol,resid,v,iparam,ipntr,workd,workl,rwork,info,ldz=shape(z,0),n=len(resid),ncv=len(select),ldv=shape(v,0),lworkl=len(workl))\n"
"    d,z,info = zneupd(rvec,howmny,select,sigma,workev,bmat,which,nev,tol,resid,v,iparam,ipntr,workd,workl,rwork,info,ldz=shape(z,0),n=len(resid),ncv=len(select),ldv=shape(v,0),lworkl=len(workl))\n"
"COMMON blocks:\n""  /debug/ logfil,ndigit,mgetv0,msaupd,msaup2,msaitr,mseigt,msapps,msgets,mseupd,mnaupd,mnaup2,mnaitr,mneigh,mnapps,mngets,mneupd,mcaupd,mcaup2,mcaitr,mceigh,mcapps,mcgets,mceupd\n""  /timing/ nopx,nbx,nrorth,nitref,nrstrt,tsaupd,tsaup2,tsaitr,tseigt,tsgets,tsapps,tsconv,tnaupd,tnaup2,tnaitr,tneigh,tngets,tnapps,tnconv,tcaupd,tcaup2,tcaitr,tceigh,tcgets,tcapps,tcconv,tmvopx,tmvbx,tgetv0,titref,trvec\n"".");
    PyDict_SetItemString(d, "__doc__", s);
    Py_DECREF(s);
    s = PyUnicode_FromString("1.24.3");
    PyDict_SetItemString(d, "__f2py_numpy_version__", s);
    Py_DECREF(s);
    _arpack_error = PyErr_NewException ("_arpack.error", NULL, NULL);
    /*
     * Store the error object inside the dict, so that it could get deallocated.
     * (in practice, this is a module, so it likely will not and cannot.)
     */
    PyDict_SetItemString(d, "__arpack_error", _arpack_error);
    Py_DECREF(_arpack_error);
    for(i=0;f2py_routine_defs[i].name!=NULL;i++) {
        tmp = PyFortranObject_NewAsAttr(&f2py_routine_defs[i]);
        PyDict_SetItemString(d, f2py_routine_defs[i].name, tmp);
        Py_DECREF(tmp);
    }












/*eof initf2pywraphooks*/
/*eof initf90modhooks*/

  tmp = PyFortranObject_New(f2py_debug_def,f2py_init_debug);
  if (tmp == NULL) return NULL;
  if (F2PyDict_SetItemString(d, "debug", tmp) == -1) return NULL;
  Py_DECREF(tmp);
  tmp = PyFortranObject_New(f2py_timing_def,f2py_init_timing);
  if (tmp == NULL) return NULL;
  if (F2PyDict_SetItemString(d, "timing", tmp) == -1) return NULL;
  Py_DECREF(tmp);
/*eof initcommonhooks*/


#ifdef F2PY_REPORT_ATEXIT
    if (! PyErr_Occurred())
        on_exit(f2py_report_on_exit,(void*)"_arpack");
#endif
    return m;
}
#ifdef __cplusplus
}
#endif
